' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will display the to-get-higher-access screens.
        '
        ' The filenames must have the name: filename.xxx where xxx is
        ' the Security Level (from SETUP.INI) that was given
        ' them--not the value, since values range from -32,767 to
        ' +32,767.  Example, level 1 = 5 (actually -32,767 to +5),
        ' level 2 = 10 (6 - 10), level 3 = 20 (11 - 20), etc.
        ' Filename.001, Filename.01, and Filename.1 will all be
        ' considered Level 1--but Filename.010 and Filename.100 are
        ' not (they are 10 and 100, respectively).
        '
        ' If a level doesn't have an access screen, then the highest
        ' available one is used (at a level lower than theirs)--thus
        ' if SL 95 doesn't have an access screen, but SL 90 does, then
        ' SL 90's screen will be displayed (eg. filename.004).
        '
        ' For multiple access screens for a single level, they should
        ' have filenames such that, when sorted, they appear in the
        ' order you want them displayed.
        '
        ' Date last checked for perfection: Sep 2 1992 
        '
SUB Apply

  K0 = 1
  IF FindF(Paths$(10) + Short$(645),FWork(K0)) = 0 THEN EXIT SUB
  DO : K0 = K0 + 1
  LOOP UNTIL FindF(Null$,FWork(K0)) = 0
  CALL FWorkSort(K0 - 1)
  K1 = 0
  K2 = UserSL
  DO
    FOR K = 1 TO K0 - 1
      K3 = 0
      SELECT CASE BitTest(User.Attr,10)
        CASE 0
             IF StrSrch1(FWork(K).FName,46) > 0 AND Val2&(FWork(K).FName) = K2 _
                THEN K3 = 1
        CASE ELSE
             IF RIGHT$(RTRIM$(FWork(K).FName),4) = Short$(838) THEN K3 = 1
      END SELECT
      IF K3 = 1 THEN CALL DispFile(Paths$(3) + FWork(K).FName,C13$) : _
                     CALL Paused : _
                     K1 = -1
    NEXT
    IF NOT K1 THEN K2 = K2 - 1
  LOOP UNTIL K1 OR (K2 = 0)

END SUB
        '
        '* * * *

