' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will search using a binary search.
        '
        ' p   1 to search for a menu line
        '     2 to search for a user name in USERS.IDX returning location and UserIDX.
        '     3 to search for a file name in FILES.IDX returning location and FileIDX.
        '     4 to search for a node address
        '     5 to search for a user name in USERS.IDX returning RecNum in USERS and UserIDX.
        '
        ' p0  numeric field to search for.
        '
        ' p$  alphanumeric field to search for.
        '
        ' Returns the position found, 0 = not found.
        '
        ' Even though we search for LEFT$() with filename and
        ' username--it's LEFT$ for the length of the input.  To search
        ' a 'complete' name, be sure to use the full length (30 chars
        ' for username 12 chars for filename).  That is, if you wish
        ' to search for a single name, that you know is there, pad it
        ' with the appropriate number of spaces.
        '
        ' This returns the position in the Files.IDX file--not the RecNum's
        ' in FILELIST.
        '
        ' 5 does return the record number.
        '
        ' 2 and 5 return information in UserIDX.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
FUNCTION BiSearch% (p,p0,p$)

  K6 = LEN(p$)
  K1 = 0
  K2 = 1
  SELECT CASE p
    CASE 1 : K7 = FileOpen(FileNames$(35))
             K3 = FileLof&(K7,38)
    CASE 2, 5 : K3 = FileLof&(Handle(21),32)
    CASE 3 : K3 = FileLof&(Handle(22),22)
    CASE 4 : K7 = FileOpen(FileNames$(70))
             K3 = FileLof&(K7,34)
  END SELECT
  WHILE K3 >= K2 AND K1 = 0
    K4 = (K2 + K3) \ 2
    SELECT CASE p
      CASE 1
           CALL FileGetRec(K7,K4,38,Menu)
           K5 = Val2&(Menu.Index)
           SELECT CASE p0
             CASE IS < K5 : K3 = K4 - 1
             CASE K5      : K1 = K4
             CASE IS > K5 : K2 = K4 + 1
           END SELECT
      CASE 2, 3, 4, 5
           IF p = 2 OR p = 5 THEN CALL FileGetRec(Handle(21),K4,32,UserIDX) : _
                                  K0$ = LEFT$(UserIDX.UserName,K6)
           IF p = 3 THEN CALL FileGetRec(Handle(22),K4,22,FileIDX) : _
                         K0$ = LEFT$(FileIDX.FName,K6)
           IF p = 4 THEN CALL FileGetRec(K7,K4,34,Node) : _
                         K0$ = MKL$(Node.Addr)
           SELECT CASE p$
             CASE IS < K0$ : K3 = K4 - 1
             CASE K0$      : K1 = K4
             CASE IS > K0$ : K2 = K4 + 1
           END SELECT
    END SELECT
  WEND
  IF p = 1 OR p = 4 THEN CALL FileClose(K7)
  IF p = 5 AND K1 > 0 THEN K1 = UserIDX.RecNum
  BiSearch = K1

END FUNCTION
        '
        '* * * *

