' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will colorize (user 'smart text') a string.
        '
        ' It looks for '}' or ']' at the start of a word, or '[' at
        ' the end of a word (which normally wouldn't appear in text).
        ' It's really quite intractable, and users seem to expect the
        ' '}' combination to work standing alone ('text }5 text to
        ' colorize')--don't know what they expect to 'turn it off'
        ' again.
        '
        ' Since this routine removes characters from the actual text,
        ' and adds ANSI 'invisible' characters, any characters removed
        ' will be substituted with an additional space at the end, to
        ' keep the length the same and make handling easier.  It also
        ' adds spaces for each backspace in the text.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB Colorize (p$)

  FOR K = 1 TO WordsCnt(p$)
    K3$ = WordsGet$(p$,K,K0)
    K1 = LEN(K3$)
    K3 = AscVal(K3$)
    SELECT CASE K3
      CASE 93, 125         '']' or '}'
           K2 = AscVal(MID$(K3$,2,1)) - 48
           K2$ = Short$(141)
           IF K2 > 0 AND K2 < 7 THEN K0$ = Short$(90 + K2) _
                                ELSE K0$ = MID$(p$,K0,2) : _
                                     K2$ = Null$
           SELECT CASE K3
             CASE 93
                  IF MsgColor <> 7 THEN MsgColor = K2
                  p$ = LEFT$(p$,K0 - 1) + K0$ + MID$(p$,K0 + 2) + K2$
             CASE 125
                  IF MsgColor > 0 AND MsgColor < 8 _
                     THEN K1$ = Short$(90 + MsgColor) _
                     ELSE K1$ = Short$(90)
                  IF MID$(p$,K0 + K1 - 1,1) = Short$(389) AND K2$ <> Null$ _
                     THEN K1 = K1 - 1
                  p$ = LEFT$(p$,K0 - 1) + K0$ + MID$(p$,K0 + 2,K1 - 2) + _
                       K1$ + MID$(p$,K0 + K1) + K2$
           END SELECT
           K3$ = WordsGet$(p$,K,K0)
           K1 = LEN(K3$)
    END SELECT
    IF K1 > 1 AND StrSrch(1,K3$,Short$(390)) = 0 _
       AND StrSrch(1,K3$,Short$(391)) = 0 _
       THEN IF MID$(p$,K0 + K1 - 1,1) = Short$(389) _
               THEN SELECT CASE MsgColor : _
                      CASE 7    : K0$ = Short$(97) : _
                      CASE ELSE : MsgColor = 0 : _
                                  K0$ = Short$(90) : _
                    END SELECT : _
                    p$ = LEFT$(p$,K0 + K1 - 2) + K0$ + MID$(p$,K0 + K1) + _
                         C32$
  NEXT
  K = 0
  K1 = StrSrch1(p$,8)
  WHILE K1 > 0
    K = K + 1
    K1 = StrSrch(K1 + 1,p$,C8$)
  WEND
  p$ = p$ + SPACE$(K)

END SUB
        '
        '* * * *

