' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine reads/accesses DIRECTRY files.
        '
        ' Menu.ShouldDo = 'vwxx' which is a MENU.ShouldDo field, with:
        '                  xx = DIRECTRY number
        '                       DIRECTRY.Dxx  data
        '                       DIRECTRY.Txx  titles
        '                       DIRECTRY.Ixx  index
        '
        ' Each data element selected is displayed, then a Paused is
        ' done and a wait for the user to hit [Enter].
        '
        '
        ' Date last checked for perfection: Sep 2 1992 
        '
SUB DirectryView

  K0$ = RIGHT$(Menu.ShouldDo,2)
  K1 = FileOpen(FileNames$(44) + K0$)             'DIRECTRY.Dxx
  K2 = FileOpen(FileNames$(45) + K0$)             'DIRECTRY.Txx
  K3 = FileOpen(FileNames$(46) + K0$)             'DIRECTRY.Ixx
  DO
    '
    ' Get data to display.  Show titles.
    '
    K0& = 0
    TT$ = FileGetLine$(K2,K0&)                    'Top line of screen.
    CALL SendTT
    TT$ = FileGetLine$(K2,K0&)                    'Question line.
    K = 1
    DO
      SWork$(K) = FileGetLine$(K2,K0&)            'Title lines.
      K = K + 1
    LOOP UNTIL K0& = -1
    SWork$(K) = Null$
    CALL MenuSystemTT
    IF TGot = 0 THEN EXIT DO
    K = TGot
    '
    ' Display a data item.
    '
    K0& = 0
    K$ = FileGetLine$(K1,K0&)                      'Data type.
    TT$ = FileGetLine$(K1,K0&)                     'Header line.
    IF TT$ = Short$(411) THEN TT = 10107 : _
                              CALL SendTT
    SELECT CASE LEFT$(K$,4)
      CASE Short$(407)
           CALL FileGetRec(K3,K,4,K0&)             'Get location of line.
           TT$ = FileGetLine$(K1,K0&) + C1310$     'Get the line. 
           CALL SendTT
      CASE Short$(408)
           CALL FileGetRec(K3,K,4,K0&)            'Get location of block.
           TT$ = FileGetLine$(K1,K0&)             'First line of block.
           DO
             TT$ = Short$(413) + TT$ + C1310$
             CALL SendTT
             TT$ = FileGetLine$(K1,K0&)           'More lines of block.
           LOOP UNTIL K0& = -1 OR TT$ = Short$(503) OR NoCarrier OR TGot > 0
      CASE Short$(410)
           CALL FileGetRec(K3,K * 2 - 1,4,K0&)    'Get location of text.
           CALL FileGetRec(K3,K * 2,4,K&)         'Get size of text.
           TT$ = SPACE$(K&)
           CALL FileGetSLoc(K1,K0&,TT$)           'The text itself.
           TT$ = Short$(414) + TT$
           CALL SendTT
    END SELECT
    CALL Paused
  LOOP UNTIL NoCarrier
  CALL FileClose(K1)
  CALL FileClose(K2)
  CALL FileClose(K3)

END SUB
        '
        '* * * *

