' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine generates the description line for a file.
        '
        ' p   array location in FWork() for the file.
        '     a negative value means to also display extended info
        '     line.
        '
        ' p$  valid stop and exit keys.
        '
        ' Relies on FileList for it's information.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB DispDescLine (p,p$)

  K3$ = p$
  IF p < 0 THEN p = - p : _
                K3 = 1 _
           ELSE K3 = 0
  K0$ = FileList.FDesc
  MsgColor = 7
  CALL Colorize(K0$)
  K0$ = RTRIM$(K0$)
  IF LEN(K0$) = 0 THEN K0$ = Short$(661)
  K0 = -1
  IF BitTest(FileList.Attr,8) _
     THEN K0$ = BlockText2(68) + Form$(20,User.UserName) + Short$(761) : _
          K0 = 0
  IF BitTest(FileList.Attr,7) THEN K0$ = BlockText2(336) : _
                                   K0 = 0
  IF NOT BitTest(FileBases(FileIndex).Attr,3) THEN K0 = 0
  IF NOT BitTest(User.Toggles,7) THEN K0 = 0
  IF NOT BitTest(FileBases(FileIndex).Attr,1) _
     THEN K1 = 51 _
     ELSE IF FileList.LDCount = 10 THEN K1 = 45 _
                                   ELSE K1 = 42
  K0$ = StripLeft$(K0$,K1)
  SELECT CASE K0
    CASE -1
         IF K1 - LEN(K0$) < 5 THEN K0$ = Form$(K1 * 100 + 1,K0$) _
                              ELSE IF FileList.LDCount <> 10 _
                                      THEN K0$ = Form1$(K1,K0$)
         SELECT CASE FileList.LDCount
           CASE 0        : K$ = Short$(189)
           CASE 1        : K$ = Short$(202)
           CASE 2 to 9   : K$ = Short$(153) + AscChr$(FileList.LDCount + 48)
           CASE 10       : K$ = RTRIM$(K0$)
                           K0$ = Null$
           CASE 11 to 19 : K$ = Short$(217) + AscChr$(68 - FileList.LDCount)
           CASE 20 to 28 : K$ = Short$(220) + AscChr$(FileList.LDCount + 29)
           CASE 100 to 199 : K$ = Short$(237) + LTRIM$(STR$(FileList.LDCount - 100))
         END SELECT
         K0$ = K0$ + K$
  END SELECT
  IF BitTest(FileBases(FileIndex).Attr,1) _
     THEN K0$ = Short$(762) + FWork(p).FDate + Short$(662) + K0$ _
     ELSE K0$ = Short$(97) + K0$
  K$ = LTRIM$(STR$(FWork(p).FSize))
  K0 = LEN(K$)
  SELECT CASE K0
    CASE 7
         K$ = LEFT$(K$,1) + Short$(242) + MID$(K$,2,3) + Short$(242) + _
              RIGHT$(K$,3)
         K0 = 9
    CASE 4 TO 6
         K$ = LEFT$(K$,K0 - 3) + Short$(242) + RIGHT$(K$,3)
         K0 = K0 + 1
  END SELECT
  IF BitTest(FileList.Attr,2) _
     OR (BitTest(FileList.Attr,9) AND ConnectCPS >= 800) _
     THEN K1$ = Short$(763) _
     ELSE IF BitTest(FileList.Attr,6) THEN K1$ = Short$(764) _
                                      ELSE K1$ = C32$
  IF FileList.Password <> 0 _
     THEN K2$ = Short$(765) _
     ELSE IF FileList.Group <> 0 THEN K2$ = Short$(766) _
                                 ELSE K2$ = C32$
  K$ = Short$(78) + SPACE$(11 - K0) + K$ + K1$ + K2$
  IF FileList.HiFilePtr > FileBases(FileIndex).HiFilePtr _
     THEN FileBases(FileIndex).HiFilePtr = FileList.HiFilePtr : _
          K2 = FileOpen(FileNames$(20)) : _
          CALL FilePutRec(K2,FileIndex,184,FileBases(FileIndex)) : _
          CALL FileClose(K2)
  IF FileList.HiFilePtr > User.HiFilePtr _
     THEN TT$ = Short$(96) : _
          User.HighestPtr = FileList.HiFilePtr _
     ELSE TT$ = Short$(91)
  TT$ = K3$ + TT$ + ExpandFileName$(FWork(p).FName) + K$ + K0$ + C1310$
  SELECT CASE K3
    CASE 1
         '
         ' Show additional information lines.
         '
         TT$ = TT$ + Short$(768) + LTRIM$(IntToDate3$(FileList.DateULed)) + _
               Short$(769) + NCR$(FileList.UserName) + Short$(770) + _
               Form$(466,STR$(FileList.Downloaded)) + _
               Short$(771) + LTRIM$(IntToDate3$(FileList.LastDLed)) + _
               C1310$
  END SELECT
  IF NOT BitTest(FileList.Attr,6) _
     THEN CALL SendTT _
     ELSE IF UserSL = LevelsSize OR User.UserName = FileBases(FileIndex).FileOp _
             THEN CALL SendTT

END SUB
        '
        '* * * *

