' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will send/display a file.
        '
        ' p$   pathname
        '
        ' p0$  list of valid stop & exit commands
        '
        ' TGot$ = NULL if completely outputed, otherwise = the valid key
        ' hit.
        '
        ' TGot = -1 if completely outputed, otherwise = the valid key
        ' hit.  Unlike TGet which returns a -1 when you hit CR, this
        ' will return 13.
        '
        ' Don't use for files larger than, say, 8192 bytes--since the
        ' whole thing is read in as a single string.
        '
        ' I break the read-in string up by CHR$(27)'s (first letter of
        ' ANSI commands) to provide better control when exit early (so
        ' a bunch of garbage characters aren't displayed).  However,
        ' with the HST's 128 byte buffer, I'm not so sure it matters.
        ' But it seems to work ok, so I've kept it--even though you
        ' could blast the whole read-in string out at once with both
        ' ANSI and the block output routine.
        '
        ' Date last checked for perfection: Sep 18 1992
        '
SUB DispFile (p$,p0$)

  TGot$ = Null$
  TGot = -1
  K2$ = p$
  K = FindF(K2$,FFile)
  K3 = StrSrchR(K2$,92)
  IF K = 0 THEN K2$ = Paths$(10) + MID$(K2$,K3 + 1) : _
                K = FindF(K2$,FFile) : _
                K3 = StrSrchR(K2$,92)
  IF NoCarrier OR K = 0 OR FFile.FSize = 0 THEN EXIT SUB
  K = 0
  DO : K = K + 1
  LOOP UNTIL FindF(Null$,FFile) = 0          'Number of file's found (1 to n).
  FOR K0 = 1 TO GetRndNum(K)
    IF K0 = 1 THEN K1 = FindF(K2$,FFile) _
              ELSE K1 = FindF(Null$,FFile)
  NEXT
  K2$ = LEFT$(K2$,K3) + FFile.FName
  '
  ' Read in the whole file at once.
  '
  K1$ = SPACE$(FFile.FSize)
  K2 = FileOpen(K2$)
  CALL FileGetSLoc(K2,0&,K1$)
  CALL FileClose(K2)
  IF (BitTest(Toggles(2),8) OR BitTest(User.Attr,6)) AND NOT BitTest(Toggles(2),9) _
     THEN IF DriveSpc&(FileNames$(51)) > Settings.MinSpace _
             THEN CALL FilePutSEnd(Handle(1),Short$(741) + RTRIM$(K2$) + Short$(741))
  SELECT CASE LEFT$(FFile.FName,2)
    CASE Short$(924)  'MB
         K2 = StrSrch1(K1$,126)
         WHILE K2 > 0
           IF BaseIndex < 0 OR BaseIndex > BasesSize THEN BaseIndex = 32767
           K2$ = Null$
           K& = 0
           K3 = -1
           SELECT CASE Val2&(MID$(K1$,K2,3))
             CASE 1 : IF BaseIndex = 32767 THEN K2$ = BlockText2(647) _
                                           ELSE K2$ = MsgBases(BaseIndex).Title
             CASE 2 : IF BaseIndex = 32767 THEN K2$ = BlockText2(647) _
                                           ELSE K2$ = MsgBases(BaseIndex).MsgOp
             CASE 3 : IF BaseIndex = 32767 THEN K& = 0 _
                                           ELSE K& = MsgBases(BaseIndex).PostSL
             CASE 4 : IF BaseIndex = 32767 THEN K& = 0 _
                                           ELSE K& = MsgBases(BaseIndex).ReadSL
             CASE 5 : IF BaseIndex = 32767 THEN K& = 0 _
                                           ELSE K& = MsgBases(BaseIndex).ScanSL
             CASE ELSE : K3 = 0
           END SELECT
           IF LEN(K2$) = 0 THEN K2$ = Commas$(K&)
           IF K3 THEN K2$ = LTRIM$(RTRIM$(K2$)) : _
                      K1$ = LEFT$(K1$,K2 - 1) + K2$ + MID$(K1$,K2 + 3)
           K2 = StrSrch(K2 + 3,K1$,Short$(743))
         WEND
    CASE Short$(722)
         K2 = StrSrch1(K1$,126)
         WHILE K2 > 0
           IF FileIndex < 1 OR FileIndex > DirsSize THEN FileIndex = 32767
           K2$ = Null$
           K& = 0
           K3 = -1
           SELECT CASE Val2&(MID$(K1$,K2,3))
             CASE 1 : IF FileIndex = 32767 THEN K2$ = BlockText2(647) _
                                           ELSE K2$ = FileBases(FileIndex).Title
             CASE 2 : IF FileIndex = 32767 THEN K2$ = BlockText2(647) _
                                           ELSE K2$ = FileBases(FileIndex).FileOp
             CASE 3 : IF FileIndex = 32767 THEN K& = 0 _
                                           ELSE K& = FileBases(FileIndex).ULSL
             CASE 4 : IF FileIndex = 32767 THEN K& = 0 _
                                           ELSE K& = FileBases(FileIndex).DLSL
             CASE 5 : IF FileIndex = 32767 THEN K& = 0 _
                                           ELSE K& = FileBases(FileIndex).ScanSL
             CASE ELSE : K3 = 0
           END SELECT
           IF LEN(K2$) = 0 THEN K2$ = Commas$(K&)
           IF K3 THEN K2$ = LTRIM$(RTRIM$(K2$)) : _
                      K1$ = LEFT$(K1$,K2 - 1) + K2$ + MID$(K1$,K2 + 3)
           K2 = StrSrch(K2 + 3,K1$,Short$(743))
         WEND
  END SELECT
  SELECT CASE LEFT$(FFile.FName,5)
    CASE Short$(925)                 'STATS   --for when we make stats format based
         K2 = StrSrch1(K1$,126)
         WHILE K2 > 0
           K2$ = Null$
           K& = 0
           K3 = -1
'           SELECT CASE Val2&(MID$(K1$,K2,3))
'             CASE 1 : K2$ = MsgBases(BaseIndex).Title
'             CASE 2 : K2$ = MsgBases(BaseIndex).MsgOp
'             CASE 3 : K& = MsgBases(BaseIndex).PostSL
'             CASE 4 : K& = MsgBases(BaseIndex).ReadSL
'             CASE 5 : K& = MsgBases(BaseIndex).ScanSL
'           END SELECT
           IF LEN(K2$) = 0 THEN K2$ = Commas$(K&)
           IF K3 THEN K2$ = LTRIM$(RTRIM$(K2$)) : _
                      K1$ = LEFT$(K1$,K2 - 1) + K2$ + MID$(K1$,K2 + 3)
           K2 = StrSrch(K2 + 3,K1$,Short$(743))
         WEND
  END SELECT
  SELECT CASE LEFT$(FFile.FName,7)
    CASE Short$(742)
         K2 = StrSrch1(K1$,126)
         WHILE K2 > 0
           K2$ = Null$
           K& = 0
           K3 = -1
           SELECT CASE Val2&(MID$(K1$,K2,3))
             CASE 1  : K2$ = NCR$(AnyUser.UserName)
             CASE 2  : K2$ = AnyUser.Password
             CASE 3  : K2$ = NCR$(AnyUser.CityState)
             CASE 4  : K2$ = IntToPhone$(AnyUser.HomePhone)
                       IF LEN(K2$) = 0 THEN K2$ = C32$
             CASE 5  : K2$ = IntToPhone$(AnyUser.BBSPhone)
                       IF LEN(K2$) = 0 THEN K2$ = C32$
             CASE 6  : K2$ = IntToDate3$(AnyUser.BirthDate)
             CASE 7  : K& = AnyUser.SecLevel
             CASE 8  : K2$ = IntToDate3$(AnyUser.FirstCall)
             CASE 9  : K2$ = AnyUser.Protocol
             CASE 10 : K2$ = IntToDate3$(AnyUser.SubsStart)
             CASE 11 : K2$ = IntToDate3$(AnyUser.SubsEnd)
             CASE 12 : K2$ = AnyUser.SubsType
             CASE 13 : K& = AnyUser.Monies
             CASE 14 : K& = AnyUser.TotalMonies
             CASE 15 : K2$ = IntToDate3$(AnyUser.LastDateOn)
             CASE 16 : K& = AscVal(AnyUser.PswdChange)
             CASE 17 : K2$ = IntToDate3$(AnyUser.AlterDate)
             CASE 19 : K& = AnyUser.PagedSysop
             CASE 20 : K& = AnyUser.Logons
             CASE 21 : K& = AnyUser.MinCredits
             CASE 22 : K& = AscVal(AnyUser.Attempts)
             CASE 23 : K& = AnyUser.MsgsPosted
             CASE 24 : K& = AnyUser.EMsgsPosted
             CASE 25 : K& = AnyUser.FMsgsPosted
             CASE 26 : K& = AnyUser.NetMailSent
             CASE 27 : K& = AnyUser.NetMailRcvd
             CASE 28 : K& = AnyUser.Elapsed
             CASE 29 : K& = AnyUser.Dnlds
             CASE 30 : K& = AnyUser.DLBytes
             CASE 31 : K& = AnyUser.MinsDLing
             CASE 32 : K& = AnyUser.BadDLs
             CASE 33 : K& = AnyUser.Uplds
             CASE 34 : K& = AnyUser.ULBytes
             CASE 35 : K& = AnyUser.MinsULing
             CASE 36 : K& = AnyUser.BadULs
             CASE 37 : K& = AnyUser.Doors
             CASE 38 : K2$ = AnyUser.SysopNote
             CASE 39 : K2$ = AnyUser.UserNote
             CASE 40 : K& = AnyUser.MsgsPosted + AnyUser.EMsgsPosted + _
                            AnyUser.FMsgsPosted + AnyUser.NetMailSent
             CASE 41 : K& = levels(MappedSL(AnyUser.SecLevel)).MinsPerDay
             CASE 42 : K& = levels(MappedSL(AnyUser.SecLevel)).MinsPerDay + _
                            AnyUser.MinCredits - AnyUser.Elapsed
             CASE 43 : K& = ElapsedTime(LogonTime$,K4)
             CASE 44 : K4 = MappedSL(AnyUser.SecLevel)
                       IF AnyUser.SecLevel <> Levels(K4).SecLevel _
                          THEN K& = Levels(K4).SecLevel _
                          ELSE K& = AnyUser.SecLevel
             CASE 45 : K2$ = Connect$
             CASE ELSE : K3 = 0
           END SELECT
           IF LEN(K2$) = 0 THEN K2$ = Commas$(K&)
           IF K3 THEN K2$ = LTRIM$(RTRIM$(K2$)) : _
                      K1$ = LEFT$(K1$,K2 - 1) + K2$ + MID$(K1$,K2 + 3)
           K2 = StrSrch(K2 + 3,K1$,Short$(743))
         WEND
  END SELECT
  FFile.FSize = LEN(K1$)
  K = 1
  WHILE (K < FFile.FSize) AND (NOT NoCarrier) AND (TGot < 1)
    K0 = StrSrch(K + 1,K1$,C27$)
    IF K0 = 0 THEN K0 = FFile.FSize + 1
    K2$ = MID$(K1$,K,K0 - K)
    K = K0
    K3$ = Null$
    kz1 = 1
    IF AscVal(K2$) = 27 THEN K4$ = C27$ : _
                             K4 = 1 : _
                             CALL AnsiProcessor(K2$,K4$,K3$,K4) : _
                             kz1 = LEN(K3$) + 1 : _
                             IF kz1 > 1 THEN K3$ = K3$ + MID$(K2$,K4 + 1)

   SELECT CASE BitTest(User.Toggles,15)
      CASE -1
           '
           ' This can fail when an ANSI code is followed by 3 codes of the same
           ' letter.  Example ']0;1;32mmmm'.  But I'll worry about that later.
           '
           IF LEN(K3$) = 0 THEN K3$ = K2$
           WHILE Kz1 + 3 <= LEN(K3$)
             kz$ = MID$(K3$,Kz1,1)
             IF MID$(K3$,Kz1 + 1,3) = Kz$ + Kz$ + Kz$ _
                THEN kz2 = kz1 : _
                     kz1 = kz1 + 3 : _
                     DO : Kz1 = Kz1 + 1 : _
                     LOOP UNTIL MID$(K3$,Kz1,1) <> Kz$ : _
                     K3$ = LEFT$(K3$,kz2 - 1) + AscChr$(25) + Kz$ + _
                           AscChr$(Kz1 - Kz2) + MID$(K3$,kz1) : _
                     Kz1 = Kz2 + 2
             Kz1 = Kz1 + 1
           WEND
    END SELECT
    IF LEN(K3$) > 0 THEN IF BitTest(Toggles(2),9) _
                            THEN CALL CommOut(K3$) _
                            ELSE CALL BlockOut(CommPort,K3$) _
                    ELSE IF BitTest(Toggles(2),9) _
                            THEN CALL CommOut(K2$) _
                            ELSE CALL BlockOut(CommPort,K2$)
    IF NOT BitTest(Toggles(2),2) THEN CALL Ansi(K2$)             'To the screen.
    DO
      K0 = CommIn(0)
      SELECT CASE K0
        CASE IS >= 0
             IF K0 > 96 THEN CALL BitClear(K0,6)  'Uppercase it.
             SELECT CASE StrSrch1(p0$,K0)
               CASE IS > 0
                    TGot$ = AscChr$(K0)
                    TGot = K0
                    CALL PurgeComIO(CommPort)
                    TT$ = Short$(68)
                    CALL CommOut(TT$)
                    CALL AnsiTT
                    CALL DispCRLF
                    CALL DispCRLF
             END SELECT
      END SELECT
    LOOP UNTIL BitTest(FosIntAX(CommPort,&H300),15) OR NoCarrier OR (TGot > 0) _
               OR (CommPort = 0)
  WEND
  IF NoCarrier THEN TGot$ = Null$ : _
                    TGot = -1

END SUB
        '
        '* * * *

