' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will 'display' a message--either to comm or a
        ' file.
        '
        ' p&  location in MESSAGES to get message from.
        '
        ' p    0 to NOT read in the message from MESSAGES (just use
        '        Message. and MessageBody$).
        '     -1 to output message to the DEL_MSGS.TXT file in ASCII
        '        format.
        '     -2 to output message to the POMessages file in ASCII
        '        format.
        '     -3 to output message to the MESSAGES.TXT file in ASCII
        '        format.
        '      3 to output message to the MESSAGES.TXT file in ANSI
        '        format.
        '      2 this is a login mail read--ignore 'continuous
        '        messages' bit.
        '      any other +'ve integer means output to screen in ANSI
        '      format.
        '
        ' p$  contains the stop & exit keys allowed.  Except when
        '     p = -2, then it contains the pathname to use.
        '
        ' Date last checked for perfection: Sep 18 1992
        '
SUB DispMessage (p&,p,p$)

  IF p = -1 THEN K4 = FileOpen(FileNames$(41))
  IF p = -2 THEN K4 = FileOpen(p$) : _
                 p$ = Null$
  IF p = -3 OR p = 3 THEN K4 = FileOpen(FileNames$(80))
  IF p <> 0 THEN CALL FileGetLoc(Handle(3),p& - 1,128,Message) : _
                 MessageBody$ = Null$
  '
  ' Title of the area.  User decides whether we do a clear screen first.
  '
  z$ = RTRIM$(MsgBases(Message.MsgBase).Title)
  IF p = 3 THEN z$ = Short$(91) + z$
  IF p >= 0 AND p <> 3 THEN IF BitTest(User.Toggles,4) AND p <> 2 _
                               THEN z$ = C1310$ + C1310$ + C1310$ + Short$(91) + z$ _
                               ELSE z$ = Short$(926) + z$ 
  z$ = z$ + C1310$
  '
  ' Message number, privacy status, sent/received status.
  '
  IF p >= 0 THEN z$ = z$ + Short$(98)
  z$ = z$ + GetLine$(102) + STR$(Message.MsgNum)
  IF BitTest(MsgBases(Message.MsgBase).SubType,2) _
     THEN z$ = z$ + GetLine$(103)
  z$ = z$ + GetLine$(104) + IntToDate3$(Message.MsgDateSent) + Short$(580)
  IF Message.MsgDateRcvd = 0 AND Message.MsgTo = User.UserName AND p <> 0 _
     THEN Message.MsgDateRcvd = LogonDate : _
          Message.MsgTimeRcvd = TimeToInt(TIME$) : _
          CALL FilePutLoc(Handle(3),p& - 1,128,Message)
  IF RTRIM$(Message.MsgTo) <> Short$(652) _
     THEN IF Message.MsgDateRcvd = 0 _
             THEN z$ = z$ + GetLine$(105) _
             ELSE z$ = z$ + GetLine$(106) + _
                       IntToDate3$(Message.MsgDateRcvd) + Short$(580)
  z$ = z$ + C1310$
  '
  ' NET attributes.  Looks really ugly for ASCII displays of the message--and
  ' unnecessary, so it's not done for those.
  '
  TT$ = SPACE$(13)
  IF BitTest(Message.NetAttr,4) THEN TT$ = TT$ + GetLine$(220)
  TT$ = RTRIM$(TT$)
  IF p >= 0 AND LEN(TT$) > 0 AND BitTest(MsgBases(Message.MsgBase).SubType,7) _
     THEN z$ = z$ + Short$(98) + TT$ + C1310$
  z$ = z$ + C1310$
  '
  ' From whom.
  '
  IF p >= 0 THEN z$ = z$ + GetLine$(110) _
            ELSE z$ = z$ + GetLine$(109)
  K1$ = NCR$(Message.MsgFrom)
  z$ = z$ + K1$
  K2 = 0
  IF BitTest(MsgBases(Message.MsgBase).SubType,3) _
     AND NOT BitTest(MsgBases(Message.MsgBase).SubType,9) _
     THEN K2 = 1
  IF K2 = 1 AND Message.SourceAddr <> 0 AND Message.SourceAddr <> Settings.Addr _
     THEN K2 = 2
  IF K2 > 0 AND Message.DestAddr <> 0 AND Message.DestAddr <> Settings.Addr _
     THEN K2 = 4
  IF BitTest(K2,2) _
     THEN K0$ = AddrToInt$(Message.SourceAddr,K5,K6,K7) + Short$(580) : _
          IF p < 0 THEN z$ = z$ + GetLine$(326) + K0$
  SELECT CASE p
    CASE IS >= 0
         IF K1$ <> Short$(402) AND K1$ <> C2$ AND K1$ <> Short$(752) _
            AND NOT BitTest(K2,2) _
            THEN IF BiSearch(2,0,Message.MsgFrom) = 0 _
                    THEN z$ = z$ + GetLine$(198)
         IF BitTest(K2,2) THEN z$ = z$ + GetLine$(442) + K0$ + Short$(927)
  END SELECT
  IF BitTest(Message.Attr,8) _
     THEN K0$ = GetLine$(107) + NCR$(Settings.Sysop) + Short$(580) : _
          IF p >= 0 THEN z$ = z$ + Short$(98) + K0$ + Short$(72) _
                    ELSE z$ = z$ + K0$
  IF BitTest(Message.Attr,9) _
     THEN K0$ = GetLine$(107) + C2$ + Short$(580) : _
          IF p >= 0 THEN z$ = z$ + Short$(98) + K0$ + Short$(72) _
                    ELSE z$ = z$ + K0$
  z$ = z$ + C1310$
  '
  ' To whom.
  '
  IF p < 0 THEN z$ = z$ + GetLine$(114) _
           ELSE z$ = z$ + GetLine$(115)
  K1$ = NCR$(Message.MsgTo)
  IF K1$ = Short$(402) THEN z$ = z$ + GetLine$(111) _
                       ELSE z$ = z$ + K1$
  K0$ = Null$
  IF BitTest(K2,3) _
     THEN K0$ = AddrToInt$(Message.DestAddr,K5,K6,K7) + Short$(580) : _
          IF p < 0 THEN z$ = z$ + GetLine$(326) + K0$
  SELECT CASE p
    CASE IS >= 0
         IF K1$ <> Short$(402) AND K1$ <> C2$ AND NOT BitTest(K2,3) _
            THEN IF BiSearch(2,0,Message.MsgTo) = 0 _
                    THEN z$ = z$ + GetLine$(198)
         IF BitTest(K2,3) THEN z$ = z$ + GetLine$(442) + K0$ + Short$(927)
  END SELECT
  IF BitTest(Message.Attr,10) _
     THEN K0$ = GetLine$(107) + C2$ + Short$(580) : _
          IF p >= 0 THEN z$ = z$ + Short$(98) + K0$ + Short$(72) _
                    ELSE z$ = z$ + K0$
  IF BitTest(Message.Attr,11) _
     THEN K0$ = GetLine$(107) + NCR$(Settings.Sysop) + Short$(580) : _
          IF p >= 0 THEN z$ = z$ + Short$(98) + K0$ + Short$(72) _
                    ELSE z$ = z$ + K0$
  z$ = z$ + C1310$
  '
  ' Subject line.
  '
  IF p >= 0 THEN z$ = z$ + GetLine$(176)
  TT$ = UnSq$(RTRIM$(Message.MsgSubject))
  IF BitTest(Message.Attr,3) THEN K0$ = GetLine$(116) : _
                                  K1$ = Short$(65) + K0$ _
                             ELSE K0$ = Null$ : _
                                  K1$ = Null$
  IF p < 0 THEN z$ = z$ + GetLine$(117) + TT$ + K0$ + C1310$ _
           ELSE z$ = z$ + TT$ + K1$ + Short$(90) + C1310$
  '
  ' Load the message and fix it up, if needed.
  '
  SELECT CASE p
    CASE IS <> 0
         MessageBody$ = SPACE$(Message.NumOfBytes)
         CALL FileGetSLoc(Handle(3),p& + 127,MessageBody$)
         IF BitTest(Message.Attr,2) THEN MessageBody$ = UnSq$(MessageBody$)
         IF (NOT BitTest(MsgBases(Message.MsgBase).SubType,7) _
            AND p > 0) OR p = -3 OR p = 3 THEN CALL StripExtras
  END SELECT
  IF p >= 0 THEN CALL ExpandFileMsgs
  WHILE RIGHT$(MessageBody$,3) = C13$ + C13$ + C13$
    MessageBody$ = LEFT$(MessageBody$,LEN(MessageBody$) - 1)
  WEND
  '
  ' Build the 'number reply's/last read' line.
  '
  TT$ = Null$
  IF BitTest(User.Toggles,9) AND p <> 0 _
     THEN IF Message.NumberReplies = C0$ _
             THEN TT$ = GetLine$(443) _
             ELSE TT$ = Short$(478) + _
                        LTRIM$(STR$(AscVal(Message.NumberReplies))) + _
                        GetLine$(399 + (Message.NumberReplies = C1$))
  IF Message.TimesRead > 0 AND p <> 0 _
     THEN IF BitTest(User.Toggles,10) AND BitTest(User.Toggles,11) _
             THEN TT$ = TT$ + GetLine$(445) + STR$(Message.TimesRead) + _
                        GetLine$(446) + IntToDate3$(Message.LastDateRead) + _
                        Short$(580) _
             ELSE IF BitTest(User.Toggles,10) _
                     THEN TT$ = TT$ + GetLine$(445) + STR$(Message.TimesRead) + _
                                GetLine$(447) _
                     ELSE IF BitTest(User.Toggles,11) _
                             THEN TT$ = TT$ + GetLine$(448) + _
                                        IntToDate3$(Message.LastDateRead) + _
                                        Short$(580)
  IF LEN(TT$) > 0 _
     THEN IF p < 0 THEN z$ = z$ + TT$ + C1310$ _
                   ELSE z$ = z$ + Short$(98) + TT$ + Short$(90) + C1310$
  IF p < 0 OR p = 3 THEN z$ = z$ + C1310$
  IF BitTest(User.Toggles,3) AND p >= 0 _
     THEN CALL FindMsgLine(0,Settings.MaxWidthOfMsg,1,K0$,K1,K2) : _
          IF K2 > 9 THEN z$ = z$ + Short$(928) + LTRIM$(STR$(K2)) + GetLine$(240) + C1310$
  IF p >= 0 AND p <> 3 THEN TT$ = Short$(186) + p$ + Short$(153) + z$ + C1310$ : _
                            CALL SendTT : _
                            IF TGot > 0 THEN EXIT SUB
  K0 = 1
  IF p < 0 THEN K3 = 5 _
           ELSE K3 = 15
  IF p = 3 THEN CALL FilePutSEnd(K4,z$)
  DO
    CALL FindMsgLine(K0,Settings.MaxWidthOfMsg,K3,K0$,K1,K2)
    IF p < 0 THEN z$ = z$ + K0$ + C1310$ _
             ELSE IF p = 3 THEN CALL FilePutSend(K4,K0$ + C1310$) _
                           ELSE TT$ = Short$(186) + p$ + Short$(153) + K0$ + C1310$ : _
                                CALL SendTT : _
                                IF TGot > 0 THEN EXIT SUB
    K0 = K0 + 1
  LOOP UNTIL K1 = -1
  '
  ' Update Times Read and Last Read numbers when the message was completely sent.
  '
  IF p <> 0 AND User.UserName <> MsgBases(Message.MsgBase).MsgOp _
     THEN Message.TimesRead = Message.TimesRead + 1 : _
          Message.LastDateRead = LogonDate : _
          CALL FilePutLoc(Handle(3),p& - 1,128,Message)
  IF p = 3 THEN z$ = Short$(998)
  IF p < 0 OR p = 3 THEN z$ = z$ + C1310$ + STRING$(79,124) + C1310$ : _
                         CALL FilePutSEnd(K4,z$) : _
                         CALL FileClose(K4) _
                    ELSE CALL DispCRLF

END SUB
        '
        '* * * *


