' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' Calculates the elapsed time between a given time and the
        ' current time.
        '
        ' p$  start time to use.
        '
        ' p   returns with number of elapsed seconds.
        '
        ' returns with number of elapsed minutes.
        '
        ' Handles correctly when the start time was before 00:00:00
        ' (midnight) and the current time is after midnight.
        '
        ' The seconds field is useless if the elapsed time was > 9
        ' hours (then you need a long integer).  When this is expected
        ' to occur, use: minutes * 60 to get the seconds.
        '
        ' Date last checked for perfection: Sep 21 1992
        '
FUNCTION ElapsedTime% (p$,p)

  K1$ = TIME$
  IF p$ > TIME$ THEN MID$(K1$,1,2) = LTRIM$(STR$(Val2&(LEFT$(K1$,2)) + 24))
  K1 = Val2&(LEFT$(K1$,2)) - Val2&(LEFT$(p$,2))     'Hours
  K0 = Val2&(MID$(K1$,4,2)) - Val2&(MID$(p$,4,2))   'Minutes
  p = Val2&(RIGHT$(K1$,2)) - Val2&(RIGHT$(p$,2))    'Seconds
  IF K0 < 0 THEN K0 = K0 + 60 : _
                 K1 = K1 - 1                          'Hours - 1
  IF p < 0 THEN p = p + 60 : _
                K0 = K0 - 1                           'Minutes - 1
  IF K1$ = Short$(274) _
     THEN K2 = Val2&(LEFT$(TIME$,2)) * 60 + Val2&(MID$(K1$,4,2)) _
     ELSE K2 = 0
  ElapsedTime% = K2 + K1 * 60 + K0                    'Hours * 60 + Minutes

END FUNCTION
        '
        '* * * *

