' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' This file contains routines that are internal to EnterMsgs.
'   EnterMsg3
'   InsertLines
'   DeleteLines
'   SaveLines
'   DoAGrammarCheck




        '* * * * * *
        ' This routine, internal to EnterMsg, handles the command line
        ' processing.
        '
        ' p  returns command option selected.
        '
        ' Date last checked for perfection: Sep 26 1992
        '
SUB EnterMsg3 (p)

  WHILE NOT NoCarrier
    '
    ' This section displays the initial message text, and is used again
    ' when the user selects to list the message.
    '
    ' For full line mode, we use 79 chars to show.  For lines with numbers,
    ' we use 79 - 4 - 1 = 74, 4 chars for numbers and ':', 1 char for a
    ' separator space.
    '
    K = Settings.MaxWidthOfMsg
    IF BitTest(User.Toggles,2) THEN K = K - 3 : _
                                    K1 = K - 1 _
                               ELSE K1 = K - 2
    TT$ = Short$(67) + Short$(70) + BlockText2(651) + Short$(70) + BlockText2(649) + _
          STR$(Settings.MaxLinesInMsg) +  BlockText2(652) + STR$(K) + _
          BlockText2(653) + Short$(70) + BlockText2(662) + Short$(70) + _
          BlockText2(663)
    CALL SendTT
    K1$ = Short$(931) + C1$
    IF BitTest(Toggles(3),4) THEN K1$ = K1$ + Short$(932)
    IF User.UserName = Settings.Sysop _
       OR (User.UserName = MsgBases(Message.MsgBase).MsgOp AND BitTest(Toggles(3),5)) _
       THEN K1$ = K1$ + Short$(476)
    IF Work(0) < 2 THEN K1$ = K1$ + Short$(464)
    TGot = -1
    SELECT CASE LEN(MessageBody$)
      CASE IS > 0
           K1 = 1
           DO
             CALL FindMsgLine(K1,K,35,K2$,K2,K3)
             IF BitTest(User.Toggles,2) _
                THEN TT$ = Short$(186) + K1$ + Short$(805) + _
                           RIGHT$(STR$(K1),2) + Short$(77) + Short$(1005) + _
                           Short$(70) + Short$(802) + Short$(77) + K2$ + _
                           C1310$ _
                ELSE TT$ = Short$(186) + K1$ + Short$(639) + Short$(77) + _
                           Short$(666) + Short$(70) + Short$(665) + _
                           Short$(77) + K2$ + C1310$
             CALL SendTT
             K1 = K1 + 1
           LOOP UNTIL K2 = -1 OR TGot > 0
    END SELECT
    '
    ' Get the message and process the command line commands.
    '
    DO
      IF p = 67 THEN CALL GetMessageText(0)
      z$ = TGot$
      TT = 10979
      CALL SendTT
      TGot = -1
      SELECT CASE z$
        CASE Short$(313), Short$(315), Short$(317), Short$(332) : TGot = 83
      END SELECT
      '
      ' Display the command line, and process it's commands, until they select
      ' Abort, Save, Continue, or List.
      '
      DO
        CALL DispCRLF
        CALL FindMsgLine(0,K,1,K2$,K2,K1)
        TT$ = Null$
        IF BitTest(User.Toggles,12) THEN K& = LEN(MessageBody$) : _
                                         TT$ = Commas$(K&) + BlockText2(452)
        IF BitTest(User.Toggles,13) _
           THEN K& = WordsCnt(MessageBody$) : _
                TT$ = TT$ + Commas$(K&) + BlockText2(454)
        IF BitTest(User.Toggles,14) _
           THEN TT$ = TT$ + LTRIM$(STR$(K1)) + BlockText2(455) : _
                IF K1 > 1 THEN TT$ = TT$ + Short$(329)
        IF RIGHT$(TT$,2) = Short$(904) THEN TT$ = LEFT$(TT$,LEN(TT$) - 2)
        IF LEN(TT$) > 0 THEN TT$ = Short$(933) + TT$ + Short$(934)
        TT$ = TT$ + BlockText2(655)
        IF User.UserName = Settings.Sysop _
           OR (User.UserName = MsgBases(Message.MsgBase).MsgOp AND BitTest(Toggles(3),5)) _
           THEN TT$ = TT$ + Short$(935)
        TT$ = Short$(387) + K1$ + Short$(153) + TT$ + BlockText2(656)
        IF Work(0) < 2 THEN TT$ = TT$ + BlockText2(810)
        TT$ = TT$ + BlockText2(811)
        IF TGot < 1 THEN CALL SendTT : _
                         IF TGot < 1 THEN CALL TGet(K1$)
        p = TGot
        SELECT CASE p
          CASE 37 : TT = 10937
                    CALL SendTT
                    EXIT SUB
          CASE 68 : TT = 667
                    CALL SendTT
                    CALL DeleteLines(K1$)
          CASE 73 : TT = 658
                    CALL SendTT
                    CALL InsertLines
          CASE 76 : TT = 456
                    CALL SendTT
                    EXIT DO
          CASE 65 : TT = 678
                    CALL SendTT
                    EXIT SUB
          CASE 80
               TT = 679
               CALL SendTT
               K2$ = MessageBody$
               CALL DispMessage(0&,0,K1$ + Short$(808))
               MessageBody$ = K2$
               K2$ = Null$                     'Save up to 8k of space.
          CASE 71
               TT = 673
               CALL SendTT
               FOR K1 = 10 TO 17
                 Handle(K1) = FileOpen(FileNames$(9) + Short$(470 + K1))
               NEXT
               CALL DoAGrammarCheck(K1$ + Short$(808))
               FOR K1 = 10 TO 17
                 CALL FileClose(Handle(K1))
               NEXT
          CASE 69
               TT = 567
               K2$ = LineEditTT$(40)
               IF LEN(K2$) = 0 _
                  THEN TT = 568 _
                  ELSE K3$ = K2$ : _
                       K1 = StrSrch(1,MessageBody$,K2$) : _
                       IF K1 = 0 _
                          THEN TT$ = Short$(282) + K3$ + BlockText2(571) _
                          ELSE TT = 665 : _
                               K2$ = LineEditTT$(47) : _
                               TT = 417 : _
                               MessageBody$ = LEFT$(MessageBody$,K1 - 1) + K2$ + _
                                              MID$(MessageBody$,K1 + LEN(K3$))
               CALL SendTT
          CASE 67
               TT = 657
               CALL SendTT
               K1 = LEN(MessageBody$)
               IF K1 < 3 THEN MessageBody$ = Null$ _
                         ELSE MessageBody$ = LEFT$(MessageBody$,K1 - 1)
               EXIT DO
          CASE 70
               TT = 812
               CALL SendTT
               EXIT SUB
          CASE 83, 1 : EXIT SUB
        END SELECT
      LOOP UNTIL NoCarrier
    LOOP UNTIL p = 76 OR NoCarrier
  WEND
  IF RTRIM$(MessageBody$) <> Null$ THEN MessageBody$ = MessageBody$ + C13$ : _
                                        p = 83 _
                                   ELSE p = 65

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to EnterMsg3, handles the deletion of
        ' lines from a message's body.
        '
        ' p$  valid stop and exit keys.
        '
        ' To delete lines; we convert the internal form of the message to
        ' what the user has been seeing, and then remove the lines the user
        ' expects to be removed.
        '
        ' Date last checked for perfection: Oct 18 1992
        '
SUB DeleteLines (p$)

  K7 = Settings.MaxWidthOfMsg
  IF BitTest(User.Toggles,2) THEN K7 = K7 - 4
  CALL FindMsgLine(0,K7,0,K0$,K0,K)                 'Get line count.
  TT = 668
  CALL GetNumPlusTT(Null$)
  K0 = Val2&(TGot$)
  SELECT CASE K0
    CASE 0 : TT = 669
    CASE 1 TO K
         TT$ = BlockText2(670) + STR$(K0) + Short$(969)
         CALL GetNumPlusTT(Null$)
         K1 = Val2&(TGot$)
         IF K1 = 0 THEN K1 = K0 : _
                        TT$ = LTRIM$(STR$(K1)) : _
                        CALL SendTT
         CALL DispCRLF
         SELECT CASE K1
           CASE IS > K : TT$ = Short$(970) + LTRIM$(STR$(K1)) + BlockText2(87)
           CASE IS < K0 : TT = 88
           CASE ELSE
                CALL DispCRLF
                '
                ' Attempt to delete lines K0 to K1.  Problems include quotes,
                ' recursive quotes, and quote authors name.
                '
                '
                ' Delete text lines, do not delete header or trailer lines.
                '
                WHILE K0 <= K1
                  '
                  ' We want to get a line for length calculations, and a line
                  ' for quote-bracket comparing.  Also want the start of the
                  ' text line (K4).  '1' adds quote brackets, '16' says to
                  ' return start of line.
                  '
                  CALL FindMsgLine(K0,K7,1,K1$,K4,K5)
                  CALL FindMsgLine(K0,K7,16,K2$,K4,K5)
                  K2 = LEN(K2$)                      'True length of line.
                  '
                  ' Backup along the message string looking for C0$'s.  We do
                  ' this to find how deep into replies the paragraph is, as
                  ' well as find it's ending CR.
                  '
                  K6 = 0                         'Depth of quote.
                  FOR K5 = K4 - 1 TO 1 STEP -1
                    IF AscVal(MID$(MessageBody$,K5,1)) = 0 THEN K6 = K6 + 1
                    IF AscVal(MID$(MessageBody$,K5,1)) = 13 THEN EXIT FOR
                  NEXT
                  '
                  ' If the string we want delete is in a quote (we found C0$'s
                  ' in the message string) and the end of the line to delete
                  ' contains a CR/LF, then check to see if there are any C0$'s
                  ' immediately in front of the string.  If yes, then we want to
                  ' delete those as well.  If not, then we don't want to delete
                  ' the C13$ at the end.  This is to allow us to delete text
                  ' lines within a paragraph without losing the paragraph's
                  ' structure.
                  '
                  IF K6 > 0 AND AscVal(MID$(MessageBody$,K4 + K2 - 1,1)) = 13 _
                     THEN IF AscVal(MID$(MessageBody$,K4 - 1,1)) = 0 _
                             THEN K4 = K4 - K6 : _
                                  K2 = K2 + K6 _
                             ELSE K2 = K2 - 1
                  IF StrSrch1(K1$,220) > 0 OR StrSrch1(K1$,223) > 0 _
                     THEN K0 = K0 + 1 _
                     ELSE K1 = K1 - 1 : _
                          IF K4 > 0 _
                             THEN MessageBody$ = LEFT$(MessageBody$,K4 - 1) + _
                                                 MID$(MessageBody$,K4 + K2)
                WEND
                '
                ' Delete quote header/trailer remants:
                '   (name)  
                '           
                ' Does not handle:          Does handle:
                ' (name)                  (name)    
                ' (name)                (name)  
                ' text                          
                '                                 
                '           
                '
                CALL FindMsgLine(0,K7,0,K0$,K0,K1)
                K2 = 1
                WHILE K2 < k1
                  CALL FindMsgLine(K2,K7,1,K1$,K3,K4)
                  CALL FindMsgLine(K2 + 1,K7,1,K2$,K4,K5)
                  SELECT CASE StrSrch1(K1$,220) * StrSrch1(K2$,223)
                    CASE IS > 0
                         '
                         ' If it is a header/trailer block, then delete it.
                         ' A header block is: 0's (text) 13
                         ' A trailer block is: 0's 13
                         ' So we remove: 0's (text) 13 0's 13
                         '
                         K4 = StrSrch(StrSrch(K3,MessageBody$,C13$) + 1,MessageBody$,C13$)
                         K3 = StrSrchR(LEFT$(MessageBody$,K3),13)
                         '
                         ' K3 contains the position of the end of the
                         ' privious line (K2 - 1).
                         ' K4 contains the position of the start of the second
                         ' line following (K2 + 2).
                         '
                         MessageBody$ = LEFT$(MessageBody$,K3) + _
                                         MID$(MessageBody$,K4 + 1)
                         K2 = 0                'Restart from first line.
                  END SELECT
                  K2 = K2 + 1
                  CALL FindMsgLine(0,K7,0,K0$,K0,K1)
                WEND
                K0 = K - K1
                IF K0 = 1 THEN TT$ = BlockText2(671) _
                          ELSE TT$ = STR$(K0) + BlockText2(685)
                TT$ = Short$(387) + p$ + BlockText2(672) + TT$
         END SELECT
    CASE ELSE
         TT$ = Short$(971) + LTRIM$(STR$(K0)) + BlockText2(87)
  END SELECT
  CALL SendTT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to EnterMsg, saves a message to the
        ' MESSAGES file.
        '
        ' p   Whether it is a Finish Later or just Save.
        '
        ' p$  The MSGID line we used.
        '
        ' Date last checked for perfection: Sep 26 1992
        '
SUB SaveLines (p,p$)

  '
  ' Save the message(s).
  '
  K2$ = TGot$
  IF p = 1 THEN CALL BitSet(Message.Attr,12) _
           ELSE IF p = 70 THEN CALL BitSet(Message.Attr,13) _
                          ELSE TT = 680 : _
                               CALL SendTT
  '
  ' Shall we include names at top of CC'd messages?
  '
  IF Work(0) > 1 AND p <> 1 _
     THEN TT = 89 : _
          IF GetYNTT _
             THEN K1$ = GetLine$(681) : _
                  K = FileOpen(FileNames$(1)) : _
                  FOR K00 = 1 TO Work(0) : _
                    CALL FileGetRec(K,Work(K00),384,AnyUser) : _
                    K1$ = K1$ + NCR$(AnyUser.UserName) + C13$ + SPACE$(17) : _
                  NEXT : _
                  CALL FileClose(K) : _
                  MessageBody$ = K1$ + C13$ + MessageBody$
  '
  ' Add hidden information lines for net mail.
  '
  'AREA:CONFERENCE
  '^APID: JDR_BBS r.xx
  '^AMSGID: address serialno
  '^AREPLY: address serialno
  'message text
  '
  K1$ = Null$
  IF BitTest(MsgBases(Message.MsgBase).SubType,9) _
     THEN K1$ = Short$(878) + UCASE$(RTRIM$(MsgBases(Message.MsgBase).Title)) + C13$
  SELECT CASE BitTest(MsgBases(Message.MsgBase).SubType,3)
    CASE -1
         IF Settings.Addr <> 0 _
            THEN K3$ = AddrToInt$(Settings.Addr,a1,a2,a3) + Short$(939) _
            ELSE K3$ = IntToPhone$(Settings.Phone) + C32$
         K1$ = K1$ + C1$ + Short$(938) + UnSq$(PID) + C13$ + C1$ + Short$(929) + _
                K3$ + RIGHT$(Short$(865) + HEX$(LogonDate),4) + _
                RIGHT$(Short$(865) + HEX$(TimeToInt(TIME$)),4) + C13$ : _
         K1$ = K1$ + p$
  END SELECT
  IF LEN(K1$) > 0 THEN MessageBody$ = K1$ + MessageBody$
  '
  ' Compress the message.  It must contain no ASCII codes > 127.
  '
  K1$ = MessageBody$
  CALL StrXLate(K1$,HighFilter$)
  SELECT CASE LEN(RTRIM$(K1$))
    CASE 0
         IF p <> 1 THEN TT = 682 : _
                        CALL SendTT
         MessageBody$ = Sq$(MessageBody$)
         CALL BitSet(Message.Attr,2)
         IF p <> 1 THEN TT = 683 : _
                        CALL SendTT
  END SELECT
  '
  ' Finally, file the message(s) away.
  '
  FOR K = 1 TO Work(0)
    SELECT CASE Work(K)
      CASE 0 : AnyUser.UserName = Short$(717)
      CASE ELSE
           K00 = FileOpen(FileNames$(1))
           CALL FileGetRec(K00,Work(K),384,AnyUser)
           Message.MsgTo = AnyUser.UserName
           CALL FileClose(K00)
    END SELECT
    CALL AddAMessage(0)
  NEXT
  SELECT CASE p
    CASE IS <> 1
         TT = 10941
         CALL SendTT
         IF BitTest(Message.Attr,13) _
            THEN TT = 813 : _
                 CALL SendTT : _
                 IF BitTest(Message.Attr,12) THEN TT = 814 : _
                                                  CALL SendTT
  END SELECT
  IF BitTest(Message.Attr,12) _
     THEN IF p <> 1 THEN TGot = 1000 _
                    ELSE IF AscVal(K2$) = 66 THEN TGot = 712 _
                                             ELSE TGot = 713

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine handles the grammar checking of a message.
        '
        ' p$ = valid stop and exit keys.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB DoAGrammarCheck (p$)

  K3 = Settings.MaxWidthOfMsg
  IF BitTest(User.Toggles,2) THEN K3 = K3 - 3
  TT$ = Short$(152) + p$ + Short$(754) + Short$(70) + BlockText2(674) + _ 
        Short$(70) + STRING$(104,219)
  CALL SendTT
  IF TGot > 0 OR NoCarrier THEN EXIT SUB
  K = 0
  K0 = 0
  DO
    K0 = K0 + 1
    CALL FindMsgLine(K0,K3,35,K0$,K1,K2)
    IF BitTest(User.Toggles,2) _
       THEN TT$ = Short$(369) + p$ + Short$(805) + RIGHT$(STR$(K2),2) + _
                  Short$(77) + Short$(1005) + Short$(70) + Short$(802) + _
                  Short$(77) _
       ELSE TT$ = Short$(369) + p$ + Short$(639) + Short$(77) + Short$(666) + _
                  Short$(70) + Short$(665) + Short$(77)
    CALL SendTT
    IF TGot < 1 AND NOT NoCarrier _
       THEN CALL GrammarCk(K,K0$) : _
            TT$ = Short$(186) + p$ + Short$(153) + K0$ + C1310$ : _
            CALL SendTT
  LOOP UNTIL K1 = -1 OR TGot > 0 OR NoCarrier
  TT = 10979
  CALL SendTT
  IF K1 <> -1 THEN K = 1
  CALL DispCRLF
  SELECT CASE K
    CASE 0                                          'No grammar errors.
         TT = 675
         CALL SendTT
    CASE -1                                         'Grmmar errors found.
         TT = 676
         SELECT CASE GetYNTT
           CASE -1
                TT = 677
                CALL SendTT
                K = 0
                DO
                  K = K + 1
                  K0$ = WordsGet$(MessageBody$,K,K1)
                  CALL GrammarCk(K1,K0$)
                LOOP UNTIL K = WordsCnt(MessageBody$) OR NoCarrier
                CALL DispCRLF
         END SELECT
  END SELECT

END SUB
        '
        '* * * *

