' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' This file contains various routines from PointShoot, ListDir, and
' PagedFileSystem.
'  DispRequests
'  DLBatchStuff
'  DLStuff
'  DisplayReviews
'  LoadDirContents





        '* * * * * *
        ' This routine displays the information in the requests file.
        '
        ' There are 3 levels displayed: requests, unprotects, and SL
        ' based targetted requests.
        '
        ' They are listed in the above order.  The key word looked for
        ' is 'unprotect'.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB DispRequests

  IF BitTest(User.Attr,10) AND NOT BitTest(Toggles(2),12) THEN EXIT SUB
  TT = 322
  CALL SendTT
  IF TGot > 0 THEN EXIT SUB
  K1 = FileOpen(FileNames$(14))
  K& = 0
  K = 1
  K0$ = GetLine$(393)
  WHILE K& <> -1 OR K = -1
    K$ = FileGetLine$(K1,K&)
    SELECT CASE StrSrch(1,K$,K0$) + StrSrch(1,K$,Short$(218)) 
      CASE 0
           K$ = MID$(K$,11)
           IF LEN(K$) > 29 THEN K$ = Form$(3801,K$) _
                           ELSE K$ = Form1$(38,K$)
           SELECT CASE K
             CASE 1 : TT$ = K$ + Short$(219)
             CASE -1
                  TT$ = Short$(232) + TT$ + Short$(98) + K$ + Short$(271)
                  CALL SendTT
                  IF TGot > 0 THEN CALL FileClose(K1) : _
                                   EXIT SUB
           END SELECT
           K = - K
    END SELECT
    IF K& = -1 AND K = -1 THEN K = 1
  WEND
  TT = 10259
  CALL SendTT
  IF TGot > 0 THEN CALL FileClose(K1) : _
                   EXIT SUB
  K& = 0
  K = 1
  WHILE K& <> -1 OR K = -1
    K$ = FileGetLine$(K1,K&)
    SELECT CASE StrSrch(1,K$,Short$(218))
      CASE IS > 0
           K$ = MID$(K$,11)
           IF LEN(K$) > 29 THEN K$ = Form$(3801,K$) _
                           ELSE K$ = Form1$(38,K$)
           SELECT CASE K
             CASE 1 : TT$ = K$ + Short$(219)
             CASE -1
                  TT$ = Short$(232) + TT$ + Short$(98) + K$ + Short$(271)
                  CALL SendTT
                  IF TGot > 0 THEN CALL FileClose(K1) : _
                                   EXIT SUB
           END SELECT
           K = - K
    END SELECT
    IF K& = -1 AND K = -1 THEN K = 1
  WEND
  TT = 10328
  CALL SendTT
  IF TGot > 0 THEN CALL FileClose(K1) : _
                   EXIT SUB
  SELECT CASE Levels(UserSL).SecLevel
    CASE IS >= Settings.SLEachOther
         K& = 0
         WHILE K& <> -1
           TT$ = FileGetLine$(K1,K&)
           SELECT CASE StrSrch(1,TT$,K0$)
             CASE IS > 0
                  IF LEN(TT$) > 82 THEN TT$ = Form$(8701,TT$) _
                                   ELSE TT$ = Form1$(87,TT$)
                  TT$ = Short$(232) + MID$(TT$,11) + Short$(271)
                  CALL SendTT
                  IF TGot > 0 THEN CALL FileClose(K1) : _
                                   EXIT SUB
           END SELECT
         WEND
  END SELECT
  TT$ = Short$(311) + STRING$(77,196) + Short$(336)
  CALL SendTT
  CALL FileClose(K1)
  CALL Paused

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine handles various batch file stuff.
        '
        ' p   what to do:
        '     65 to add to batch.
        '     66 to list the batch contents and offer to delete any.
        '     5  to list the batch contents and offer to download them.
        '     6  to list the batch contents and go and download them.
        '     3  delete entries from the batch.
        '     4  download the batch.
        '
        ' p$  actual batch.
        '
        ' Date last checked for perfection: Nov 6 1992
        '
SUB DLBatchStuff (p,p$)

  IF NoCarrier THEN EXIT SUB
  DO
    SELECT CASE p
      CASE 65
           '
           ' Add to batch.
           '
           CALL DLStuff(0,p$,K&)
           DO
             TT = 597
             CALL SendTT
             p = -1
             CALL GetFileName(K0$,p)
             IF p < 1 THEN EXIT DO
             IF FileIDX.FSize + K& > CanDL& _
                THEN TT = 786 : _
                     CALL SendTT : _
                     EXIT DO
             IF FileIDX.FSize + K& > (DLTime * (ConnectCPS * 57&)) _
                THEN TT = 787 : _
                     CALL SendTT : _
                     EXIT DO
             CALL DispCRLF
             p$ = p$ + Form$(1201,K0$) + MKL$(FileIDX.FSize)
           LOOP UNTIL LEN(p$) > 1600
      CASE 66, 5, 6
           '
           ' List the contents of the batch.
           '
           K0 = LEN(p$) \ 16
           FOR K1 = 1 TO K0 STEP 3
             TT$ = Null$
             FOR K2 = K1 TO K1 + 2
               IF K2 <= K0 _
                  THEN TT$ = TT$ + Short$(762) + _
                             Form$(966,Commas$(CVL(MID$(p$,K2 * 16 - 3,4)))) +  _
                             Short$(905) + Form$(1265,MID$(p$,K2 * 16 - 15,12))
             NEXT
             TT$ = RTRIM$(TT$) + C1310$
             CALL SendTT
           NEXT
           IF K0 = 0 THEN IF p <> 5 THEN TT = 788 : _
                                         CALL SendTT : _
                                         p = 0 _
                                    ELSE p = 0
           SELECT CASE p
             CASE 66 : TT = 789
                       IF GetYNTT THEN p = 3 _
                                  ELSE p = 0
                       CALL DispCRLF
             CASE 5 : TT = 772
                      IF GetYNTT THEN p = 4 _
                                 ELSE p = 0
             CASE 6 : p = 4
           END SELECT
      CASE 3
           '
           ' Remove entries from the batch.
           '
           DO
             TT = 724
             CALL SendTT
             p = -1
             CALL GetFileName(K0$,p)
             IF p > 0 _
                THEN K0 = StrSrch(1,p$,Form$(1201,K0$)) : _
                     IF K0 > 0 THEN p$ = LEFT$(p$,K0 - 1) + MID$(p$,K0 + 17)
             CALL DispCRLF
           LOOP UNTIL LEN(p$) = 0 OR p < 1
      CASE 4
           '
           ' Download the batch.  Bytes and time checking done when added
           ' to the batch.
           '
           CALL DispCRLF
           CALL KillFile(FileNames$(49))
           K1 = FileOpen(FileNames$(49))
           p = -1
           WHILE LEN(p$) > 0
             K0$ = LEFT$(p$,12)
             p$ = MID$(p$,17)
             IF GetFilePassword(BiSearch(3,0,K0$)) > 0 _
                THEN CALL FilePutSend(K1,RTRIM$(FileBases(FileIDX.FArea).Path) + K0$ + C1310$) : _
                     p = 0
           WEND
           CALL FileClose(K1)
           IF p THEN EXIT DO
           CALL AdjustProtocol(User.Protocol)
           TT$ = Short$(602) + RTRIM$(Form$(7908,MID$(TT$,20,34))) + _
                 BlockText2(335)
           TGot = 1000
    END SELECT
  LOOP UNTIL p < 1
END SUB
        '
        '* * * *

 


        '* * * * * *
        ' This routine handles various download-related operations.
        '
        ' p   What to do:
        '     0 Display what the user has available and has allocated.
        '     1 Ask for and download a single file.
        '
        ' p$  DL batch (if any)
        '
        ' p&  returns with the total bytes allocated so far when p = 0.
        '
        ' Date last checked for perfection: Nov 6 1992
        '
SUB DLStuff (p,p$,p&)

  SELECT CASE p
    CASE 0
         TT$ = BlockText2(725) + Commas$(CanDL&) + _
               BlockText2(726) + STR$(DLTime) + BlockText2(727)
         CALL SendTT
         p& = 0
         FOR K1 = 1 TO LEN(p$) \ 16
           p& = p& + CVL(MID$(p$,K1 * 16 - 3,4))
         NEXT
         IF p& > 0 THEN TT$ = Short$(97) + Commas$(p&) + BlockText2(726) + _
                              STR$(p& \ (ConnectCPS * 57&)) + _
                              BlockText2(728) : _
                              CALL SendTT
         CALL DispCRLF
    CASE 1
         TT = 729
         CALL SendTT
         K0 = -1
         CALL GetFileName(K0$,K0)
         IF GetFilePassword(K0) = 0 THEN EXIT SUB
         IF FileIDX.FSize + p& > CanDL& THEN TT = 786 : _
                                             CALL SendTT : _
                                             EXIT SUB
         IF FileIDX.FSize + p& > (DLTime * (ConnectCPS * 57&)) _
            THEN TT = 787 : _
                 CALL SendTT : _
                 EXIT SUB
         CALL KillFile(FileNames$(49))
         K0 = FileOpen(FileNames$(49))
         CALL FilePutSend(K0,RTRIM$(FileBases(FileIDX.FArea).Path) + K0$ + C1310$)
         CALL FileClose(K0)
         CALL AdjustProtocol(User.Protocol)
         TT$ = Short$(751) + RTRIM$(Form$(7908,MID$(TT$,20,34))) + _
               BlockText2(335)
         TGot = 1000
    CASE 2
         K1 = FileOpen(FileNames$(49))
         K2 = FileOpen(FileNames$(10))
         K0& = 0
         K7 = -1
         DO
           K$ = FileGetLine$(K1,K0&)
           K6 = StrSrch1(K$,32)
           IF K6 > 0 _
              THEN K66 = GetFilePassword(BiSearch(3,0,LEFT$(K$,K6))) : _
                   IF K66 = 0 THEN K6 = 0
           IF K6 > 0 _
              THEN K$ = RTRIM$(FileBases(Val2&(K$)).Path) + LEFT$(K$,K6) : _
                   CALL FilePutSend(K2,K$) : _
                   K7 = 0
         LOOP UNTIL K0& = -1
         CALL FileClose(K1)
         CALL FileClose(K2)
         CALL CopyFile(1,FileNames$(10),FileNames$(49))
         K1 = 0
         IF K7 < 0 THEN TGot = 0 : _
                        EXIT SUB
         CALL AdjustProtocol(User.Protocol)
         TT$ = AnsiLocStr$(K5 + 10,1) + Short$(602) + _
               RTRIM$(Form$(7908,MID$(TT$,20,34))) + BlockText2(335)
         TGot = 1001
  END SELECT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine displays the reviews for a file area.
        '
        ' p  -1 if should wipe and do a paused, 0 if not.
        '
        ' FileIndex is relied upon.
        '
        ' Date last checked for perfection: Nov 7 1992
        '
SUB DisplayReviews (p)

  IF p THEN CALL Wipe(StripLen(GetLine$(3)) - 4)
  K0$ = FileNames$(15) + Form4$(3,FileIndex)
  IF FindF(K0$,FFile) = 0 THEN EXIT SUB
  TT = 340
  CALL SendTT
  K0 = FileOpen(K0$)
  K& = 0
  DO
    K$ = FileGetLine$(K0,K&)
    TT$ = Short$(774) + ExpandFileName$(MID$(K$,2,12)) + Short$(775) + _
          MID$(K$,14) + C1310$
    CALL SendTT
  LOOP UNTIL K& = -1 OR TGot > 0
  CALL FileClose(K0)
  IF p THEN CALL Paused

END SUB
        '
        '* * * *


'make a function.
SUB LoadDirContents (K3)
                  '
                  ' Locate all the files in the directory.  An alternative
                  ' method is to scan the entire FILES.IDX file looking for
                  ' matching .FArea's.
                  '
                  ' BiSearch est: NLogN wher N is number of files in dir.
                  ' FILES.IDX est: total number of entries.
                  ' BiSearch offers the advantage of sorted entries.
                  ' Files.idx offers the advantage of disk buffered speed.
                  '
                  ' 3 dirs with 100 files each (300 total):
                  ' Bisearch = 600 reads of files.idx per dir.
                  ' Files.idx = 300 reads of files.idx per dir.
                  ' 10 dirs with 100 files each (1000 total):
                  ' Bisearch = 600 reads of files.idx per dir.
                  ' Files.idx = 1000 reads of files.idx per dir.
                  ' 20 dirs with 100 files each (2000 total):
                  ' Bisearch = 600 reads of files.idx per dir.
                  ' Files.idx = 2000 reads of files.idx per dir.
                  '
                  ' So, Bisearch method is better as number of files increase.
                  ' Therefore that is the method used.
                  '
                  K3 = 1
                  DO : K3 = K3 + 1
                  LOOP UNTIL FindF(Null$,FWork(K3)) = 0
                  FWork(0).FName = C0$
                  K3 = K3 - 1
                  CALL FWorkSort(K3)

END SUB
