' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will 'find' and return a 'line' of text from
        ' MessageBody$.
        '
        ' p   is line number to find.  If p = 0 then find the last
        '     line and store it's number in p3.
        '
        ' p0  is maximum line length.
        '
        ' p1  0 if p$ should be original text.
        '     Below are the flags, with all, cr's are stripped and the
        '     text is rtrim'ed.  Except for that, 1 & 2 only effects
        '     the quoted text, 4 & 5 effect the whole message (text
        '     and quoted text).
        '        1  add quote brackets
        '        2  compress quote space and add color (add escape
        '           sequences)
        '        4  ltrim the text
        '        8  colorize the text
        '       16  if p2 should return the first character of the
        '           last line (instead of -1).
        '       32  Use reverse (messsage entry) quote colors.
        '
        ' p$  returns the line of text
        '
        ' p2  returns -1 if p$ = last line and p <> 0, otherwise
        '     p2 = postion in MessageBody$ of the first character for
        '     p$.
        '
        ' p3  line number working on.  Returns either the last line
        '      or p.
        '
        ' MessageBody$ is assumed to contain the text of the message.
        '
        ' Special note: This is the nastiest routine I have.  Deadly.
        ' It's the 'engine' behind the message system.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB FindMsgLine (p,p0,p1,p$,p2,p3)

  p3  = 0
  IF LEN(MessageBody$) = 0 THEN p$ = Null$ : _
                                p2 = -1 : _
                                EXIT SUB
  p$ = SPACE$(p0)
  p2 = 1
  K4 = 0
  K5 = -1
  K6 = 1
  K7 = 0
  DO
    K8 = 0
    IF K6 > 1 THEN IF MID$(MessageBody$,K6 - 1,1) = C13$ THEN K5 = -1 : _
                                                              K4 = 0 _
                                                         ELSE K5 = 0
    SELECT CASE MID$(MessageBody$,K6,1)
      CASE C0$
           FOR K4 = 1 TO 20
             IF MID$(MessageBody$,K6 + K4,1) <> C0$ THEN EXIT FOR
           NEXT
           K6 = K6 + K4
    END SELECT
    K9 = p0 - K4 - K4
    p2 = K6
    SELECT CASE K7
      CASE IS < K4
           K7 = K7 + 1
           K8 = 1
           K9 = StrSrch1(MID$(MessageBody$,K6,31),13)
      CASE ELSE
           K10 = StrSrch1(MID$(MessageBody$,K6,K9),13)
           IF K10 = 0 THEN K10 = StrSrchR(MID$(MessageBody$,K6,K9 - 1),32) : _
                           IF K10 = 0 THEN K10 = K9
           K9 = K10
           IF K7 > 0 AND MID$(MessageBody$,K6,1) = C13$ THEN K7 = K7 - 1 : _
                                                             K8 = 2
    END SELECT
    p3 = p3 + 1
    K6 = K6 + K9
  LOOP UNTIL K6 >= LEN(MessageBody$) OR p3 = p
  IF K6 >= LEN(MessageBody$) AND p <> 0 AND (NOT BitTest(p1,5)) THEN p2 = -1
  p$ = MID$(MessageBody$,K6 - K9,K9)
  IF p1 = 0 OR p1 = 16 THEN EXIT SUB
  SELECT CASE K8
    CASE 0 : K6 = K7
             K0$ = Null$
    CASE 1 : K6 = K7 - 1
             K0$ = Short$(382)
    CASE 2 : K7 = K7 + 1
             K6 = K7 - 1
             K0$ = Short$(388)
  END SELECT
  IF K9 > 0 THEN p$ = RTRIM$(LEFT$(p$,K9 - 1))
  IF BitTest(p1,3) AND (K5 = 0) THEN p$ = LTRIM$(p$)
  IF BitTest(p1,1) THEN K1$ = K0$ + STRING$(K6,222) : _
                        K0$ = STRING$(K6,221) + K0$
  K6 = p0 - LEN(p$) - K7 - K7
  IF K6 < 0 THEN K6 = 0
  SELECT CASE BitTest(p1,2)
    CASE -1
         SELECT CASE BitTest(p1,6)
           CASE -1
                IF K8 = 0 THEN K1$ = Short$(77) + Short$(65) + K1$ + Short$(77) : _
                               K0$ = Short$(77) + Short$(65) + K0$ + Short$(77) _
                          ELSE K1$ = K1$ + Short$(77) : _
                               K0$ = Short$(77) + Short$(65) + K0$
           CASE ELSE
                IF K8 = 0 THEN K1$ = Short$(82) + K1$ + Short$(90) : _
                               K0$ = Short$(82) + K0$ + Short$(90) _
                          ELSE K1$ = K1$ + Short$(90) : _
                               K0$ = Short$(82) + K0$
         END SELECT
         IF K6 > 6 THEN K2$ = Short$(213) + LTRIM$(STR$(K6)) + Short$(214) _
                   ELSE K2$ = SPACE$(K6)
    CASE ELSE : K2$ = SPACE$(K6)
  END SELECT
  SELECT CASE BitTest(p1,4)
    CASE -1
         K3$ = Null$
         IF p3 = 1 THEN MsgColor = 0 _
                   ELSE IF MsgColor > 0 AND MsgColor < 7 _
                           THEN K3$ = Short$(90 + MsgColor)
         CALL Colorize(p$)
         p$ = K3$ + p$
  END SELECT
  IF K7 > 0 THEN p$ = K0$ + p$ + K2$ + K1$

END SUB
        '
        '* * * *

