' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine gets, and returns with, a description for a
        ' file.
        '
        ' p    What to do:
        '      1 just get a new decription line.
        '      2 just add GIF info to a description.
        '      3 to replace a description line, and add GIF info.
        '      4 to replace a description line, and add GIF info, but
        '        to not replace description line if already has more
        '        than 3 characters.
        '
        ' p$   Output text for first (bar) line.
        ' p0$  Output txt for second (description) line.
        '
        ' A FileList read-in of the desired file must have been done
        ' before calling this.
        '
        ' FileList.FDesc is modified if there were any changes.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB GetDesc (p,p$,p0$)

  SELECT CASE p
    CASE 1, 3, 4
         TT$ = Short$(131) + Form$(1801,p$) + Short$(403) + _
               Form$(1566,p0$) + Short$(664)
         IF p = 3 OR p = 4 _
            THEN TT$ = TT$ + Short$(668) + RTRIM$(FileList.FDesc) + Short$(673)
         K0 = 0
         IF p = 4 AND LEN(RTRIM$(FileList.FDesc)) > 3 THEN K0 = 1 : _
                                                           CALL SendTT : _
                                                           CALL DispCRLF
         SELECT CASE K0
           CASE 0
                IF User.UserName <> FileBases(FileList.FArea).FileOp _
                   THEN LESpecial = 1
                K2$ = LineEditTT$(51)
                K0 = LEN(RTRIM$(FileList.FDesc)) - LEN(K2$)
                IF K0 > 0 AND LEN(K2$) > 0 THEN TT$ = SPACE$(K0) : _
                                                CALL SendTT
                CALL DispCRLF
                K2$ = LTRIM$(RTRIM$(K2$))
                IF LEN(K2$) < 3 THEN EXIT SUB
                FileList.FDesc = StripAnsi$(K2$)
         END SELECT
  END SELECT
  SELECT CASE p
    CASE 2, 3, 4
         K1$ = RTRIM$(FileBases(FileList.FArea).Path) + FileList.FName
         IF BitTest(FileBases(FileList.FArea).Attr,1) THEN K0 = 38 _
                                                      ELSE K0 = 52
         IF StrSrch(1,FileList.FName,Short$(128)) > 0 _
            THEN K1$ = GifInfo$(K1$) : _
                 MID$(FileList.FDesc,K0 - LEN(K1$)) = K1$
  END SELECT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to GetDesc, will get the size
        ' information from GIF files.
        '
        ' p$  pathname of file to examine.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
FUNCTION GifInfo$ (p$)

    K = FileOpen(p$)
  K0$ = SPACE$(48)
  CALL FileGetSLoc(K,0&,K0$)
  CALL FileClose(K)
  SELECT CASE LEFT$(K0$,3)
    CASE Short$(355)                    'GIF87a GIF89a
         K = 0
         K0 = AscVal(MID$(K0$,11,1))
         IF BitTest(K0,1) THEN K = 1
         IF BitTest(K0,2) THEN K = K + 2
         IF BitTest(K0,3) THEN K = K + 4
         K0 = 7
         K1 = 9
         K = Power2(K + 1)
    CASE Short$(272)                   'Windows bitmap
         K0 = 19
         K1 = 23
         K = CVI(MID$(K0$,47,2))
    CASE ELSE : GifInfo$ = GetLine$(239)
                EXIT FUNCTION
  END SELECT
  GifInfo$ = Short$(267) + LTRIM$(STR$(CVI(MID$(K0$,K0,2)))) + _
             Short$(268) + LTRIM$(STR$(CVI(MID$(K0$,K1,2)))) + _
             Short$(268) + LTRIM$(STR$(K)) + Short$(270)

END FUNCTION
        '
        '* * * *

