' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved. 




        '* * * * * *
        ' This routine will get message text and store it in
        ' MessageBody$.
        '
        ' p = line number to start at, -1 means do chat.
        '
        ' It is the job of the calling routine to display heading,
        ' clear MessageBody$, display anything already in
        ' MessageBody$.  The calling routine also must use FindMsgLine
        ' to break the resulting MessageBody$ into smaller widths if
        ' that is what it wants to do with it.
        '
        ' CHR$(13) isn't ever processed (displayed) but is stored with
        ' text.
        '
        ' Except for 8, 9, 13, and 27, everything below ASCII 32 is
        ' ignored.  Tab's are expanded.
        '
        ' Date last checked for perfection: Sep 18 1992
        '
SUB GetMessageText (p)

  kz = 0
  FOR K0 = 10 TO 17
    Handle(K0) = FileOpen(FileNames$(9) + Short$(470 + K0))
  NEXT
  CALL CursorOn
  K5 = Settings.MaxWidthOfMsg
  K$ = Null$
  IF BitTest(User.Toggles,2) THEN K5 = K5 - 4
  IF p = 0 THEN CALL FindMsgLine(0,K5,3,K$,K0,p) : _
                IF RIGHT$(K$,3) = Short$(277) OR LEN(MessageBody$) = 0 _
                   THEN K$ = Null$ _
                   ELSE MessageBody$ = LEFT$(MessageBody$,LEN(MessageBody$) - LEN(K$) - 1)
  IF LEN(K$) = 0 THEN p = p + 1
  K5 = K5 + 1
  K2$ = SPACE$(K5)
  K9 = 0
  DO
    '             
    'This handles colorizing at line changes.
    '
    IF K9 = -1 AND CommPort > 0 THEN TT$ = Short$(757) : _
                                     K8 = -1 _
                                ELSE TT$ = Short$(77) : _
                                     K8 = 0
    IF NOT BitTest(User.Toggles,2) _
       THEN TT$ = Short$(77) + Short$(758) + Short$(70) + Short$(665) + TT$ + K$ _
       ELSE TT$ = Short$(746) + RIGHT$(STR$(p),2) + Short$(77) + _
                  Short$(1005) + Short$(70) + Short$(802) + TT$ + K$
    CALL SendTT
    K0 = LEN(K$)
    MID$(K2$,1,K0) = K$
    K$ = Null$
    K1 = 0
    K0$ = TIME$
    DO
      SELECT CASE K1
        CASE IS > 0
             K1 = K1 - 1
             K2 = 32
        CASE ELSE
             '
             ' This handles color changes within lines.
             '
             K2 = CommIn(K9)
             IF K8 <> K9 AND K2 >= 0 AND CommPort > 0 _
                THEN K8 = K9 : _
                     IF K9 THEN TT = 10065 : _
                                CALL SendTT _
                           ELSE TT = 10077 : _
                                CALL SendTT
      END SELECT
      '
      ' No excessive inactivity message since that would cause all sorts of
      ' data entry display problems should the user decide to continue the
      ' session.  Also, the cursor could be positioned anywhere.
      '
      IF ElapsedTime(K0$,K6) = Settings.TimeOut THEN CALL Quote : _
                                                     CALL HangUp
      '
      ' Except for 8, 9, 13, and 27, everything below 32 is ignored.
      '
      SELECT CASE K2
        CASE 8, 127
             SELECT CASE K0
               CASE 0
                    K$ = Null$
                    MessageBody$ = MessageBody$ + C13$
                    CALL FindMsgLine(0,K5,3,K2$,K3,K4)
                    SELECT CASE RIGHT$(K2$,3)
                      CASE Short$(277)
                           MessageBody$ = LEFT$(MessageBody$,LEN(MessageBody$) - 1)
                           K2$ = SPACE$(K5)
                      CASE ELSE
                           K0 = LEN(K2$)
                           IF K0 < K5 THEN K2$ = K2$ + SPACE$(K5 - K0)
                           IF K3 > 1 THEN MessageBody$ = LEFT$(MessageBody$,K3 - 1) _
                                     ELSE MessageBody$ = Null$
                           CALL Wipe(4)
                           IF NOT BitTest(User.Toggles,2) _
                              THEN TT$ = BlockText2(167) + Short$(77) + _
                                         Short$(758) +  Short$(70) + _
                                         Short$(665) + Short$(77) + _
                                         LEFT$(K2$,K0) _
                              ELSE TT$ = BlockText2(167) + Short$(746) + _
                                         RIGHT$(STR$(K4),2) + Short$(77) + _
                                         Short$(1005) + Short$(70) + _
                                         Short$(802) + Short$(77) + _
                                         LEFT$(K2$,K0)
                           CALL SendTT
                    END SELECT
               CASE ELSE
                    K0 = K0 - 1
                    CALL Wipe(1)
             END SELECT
        CASE 9 : K1 = 4 - K0 + ((K0 + 1) \ 5) * 5     '5 - ((K0 + 1) MOD 5)
        CASE 13, 27, IS > 31
             K3 = -1
             SELECT CASE K2
               CASE 13, 32
                    IF K0 > 0 AND kz = 0 THEN K4 = 1 : _
                                              kz = 1 : _
                                              CALL Censor(K0,K4,K2$) : _
                                              IF K4 = 0 THEN K3 = 0
                    IF K2 = 13 THEN K3 = 0
               CASE ELSE : kz = 0
             END SELECT
             K0$ = TIME$
             SELECT CASE K3
               CASE -1
                    TT$ = AscChr$(K2)
                    K0 = K0 + 1
                    MID$(K2$,K0,1) = TT$
                    CALL CommOut(TT$)
                    CALL AnsiTT
                    IF K0 > 2 THEN IF MID$(K2$,K0,1) = MID$(K2$,K0 - 2,1) _
                                      THEN CALL ForeignChar(K2$,K0)
                    SELECT CASE K0
                      CASE K5 : K2 = 257
                      CASE IS < 5
                           K1$ = UCASE$(LEFT$(K2$,K0))
                           IF K1$ = Short$(313) OR K1$ = Short$(315) _
                              OR K1$ = Short$(317) OR K1$ = Short$(332) _
                              THEN K2 = 256 : _
                                   TGot$ = K1$
                  END SELECT
           END SELECT
      END SELECT
    LOOP UNTIL K2 = 13 OR K2 > 255 OR NoCarrier
    SELECT CASE K2
      CASE 256 : CALL Wipe(K0)
                 MessageBody$ = MessageBody$ + C13$ + C13$
      CASE 13  : K3$ = LEFT$(K2$,K0)
                 IF K3$ = Short$(777) THEN K3$ = C32$ : _
                                           CALL Wipe(1)
                 MessageBody$ = MessageBody$ + K3$ + C13$
      CASE 257 : K3 = StrSrchR(K2$,32)
                 IF K3 = 0 THEN K3 = K0
                 CALL Wipe(K0 - K3)
                 K0 = K3
                 MessageBody$ = MessageBody$ + LEFT$(K2$,K3)
                 K$ = MID$(K2$,K3 + 1)
    END SELECT
    CALL DispCRLF
    IF K2 <> 256 THEN K2 = Settings.MaxLinesInMsg - p : _
                      IF K2 < 3 THEN TT = 170 - K2 : _
                                     CALL SendTT
    p = p + 1
  LOOP UNTIL NoCarrier OR p > Settings.MaxLinesInMsg _
       OR RIGHT$(MessageBody$,2) = C13$ + C13$
  CALL CursorOff
  z$ = TGot$
  TT = 10979
  CALL SendTT
  TGot$ = z$
  FOR K0 = 10 TO 17
    CALL FileClose(Handle(K0))
  NEXT

END SUB
        '
        '* * * *

