' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will get a U.S. phone number.
        '
        ' p  0 to just get a number.
        '    1 to get a home phone number.
        '    2 to get a user's BBS phone number.
        '
        ' TGot$ returns with the alpha-numeric form of the number
        ' entered.
        '
        ' TT& returns with the long integer form of the number
        ' entered.
        '
        ' This routine cannot handle international numbers.
        '
        ' Formats: xxx-yyyy local
        '          (aaa) xxx-yyyy long distance
        '          The formats below aren't supported because they
        '          don't fit too well into long integer's:
        '            1 xxx-yyyy not so local (use LD format)
        '            1 (aaa) xxx-yyyy also a possible entry for long
        '            distance
        '            1 800 xxx-yyyy 800 numbers  --use LD format
        '            011 aaa bbb xxx yyyy  International, lengths
        '            vary, not sure.
        '
        ' When creating the long integer, the second digit of long
        ' distance numbers (always 0 or 1) is moved to the front.  So
        ' check the length of the number when convert back to a
        ' string.  If 7, then local, if 9 then (x0x) long distance, if
        ' 10 then (x1x) long distance.  Examples: (808) 666-5555 is
        ' stored as 886665555, (818) 666-5555 as 1886665555
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB GetPhoneNumber (p)

  IF p = 1 THEN TT = 59 : _
                CALL SendTT
  IF p = 2 THEN TT = 60 : _
                CALL SendTT
  K$ = Null$
  DO
    CALL TGet(Short$(999) + C13$ + C8$)
    K = TGot
    K0$ = TGot$
    SELECT CASE TGot
      CASE 8
           DO
             IF LEN(K$) > 0 THEN TGot$ = RIGHT$(K$,1) : _
                                 K$ = LEFT$(K$,LEN(K$) - 1) : _
                                 CALL Wipe(1)
           LOOP UNTIL K$ = Null$ OR StrSrch(1,Short$(999),TGot$) > 0
           IF K$ = Short$(478) THEN K$ = Null$ : _
                                    CALL Wipe(1)
      CASE IS > 8
           SELECT CASE AscVal(K$)
             CASE 40
                  SELECT CASE LEN(K$)
                    CASE 3 : K0$ = K0$ + Short$(491)
                    CASE 8 : K0$ = K0$ + Short$(492)
                    CASE 14 : K = 0
                  END SELECT 
             CASE ELSE
                  SELECT CASE LEN(K$)
                    CASE 0 : IF TGot = 48 OR TGot = 49 THEN K = 0
                    CASE 1
                         IF TGot = 48 OR TGot = 49 _
                            THEN CALL Wipe(1) : _
                                 K0$ = Short$(478) + K$ + K0$ : _
                                 K$ = Null$
                    CASE 2 : K0$ = K0$ + Short$(492)
                    CASE 8 : K = 0
                  END SELECT
           END SELECT
           IF K > 0 THEN K$ = K$ + K0$ : _
                         TT$ = K0$ : _
                         CALL SendTT
    END SELECT
  LOOP UNTIL K = -1
  TT& = 0
  TGot$ = Null$
  SELECT CASE AscVal(K$)
    CASE 40
         IF LEN(K$) = 14 _
            THEN TT& = Val2&(MID$(K$,3,1) + MID$(K$,2,1) + MID$(K$,4,1) + _
                       MID$(K$,7,3) + RIGHT$(K$,4)) : _
                 TGot$ = K$
    CASE ELSE
         IF LEN(K$) = 8 THEN TT& = Val2&(LEFT$(K$,3) + RIGHT$(K$,4)) : _
                             TGot$ = K$
  END SELECT
  IF p = 1 THEN User.HomePhone = TT&
  IF p = 2 THEN User.BBSPhone = TT&

END SUB
        '
        '* * * *

