' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.





        '* * * * * *
        ' This routine will get a user name as input.
        '
        ' Setting LESpecial = 2 before calling this causes any name
        ' except 'ALL', 'FELLOW', 'SYSOP' to be processed.
        ' LESpecial <> 2 will allow the above, but only allow entry of
        ' current user names (like GetFileName).  This only comes into
        ' effect for the opening logon session.
        '
        ' p  returns the RecNum if the name was found. No need to call
        '    BiSearch or RTRIM$(K$) after calling this--except for
        '    logging in new users.  That is, it returns the position
        '    in USERS--the users record in the file.  If p > 0 then a
        '    user was found, otherwise K$ will be NULL except for 'ALL'.
        '
        ' p$ returns with 30 or less characters.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB GetUserNameTT (p$,p)

  km = tt
  km$ = tt$
  CALL SendTT
  p$ = SPACE$(31)                        ''=name' -> 31 chars.
  p = 0
  K0 = 0
  IF LEN(RTRIM$(User.UserName)) = 0 _
     THEN K0$ = C3$ _
     ELSE K0$ = Short$(642 + (UserSL = LevelsSize))
  K0$ = K0$ + LEFT$(Short$(234),26) + Short$(579) + C13$ + C8$
  DO
    CALL TGet(K0$ + Short$(254))                    'Get valid character.
    IF TGot = 61 AND K0 > 0 THEN CALL TGet(K0$)     'No middle ='s allowed.
    K4 = -1
    SELECT CASE TGot
      CASE 42, 63 : CALL UserNameMatcher(p$,k0,km,km$,TGot)
                    K4 = 0
      CASE 8 : IF K0 > 0 THEN MID$(p$,K0,1) = C32$ : _
                              K0 = K0 - 1 : _
                              CALL Wipe(1)
               K4 = 0
      CASE -1
           IF RTRIM$(p$) = Short$(652) _
              THEN IF LESpecial = 2 THEN p$ = Null$ _
                                    ELSE CALL Wipe(3) : _
                                         TT = 141 : _
                                         CALL SendTT
           EXIT DO
      CASE 32
           '
           ' Space.  Only allowed in position 1 if sysop--for deleting users
           ' with a space as the first letter (usually due to user file
           ' corruptions of some sort).
           '
           ' Two spaces in a row are not allowed.  The lines below cannot be
           ' be merged, because K0 = 0 kills the MID$ part of the IF.
           '
           SELECT CASE K0
             CASE 0
                  IF UserSL = LevelsSize THEN K0 = K0 + 1 : _
                                              TT$ = C32$ : _
                                              CALL CommOut(TT$) : _
                                              CALL AnsiTT
             CASE ELSE
                  IF AscVal(MID$(p$,K0,1)) <> 32 THEN K0 = K0 + 1 : _
                                                      TT$ = C32$ : _
                                                      CALL CommOut(TT$) : _
                                                      CALL AnsiTT
           END SELECT
      CASE ELSE
           K0 = K0 + 1
           MID$(p$,K0,1) = TGot$
           TT$ = p$
           CALL WordsCase(TT$)
           TT$ = MID$(TT$,K0,1)
           CALL CommOut(TT$)
           CALL AnsiTT
    END SELECT
    K2$ = LEFT$(p$,K0)
    SELECT CASE K2$
      CASE Short$(652), LEFT$(Short$(652),K0) : K4 = 0
      CASE Short$(582)
           CALL Wipe(6)
           p$ = Short$(652)
           TT = 141
           CALL SendTT
           K0 = 3
           EXIT DO
      CASE Short$(473)
           CALL Wipe(5)
           p$ = MsgBases(BaseIndex).MsgOp
           TT$ = NCR$(p$)
           K0 = LEN(TT$)
           CALL SendTT
           EXIT DO
    END SELECT
    IF K2$ = LEFT$(Short$(582),K0) OR K2$ = LEFT$(Short$(473),K0) _
       OR AscVal(p$) = 61 OR K0 < 2 THEN K4 = 0
    SELECT CASE K4
      CASE -1
           k = BiSearch(2,0,K2$)
           IF k = 0 AND LESpecial <> 2 THEN CALL Wipe(1) : _
                                            K0 = K0 - 1
           IF k > 0 THEN K2 = 1 : _
                         K1 = 0 : _
                         CALL AI(1,p$,k,K0,K1,K2,K3,0&,0&) : _
                         IF K2 - K1 = 0 THEN EXIT DO
    END SELECT
  LOOP UNTIL K0 > 30
  '
  ' LESpecial = 2 is login.  We don't care about p, just p$.  Otherwise we
  ' want to return the single match.  Thus, p$ can obtain any text in the
  ' above routines, but this ultimately confirms or denies it.
  '
  IF AscVal(p$) = 61 THEN p$ = MID$(p$,2) _
                     ELSE p$ = LEFT$(p$,30)
  IF LESpecial <> 2 _
     THEN p = BiSearch(5,0,p$) : _
          IF p = 0 AND RTRIM$(p$) <> Short$(652) THEN CALL Wipe(K0) : _
                                                      p$ = Null$

  p$ = LEFT$(p$,K0)

END SUB
        '
        '* * * *






'IF LESpecial = 3, then we're doing entering messages.
'IF LESpecial = 4, then skip this.
SUB UserNameMatcher(p$,k0,km,km$,kk)
  IF K0 < 1 OR LEN(RTRIM$(User.UserName)) = 0 OR LESpecial = 4 THEN EXIT SUB
  IF LESpecial <> 3 THEN TT$ = AscChr$(kk) + Short$(643) _
                    ELSE CALL WipeMsgHdrWindow(3) : _
                         TT = 10839 : _
                         kzz = 14
  CALL SendTT
  km1$ = LEFT$(p$,K0)
  km2$ = km1$
  km3$ = SPACE$(30)
  K& = -32
  km3 = 1
  FOR km2 = 1 TO FileLof&(Handle(21),32)
    K& = K& + 32
    CALL FileGetSLoc(Handle(21),K&,km2$)
    IF km2$ = km1$ _
       THEN CALL FileGetSLoc(Handle(21),K&,km3$) : _
            km3 = - km3 : _
            IF km3 = -1 THEN TT$ = C32$ + km3$ _
                        ELSE TT$ = NCR$(TT$ + km3$) + C1310$ : _
                             CALL SendTT : _
                             IF LESpecial = 3 THEN kzz = kzz + 1 : _
                                                   IF kzz = 23 THEN EXIT FOR
  NEXT
  IF kzz = 23 THEN TT = 10820 : _
                   CALL SendTT
  IF km3 = -1 THEN TT$ = NCR$(TT$) + C1310$ : _
                   CALL SendTT
  IF LESpecial <> 3 THEN TT = km : _
                         TT$ = km$ : _
                         CALL SendTT : _
                         TT$ = NCR$(km1$) _
                    ELSE TT$ = Short$(747) + LTRIM$(STR$(K0)) + Short$(745)
  CALL SendTT
END SUB

