; Copyright (c) 1991-1992, John David Rohner.  All rights reserved.

;
; This routine returns a time in HH:MM:SS format given an integer time.
;
; Usage:  Result$ = IntToTime$(Input%)
; Declare:  DECLARE FUNCTION IntToTime$ (Input%)
;
; Where Result$ is the time in the form "HH:MM:SS" and Input% is the time in
; integer form.
;

.Model Medium, Basic
.Code

DGROUP      group   _DATA

_DATA       segment word public 'DATA'

Max8Buf     DB      8,0,0,0,0,0,':',0,0,':',0,0

_DATA       ends


            PUBLIC  IntToTime         ;Make this routine available to LINK.

IntToTime   proc    far               ;Beginning of routine.

            push    bp
            mov     bp,sp

            lea     si,Max8Buf        ;Find our output buffer.
            push    si
            add     si,04             ;Point to data area.
            mov     [si - 02],si      ;Put address of data area in.

            mov     bx,[bp + 06]

            mov     dx,000AH

            mov     ax,bx
            and     ax,0F800H
            jz      R1
            mov     cl,11
            shr     ax,cl
            div     dl
        R1: add     ax,3030H
            mov     [si],al
            inc     si
            mov     [si],ah
            inc     si

            inc     si

            mov     ax,bx
            and     ax,07E0H
            jz      r2
            mov     cl,5
            shr     ax,cl
            div     dl
        R2: add     ax,3030H
            mov     [si],al
            inc     si
            mov     [si],ah
            inc     si
            
            inc     si

            mov     ax,bx
            and     ax,001FH
            jz      R3
            shl     ax,1
            div     dl
        R3: add     ax,3030H
            mov     [si],al
            inc     si
            mov     [si],ah

            pop     ax

            pop     bp
            ret     2                 ;Pop-return past our input parameter.

IntToTime   endp                      ;End of routine.

End


