' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will alter the Life & Death Count of a file.
        '
        ' Each user above a specified security level can alter the L&D
        ' Count of one file each day.
        '
        ' Users cannot modify files for which they uploaded.  They may
        ' try to keep it up by increasing the L&D count.  They also
        ' may upload bad stuff knowing that they can help speed it's
        ' removal.
        '
        ' A user may only delete a file when all of the below are
        ' true:
        '   They have high enough SL.
        '   There is less than a defined number of bytes on the drive.
        '   It's toggled on.
        '   The L&D count is currently at zero.
        '
        ' A user may not increase the count if it is 9, +9, or blank.
        ' Since this is like stopping daily auto-reduction.
        '
        ' Date last checked for perfection: Sep 3 1992
        '
SUB LifeDeath

  IF LogonDate = User.AlterDate THEN TT = 418 : _
                                     CALL SendTT : _
                                     EXIT SUB
  TT = 419
  CALL SendTT
  CALL GetFileName(K$,K0)
  IF K0 < 1 THEN EXIT SUB
  K2 = FileOpen(FileNames$(4))
  CALL FileGetRec(K2,FileIDX.FRec,119,FileList)
  IF FileList.UserName = User.UserName THEN TT = 420 : _
                                            CALL SendTT : _
                                            CALL FileClose(K2) : _
                                            EXIT SUB
  SELECT CASE FileList.LDCount
    CASE 10       : TT$ = Short$(603)
    CASE IS < 10  : TT$ = STR$(FileList.LDCount * 2 + 2) + Short$(604)
    CASE 11 TO 28 : TT$ = STR$(FileList.LDCount * 3 - 11) + Short$(605)
  END SELECT
  TT$ = BlockText2(421) + LTRIM$(TT$) + BlockText2(422)
  CALL SendTT
  CALL TGet(Short$(606) + C13$)
  K1 = FileList.LDCount
  SELECT CASE TGot
    CASE 73
         TT = 423
         CALL SendTT
         SELECT CASE FileList.LDCount
           CASE 0 TO 8, 11 TO 27 : FileList.LDCount = FileList.LDCount + 1
           CASE 9, 10, 28 : TT = 424
                            CALL SendTT
         END SELECT
    CASE 68
         TT = 425
         CALL SendTT
         SELECT CASE FileList.LDCount 
           CASE 1 TO 9, 12 TO 28 : FileList.LDCount = FileList.LDCount - 1
           CASE 10 : IF FileList.FArea = 1 THEN FileList.LDCount = 9 _
                                           ELSE FileList.LDCount = 28
           CASE 11 : FileList.LDCount = 9
           CASE 0
                K = -1
                IF NOT BitTest(Toggles(1),1) THEN TT = 426 : _
                                                  CALL SendTT : _
                                                  K = 0
                IF DriveSpc&(FileBases(1).Path) >= Settings.LDDelSpace _
                   THEN TT$ = BlockText2(427) + Commas$(Settings.LDDelSpace) + _
                              BlockText2(453) : _
                        CALL SendTT : _
                        K = 0
                IF Levels(UserSL).SecLevel < Settings.LDDelSL _
                   THEN TT$ = BlockText2(428) + STR$(Settings.LDDelSL) + _
                              BlockText2(466) : _
                        CALL SendTT : _
                        K = 0
                IF FileList.FArea > 1 THEN TT = 429 : _
                                           CALL SendTT : _
                                           K = 0
                IF K THEN TT$ = BlockText2(430) + RTRIM$(FileList.FName) + Short$(221) : _
                          IF GetYNTT THEN CALL FileClose(K2) : _
                                          CALL RemoveFile(FileList.FName) : _
                                          TT$ = BlockText2(4) : _
                                          User.AlterDate = LogonDate _
                                     ELSE K = 0
                IF NOT K THEN TT$ = BlockText2(431)
                CALL SendTT
                CALL FileClose(K2)
                EXIT SUB
         END SELECT
    CASE ELSE
         TT = 10637
         CALL SendTT
         CALL FileClose(K2)
         EXIT SUB
  END SELECT
  SELECT CASE K1
    CASE 0        : TT$ = Short$(609)
    CASE 1 TO 9   : TT$ = STR$(K1 * 2 + 2) + Short$(214) + AscChr$(K1 + 48)
    CASE 10       : TT$ = Short$(611)
    CASE 11 to 19 : TT$ = STR$(K1 * 3 - 11) + Short$(612) + AscChr$(68 - K1)
    CASE 20 TO 28 : TT$ = STR$(K1 * 3 - 11) + Short$(613) + AscChr$(K1 + 29)
  END SELECT
  IF FileList.LDCount <> K1 THEN User.AlterDate = LogonDate
  SELECT CASE FileList.LDCount
    CASE 10       : K$ = Short$(603)
    CASE IS < 10  : K$ = STR$(FileList.LDCount * 2 + 2) + Short$(604)
    CASE 11 TO 28 : K$ = STR$(FileList.LDCount * 3 - 11) + Short$(605)
  END SELECT
  TT$ = BlockText2(432) + LTRIM$(TT$) + BlockText2(408) + LTRIM$(K$) + _
        BlockText2(414)
  CALL SendTT
  CALL FilePutRec(K2,FileIDX.FRec,119,FileList)
  CALL FileClose(K2)

END SUB
        '
        '* * * *

