' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' This file contains:
'   Login
'   GetPassword
'   GetCityState
'   RingBackVerify




        '* * * * * *
        ' Handles the logging in of a user--get their name, password,
        ' etc.
        '
        ' p  returns -1 if should hangup/etc.
        '
        ' Date last checked for perfection: Sep 18 1992
        '
SUB Login (p)

  '
  ' Load up the NOTNAMES.TXT file.
  '
  K0 = FileOpen(FileNames$(78))
  K1$ = SPACE$(FileLof&(K0,1))
  CALL FileGetSLoc(K0,0&,K1$)
  K1$ = C10$ + UCASE$(K1$)
  CALL FileClose(K0)
  '
  ' Strip leading and trailing spaces.
  '
  CALL ReplaceCharacters(K1$,-2,C10$ + C32$,10)
  CALL ReplaceCharacters(K1$,-2,C32$ + C13$,13)
  '
  ' Begin actual login session.
  '
  p = -1
  LogonTime$ = TIME$
  IF BitTest(Toggles(2),16) THEN TT = 10200 : _
                                 CALL SendTT
  CALL DispFile(FileNames$(68),C13$)
  K0 = 0
  K1 = 0
  DO
    DO
      User.UserName = Null$
      IF K0 > Settings.MaxLAttempts THEN EXIT SUB
      K0 = K0 + 1
      IF NoCarrier THEN EXIT SUB
      TT = 300
      LESpecial = 2
      IF K1 THEN K$ = LineEditTT$(30) _
            ELSE CALL GetUserNameTT(K$,K2) : _
                 LESpecial = 0
      K2 = Crunch(K$)
      K$ = LEFT$(K$,K2)
      IF NoCarrier THEN EXIT SUB
      CALL DispCRLF
      K2 = -1
      SELECT CASE StrSrch1(K$,32)
        CASE 0
             IF StrSrch(1,K1$,C10$ + K$ + C13$) > 0 THEN K$ = Null$
             SELECT CASE LEN(K$)
               CASE 0 : K1 = -1
                        K2 = 0
               CASE ELSE
                    IF NOT BitTest(Toggles(2),14) _
                       THEN TT = 301 : _
                            LESpecial = 2 : _
                            K0$ = RTRIM$(LTRIM$(LineEditTT$(30))) : _
                            CALL DispCRLF : _
                            IF LEN(K0$) > 1 THEN K$ = K$ + C32$ + K0$ _
                                            ELSE K2 = 0
                    IF NoCarrier THEN EXIT SUB
             END SELECT
      END SELECT
      '
      ' Disallow 2 letter, or fewer, names.  Also turns off auto-name-detect.
      '
      IF StrSrch(1,K1$,C10$ + K$ + C13$) > 0 THEN K$ = Null$
      IF LEN(K$) < 3 THEN K1 = -1 : _
                          K2 = 0
    LOOP UNTIL K2
    CALL DispCRLF
    K2 = BiSearch(5,0,Form$(3001,K$))
    SELECT CASE K2
      CASE IS > 0
           '
           ' Old user found.
           '
           IF DriveSpc&(FileNames$(1)) < 2049 THEN TT = 73 : _
                                                   CALL SendTT : _
                                                   TT = 67 : _
                                                   CALL LogTT : _
                                                   EXIT SUB
           K0 = FileOpen(FileNames$(1))
           CALL FileGetRec(K0,K2,384,User)
           CALL FileClose(K0)
           K0 = FileOpen(FileNames$(3))
           CALL FileGetSLoc(K0,1& * (K2 - 1) * LEN(UserMsgInfo$),UserMsgInfo$)
           CALL FileClose(K0)
           IF (User.UserName = Settings.Sysop OR BitTest(User.Attr,9)) _
              AND CommPort > 0 _
              THEN TT$ = C7$ + C7$ + C7$ : _
                   CALL AnsiTT
           IF LogonDate <> User.LastDateOn THEN User.Elapsed = 0
           K0 = 3
           CALL GetPassword(K0)
           IF K0 <> 0 THEN p = 0
           IF K0 = 0 THEN User.UserName = Null$ : _
                          IF NOT K1 THEN K1 = -1 _
                                    ELSE EXIT SUB
      CASE ELSE
           '
           ' New user processing.
           '
           K2 = 0
           IF NOT BitTest(Toggles(1),2) _
              OR FileLof&(Handle(21),32) = Settings.MaxUsers _
              THEN K2 = 1
           SELECT CASE K2
             CASE 1
                  TT = 96
                  CALL SendTT
                  TT = 98
                  CALL LogTT
                  EXIT SUB
             CASE ELSE
                  TT = 302
                  CALL SendTT
                  IF DriveSpc&(FileNames$(1)) < Settings.MinSpace _
                     OR NOT BitTest(Toggles(1),2) _
                     THEN TT = 57 : _
                          CALL LogTT : _
                          TT = 119 : _
                          CALL SendTT : _
                          CALL HangUp
                  TT$ = BlockText2(303) + NCR$(K$) + Short$(221)
                  SELECT CASE GetYNTT
                    CASE 0
                         TT$ = GetLine$(305) + K$
                         CALL LogTT
                    CASE ELSE
                         K4 = FileOpen(FileNames$(1))
                         CALL FileGetRec(K4,1,384,User)
                         CALL FileClose(K4)
                         IF BitTest(Toggles(2),13) THEN CALL GetCityState
                         CALL DispCRLF
                         CALL GetPassword(1)
                         IF NoCarrier THEN EXIT SUB
                         CALL DispFile(FileNames$(58),Null$)
                         User.UserName = K$
                         User.LastDateOn = LogonDate
                         User.FirstCall = LogonDate
                         K3 = FileOpen(FileNames$(1))
                         K2 = FileLof&(K3,384) + 1
                         CALL FilePutRec(K3,K2,384,User)
                         CALL FileClose(K3)
                         K3 = FileOpen(FileNames$(3))
                         CALL FileGetSLoc(K3,0&,UserMsgInfo$)
                         CALL FileClose(K3)
                         MID$(UserMsgInfo$,1,4) = MKL$(MsgBases(0).NextNumber - 1)
                         CALL SharedWriteEOF(3,-1,UserMsgInfo$)
                         CALL SharedWriteEOF(5,-1,STRING$(99,0))
                         UserIDX.UserName = User.UserName
                         UserIDX.RecNum = K2
                         CALL FilePutRec(Handle(21),FileLof&(Handle(21),32) + 1,32,UserIDX)
                         CALL FileSort(Handle(21),32)
                         MessageBody$ = Short$(503) + Settings.AINewUserMsg
                         IF K1 THEN MessageBody$ = MessageBody$ + _
                                                   GetLine$(306)
                         IF Settings.AINewUserMsg <> Short$(503) _
                            THEN CALL ComputerSend(UserIDX.UserName) : _
                                 MID$(UserMsgInfo$,BasesSize * 4 + 5,1) = C1$
                         TGot$ = Null$
                         CALL Paused
                         p = 0
                  END SELECT
           END SELECT
    END SELECT
  LOOP UNTIL p = 0
  IF BitTest(User.Attr,2) THEN p = -1 : _
                               EXIT SUB
  SELECT CASE User.PswdChange
    CASE C1$
         CALL DispCRLF
         CALL DispCRLF
         CALL DispBlockText(61,Null$)
         DO
           K$ = User.Password
           CALL GetPassword(2)
           IF NoCarrier THEN User.Password = K$ : _
                             User.PswdChange = C1$ : _
                             p = -1 : _
                             K0 = FileOpen(FileNames$(1)) : _
                             CALL FileGetRec(K0,K2,384,User) : _
                             CALL FileClose(K0) : _
                             EXIT SUB
         LOOP UNTIL K$ <> User.Password
  END SELECT
  IF User.PswdChange <> C0$ _
     THEN User.PswdChange = AscChr$(AscVal(User.PswdChange) - 1)
  UserSL = MappedSL(User.SecLevel)
  User.logons = User.logons + 1
  IF BitTest(User.Attr,6) AND NOT BitTest(Toggles(2),8) _
     THEN Handle(1) = FileOpen(FileNames$(51))
  IF BitTest(User.Attr,6) OR BitTest(Toggles(2),8) _
     THEN TT$ = C1310$ + GetLine$(858) + NCR$(User.UserName) + Short$(256) + _
          IntToDate3$(LogonDate) + Short$(137) + TIME$ + Short$(257) + C1310$ : _
          IF DriveSpc&(FileNames$(51)) > Settings.MinSpace _
             THEN CALL FilePutSEnd(Handle(1),TT$)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will get a new user password or a regular
        ' password.
        '
        ' p  1 for new user's password.
        '    2 for active user changing password.
        '    3 for active user's logon password.
        '    For p = 1 and 2:
        '      Keeps asking until they enter the same answer twice, or
        '      they hang up.  If they hung up, then the password isn't
        '      changed.  p isn't altered.
        '    For K = 3:
        '      p returns's with -1 if user entered correct password,
        '      else a 0 is returned.  Will only do
        '      Settings.MaxPAttempts bad attempts before returning a 0.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB GetPassword (p)

  SELECT CASE p
    CASE 1, 2
         DO
           TT = 128
           K$ = UCASE$(LineEditTT$(15))
           TT = 129
           K1$ = UCASE$(LineEditTT$(15))
           CALL DispCRLF
           SELECT CASE K1$
             CASE K$
                  IF UserSL = 1 THEN K0 = Settings.MinPassAllUsers _
                                ELSE K0 = Settings.MinPassRegUsers
                  IF LEN(K$) < K0 THEN K$ = Null$ : _
                                       TT$ = BlockText2(130) + STR$(K0) + BlockText2(132) : _
                                       CALL SendTT : _
                                       K1$ = Short$(404)
             CASE ELSE
                  TT = 133
                  CALL SendTT
           END SELECT
           IF NoCarrier THEN EXIT SUB
         LOOP UNTIL K1$ = K$
         IF p = 2 THEN TT$ = GetLine$(74) + RTRIM$(User.Password) : _
                       CALL LogTT
         User.Password = LTRIM$(K$)
         IF p = 2 THEN TT = 179 : _
                       CALL SendTT : _
                       K0 = FileOpen(FileNames$(1)) : _
                       CALL FileGetRec(K0,1,384,AnyUser) : _
                       CALL FileClose(K0) : _
                       User.PswdChange = AnyUser.PswdChange
    CASE 3
         p = 0
         LESpecial = -1
         K0$ = RTRIM$(User.Password)
         DO
           TT = 135
           K1$ = LTRIM$(LineEditTT$(15))
           SELECT CASE K0$
             CASE IS <> K1$
                  K0 = AscVal(User.Attempts)
                  p = p + 1
                  SELECT CASE RTRIM$(K1$)
                    CASE Null$ : p = Settings.MaxPAttempts
                    CASE ELSE
                         IF K0 <> 255 AND NOT NoCarrier _
                            THEN User.Attempts = AscChr$(K0 + 1) : _
                                 K0 = FileOpen(FileNames$(1)) : _
                                 CALL FilePutRec(K0,BiSearch(5,0,User.UserName),384,User) : _
                                 CALL FileClose(K0) : _
                                 TT$ = NCR$(User.UserName) + GetLine$(136) + K1$ : _
                                 CALL LogTT
                         IF BitTest(Toggles(1),8) AND User.UserName = Settings.Sysop _
                            THEN TT = 137 : _
                                 CALL SendTT : _
                                 CALL HangUp _
                            ELSE TT = 138 : _
                                 CALL SendTT
                  END SELECT
                  SELECT CASE p
                    CASE IS < Settings.MaxPAttempts
                         IF BitTest(User.Toggles,6) _
                            THEN TT$ = BlockText2(139) + STR$(LEN(K0$)) + _
                                       BlockText2(140) + LEFT$(K0$,1) + _
                                       Short$(405) _
                            ELSE TT$ = Null$
                    CASE ELSE : TT = 32
                  END SELECT
                  CALL SendTT
           END SELECT
         LOOP UNTIL p = Settings.MaxPAttempts OR K0$ = K1$ OR NoCarrier
         LESpecial = 0
         IF K0$ = K1$ AND NOT NoCarrier THEN p = -1 _
                                        ELSE p = 0
  END SELECT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will get and alter the user's location field.
        '
        ' Date last checked for perfection: Sep 3 1992
        '
SUB GetCityState

  TT = 127
  LESpecial = 3
  K$ = UCASE$(LineEditTT$(30))
  IF LEN(K$) > 0 THEN K = Crunch(K$) : _
                      User.CityState = LEFT$(K$,K)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine handles call-back verification of phone
        ' numbers.
        '
        ' Date last checked for perfection: Sep 15 1992
        '
SUB RingBackVerify
  '
  ' Display what's going on.  the weirdness with the number creation is because
  ' any kind of quick calling with GetRndNum is likely to return the same
  ' numbers.
  '
  K0$ = STR$(GetRndNum(9))
  TT$ = GetBlock$(34)
  K0$ = K0$ + LTRIM$(STR$(GetRndNum(9)))
  K0$ = K0$ + LTRIM$(STR$(GetRndNum(9)))
  CALL SendTT
  K0$ = K0$ + LTRIM$(STR$(GetRndNum(9)))
  TT$ = K0$ + BlockText2(707)
  CALL SendTT
  K$ = Null$
  IF User.HomePhone <> 0 THEN K$ = IntToPhone$(User.HomePhone) : _
                              TT$ = BlockText2(708) + K$ + Short$(78) : _
                              IF NOT GetYNTT THEN K$ = Null$
  IF User.BBSPhone <> 0 AND LEN(K$) = 0 _
     THEN K$ = IntToPhone$(User.BBSPhone) : _
          TT$ = BlockText2(708) + K$ + Short$(78) : _
          IF NOT GetYNTT THEN K$ = Null$
  DO
    IF LEN(K$) = 0 THEN DO : _
                          TT = 709 : _
                          CALL SendTT : _
                          CALL GetPhoneNumber(0) : _
                          User.HomePhone = TT& : _
                          K$ = IntToPhone$(User.HomePhone) : _
                        LOOP UNTIL LEN(K$) > 0 OR NoCarrier : _
                        TT$ = BlockText2(697) + K$ + Short$(78) : _
                        IF NOT GetYNTT THEN K$ = Null$
    K1$ = IntToPhone$(Settings.Phone)
    IF LEN(K$) > 8 AND NOT BitTest(Toggles(1),12) AND LEFT$(K$,3) <> LEFT$(K1$,3) _
       THEN TT = 710 : _
            CALL SendTT : _
            K$ = Null$
    IF RIGHT$(K$,8) = RIGHT$(K1$,8) THEN K$ = Null$
    IF NoCarrier THEN EXIT SUB
  LOOP UNTIL LEN(K$) > 0
  TT = 711
  CALL SendTT
  CALL HangUp
  CALL ContactPhoneNumber(K$)
  IF NoCarrier THEN EXIT SUB
  K$ = MID$(K$,3)
  TT$ = Short$(236) + NCR$(User.UserName) + BlockText2(712)
  K = Settings.TimeOut
  Settings.TimeOut = Settings.LogoTimeOut
  K1$ = RTRIM$(LTRIM$(LineEditTT$(30)))
  IF LTRIM$(K0$) <> K1$ _
     THEN TT = 713 : _
          CALL SendTT : _
          CALL HangUp : _
          TT$ = NCR$(User.UserName) + GetLine$(714) + K$ + Short$(379) : _
          CALL LogTT : _
          Settings.TimeOut = K : _
          EXIT SUB
  TT = 715
  CALL SendTT
  SELECT CASE BitTest(User.Attr,14)
    CASE -1
         CALL DispBlockText(61,Null$)
         DO
           K0$ = User.Password
           CALL GetPassword(2)
           IF NoCarrier THEN User.Password = K0$ : _
                             Settings.TimeOut = K : _
                             EXIT SUB
         LOOP UNTIL K0$ <> User.Password
  END SELECT
  IF BitTest(Toggles(1),11) THEN TT = 716 : _
                                 CALL SendTT : _
                                 CALL Paused : _
                                 CALL HangUp
  TT$ = NCR$(User.UserName) + GetLine$(717) + K$ + Short$(379)
  CALL LogTT
  Settings.TimeOut = K
  CALL BitClear(User.Attr,13)
  CALL BitClear(User.Attr,14)
  IF Settings.PostRingSL <> 0 THEN User.SecLevel = Settings.PostRingSL

END SUB
        '
        '* * * *


