' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' Overlaid  routines from MainLoop module:
'  MainLoop2
'  ReInit
'  StartUp




        '* * * * * *
        ' This routine displays various parts of the WFC screen.
        '
        ' p   which of the screens to put up.
        ' p0  current help page being displayed.  Or which to do.
        ' p1  current line in callers log file.
        '
        ' Date last checked for perfection: Sep 26 1992 
        '
SUB MainLoop2 (p,p0,p1)

  SELECT CASE p
    CASE 1
         IF p0 = 0 THEN p0 = 1 : _
                        TT = 10067 : _
                        CALL AnsiTT
         SELECT CASE p0
           CASE 1
                '
                ' Display the drive space.
                '
                TT$ = Short$(684)
                FOR K2 = 1 to 5
                  TT$ = TT$ + AnsiLocStr$(K2 + 1,1)
                  SELECT CASE AscVal(MID$(Settings.DrDrives,K2,1))
                    CASE 32 : TT$ = TT$ + Short$(142)
                    CASE ELSE
                         K& = DriveSpc&(MID$(Settings.DrDrives,K2,1))
                         TT$ = TT$ + Short$(686) + MID$(Settings.DrDrives,K2,1)
                         IF K& <= Settings.MinSpace _
                            AND MID$(Settings.DrDrives,K2,1) <> LEFT$(Paths$(4),1) _
                            THEN K4 = 944 _
                            ELSE K4 = 687
                         TT$ = TT$ + Short$(K4) + Form$(1301,Commas$(K&)) + Short$(173)
                  END SELECT
                NEXT
           CASE ELSE
                TT$ = GetLine$(795) + Form$(1002,Commas$(FRE(-1))) + _
                      GetLine$(796) + Form$(702,Commas$(FRE(0))) + _
                      GetLine$(797) + Form$(802,Commas$(FRE(-2))) + Short$(740)
         END SELECT
         CALL AnsiTT
    CASE 2
         '
         ' Display the help pages.
         '
         k = FileOpen(FileNames$(7) + Form4$(3,1))
         k& = BlockText&(29) - 1
         k0 = 0
         DO
           k0 = k0 + 1
           FWork(k0).FSize = k&
           FOR k1 = 1 TO 6
             k$ = FileGetLine$(k,k&)
           NEXT
           k0& = k&
           k$ = FileGetLine$(k,k0&)
         LOOP UNTIL k& = -1 OR Val2&(LEFT$(k$,2)) <> 29
         IF p0 > k0 THEN p0 = 1
         IF p0 < 1 THEN p0 = k0
         k& = FWork(p0).FSize
         TT$ = Null$
         FOR k1 = 1 TO 6
           k$ = FileGetLine$(k,k&)
           TT$ = TT$ + AnsiLocStr$(k1,19)
           IF k& = -1 OR Val2&(LEFT$(k$,2)) <> 29 OR LEN(k$) = 2 _
              THEN TT$ = TT$ + GetLine$(607) _
              ELSE TT$ = TT$ + MID$(k$,3)
         NEXT
         CALL FileClose(k)
         CALL AnsiTT
    CASE 3
         '
         ' Display the callers log.
         '
         K4 = FileOpen(FileNames$(25))
         K& = FileLof&(K4,1)
         SELECT CASE K&
           CASE IS > 1
                TT = 10182
                CALL AnsiTT
                FOR K2 = 13 TO p1 + 11
                  K1$ = FileGetLineR$(K4,K&)
                NEXT
                K2$ = RTRIM$(Settings.LogLeader)
                FOR K2 = 13 TO 23
                  K3$ = Form$(7801,FileGetLineR$(K4,K&)) + Short$(1033)
                  IF LEFT$(K3$,LEN(K2$)) = K2$ _
                     THEN TT$ = Short$(184) + K3$ _
                     ELSE TT$ = Short$(988) + K3$
                  CALL AnsiTT
                NEXT
         END SELECT
         CALL FileClose(K4)
  END SELECT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to WFC, re-initializes the fossil and
        ' modem.
        '
        ' Date last checked for perfection: Sep 21 1992
        '
SUB ReInit

  CommPort = Settings.CommPort
  '
  'Make sure a fossil is installed, exit with message if not, otherwise it
  'will be turned on.
  '
  IF FosIntAX(CommPort,&H1C00) <> &H1954 AND CommPort <> 0 _
     THEN TT$ = C1310$ + C1310$ + GetLine$(65) + C1310$ : _
          CALL AnsiTT : _
          CALL Delay : _
          CALL ShellDos(9,Null$)
  '
  ' Re-init fossil for HST or 2400 modems.
  '
  IF BitTest(Toggles(2),10) THEN K = FosIntAX(CommPort,Settings.Init9600) _
                            ELSE K = FosIntAX(CommPort,Settings.Init2400)
  CALL CommOut(GetLine$(626) + C1310$)                 'ATZ
  CALL Delay
  CALL PurgeComIO(CommPort)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine handles the getting/accepting of the modem's
        ' CONNECT string.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB StartUp
  '
  ' Retrieve the connect string from the modem.
  '
  SELECT CASE CommPort
    CASE IS > 0
         K0 = FileOpen(FileNames$(74))
         K1 = FileLof&(K0,52) + 8
         K& = -52
         FOR K = 9 TO K1
           K& = K& + 52
           SWork$(K) = SPACE$(52)
           CALL FileGetSLoc(K0,K&,SWork$(K))
           Work(K) = CVI(MID$(SWork$(K),31,2))
         NEXT
         CALL FileClose(K0)
         Connect$ = Null$
         ConnectCPS = -1
         K$ = TIME$
         K1$ = Null$
         DO
           K3 = -3
           K = CommIn(K3)
           IF K3 <> 0 THEN K = -1
           SELECT CASE K
             CASE 13
                  K2 = 0
                  ConnectCPS = -1
                  FOR K0 = 9 TO K1
                    K0$ = RTRIM$(LEFT$(SWork$(K0),30))
                    IF StrSrch(1,Connect$,K0$) > 0 AND LEN(K0$) > K2 _
                       THEN ConnectCPS = K0 : _
                            K2 = LEN(K0$)
                  NEXT
                  IF ConnectCPS >= 0 _
                     THEN Connect$ = RTRIM$(RIGHT$(SWork$(ConnectCPS),20)) : _
                          ConnectCPS = Work(ConnectCPS)
                  K1$ = K1$ + Short$(987)
             CASE IS > 31
                  K1$ = K1$ + AscChr$(K)
                  Connect$ = Connect$ + AscChr$(K)
                  IF StrSrch(1,Connect$,Short$(899)) > 0 THEN Connect$ = Null$
           END SELECT
           '
           ' Display text OR show modem status 'line'.  Doing both is too slow.
           '
           IF K > 31 OR K = 13 _
              THEN TT$ = Short$(185) + RIGHT$(K1$,39) _
              ELSE K2 = FosIntAX(CommPort,&H300) : _
                   TT$ = SWork$(4 + BitTest(K2,5)) + _
                         SWork$(6 + BitTest(K2,6)) + _
                         SWork$(2 + BitTest(K2,7)) + _
                         SWork$(8 + BitTest(K2,8))
           CALL AnsiTT
           '
           ' 300/1200 baud callers are just ignored until we time-out, or they
           ' hangup.
           '
         LOOP UNTIL ElapsedTime(K$,K) = Settings.LogoTimeOut OR NoCarrier _
                    OR LEN(Connect$) = 78 OR ConnectCPS <> -1
         Connect$ = LEFT$(Connect$,20)        'Get enough to show what we want.
         IF ConnectCPS = -1 AND NOT BitTest(Toggles(2),15) THEN CALL HangUp : _
                                                                EXIT SUB
    CASE ELSE : Connect$ = GetLine$(403)
                ConnectCPS = 11500
  END SELECT
  '
  ' Set some 'safety' defaults.
  '
  K = FileOpen(FileNames$(1))
  CALL FileGetRec(K,1,384,User)
  CALL FileClose(K)
  User.SecLevel = 0
  User.UserName = Null$
  UserSL = 1
  FileIndex = 1
  '
  ' If a shuttle logon system is used, then we first use line 2 of MENUTEXT.DAT,
  ' otherwise we use line 1.
  '
  K = FileOpen(FileNames$(35))
  CALL FileGetRec(K,1 - BitTest(Toggles(2),1),38,Menu)
  CALL FileClose(K)

END SUB
        '
        '* * * *

