' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' This file contains routines that are internal to EnterMsgs and/or
' ReadMsgs.
'   EnterMsgHeader
'   GetMsgHdrStuff
'   DispMsgHdrStuff
'   ReDrawMsgScreen
'   MsgErrorBoxOutTT
'   ScrollCCScreen
'   WipeMsgHdrWindow
'   SaveMessageFile
'   DoFileAttach
'   GetBBSAddr
'




        '* * * * * *
        ' This routine is the first half of the EnterMsg routine.
        ' This half gets information about the message, and handles
        ' the getting of text prior to the start of editing.
        '
        ' p    flag for whether this is a reply or not (it's the only
        '      passed variable that can be, and is, altered and used).
        '
        ' p$   contains who the message is to (if any).
        '
        ' p0$  contains the message subject (if any).
        '
        ' p0   returns -1 if message was aborted.
        '
        ' BaseIndex is assumed to be the area to put the message, but
        ' loses reliablity as a variable for that once the initial
        ' information display is done (since one can change the area
        ' in which the message is put), Message.MsgBase is then used.
        '
        ' Date last checked for perfection: Nov 19 1992
        '
SUB EnterMsgHeader (p0,p,p$,p0$)

  IF BaseIndex = 32767 THEN p0 = -1 : _
                            EXIT SUB
  IF DriveSpc&(FileNames$(2)) < Settings.MinSpace THEN TT = 123 : _
                                                       CALL SendTT : _
                                                       p0 = -1 : _
                                                       EXIT SUB
  Message.Attr        = p
  Message.MsgTo       = p$
  Message.MsgFrom     = User.UserName
  Message.MsgSubject  = p0$
  Message.MsgBase     = BaseIndex
  Message.MsgNum      = MsgBases(Message.MsgBase).NextNumber
  Message.MsgDateRcvd = 0
  Message.MsgDateSent = LogonDate
  Message.NetAttr     = 0
  IF BitTest(MsgBases(Message.MsgBase).SubType,1) _
     THEN Message.MsgFrom = Short$(718)
  IF BitTest(MsgBases(Message.MsgBase).SubType,6) _
     OR RTRIM$(Message.MsgTo) = Short$(718) _
     THEN Message.MsgTo = Short$(717)
  IF AscVal(Message.MsgTo) = 2 THEN Message.MsgTo = Settings.Sysop : _
                                    CALL BitSet(Message.Attr,10)
  IF RTRIM$(Message.MsgTo) <> Short$(717) AND LEN(RTRIM$(Message.MsgTo)) > 0 _
     AND NOT BitTest(MsgBases(Message.MsgBase).SubType,3) _
     THEN IF BiSearch(2,0,Message.MsgTo) < 1 THEN p0 = -1 : _
                                                  EXIT SUB
  K3$ = Null$
  ' K9 : 3 bits:
  '      1 upload/import the message.
  '      2 quote the message.
  '      3 cc's
  K9 = 0
  CALL ReDrawMsgScreen(K9,p0,k3$,nn$)
  IF LEN(RTRIM$(Message.MsgTo)) = 0 THEN CALL GetMsgHdrStuff(5,p0,K3$) : _
                                         IF p0 = -1 THEN EXIT SUB
  IF LEN(RTRIM$(Message.MsgSubject)) = 0 THEN CALL GetMsgHdrStuff(6,p0,K3$) : _
                                              IF p0 = -1 THEN EXIT SUB
  '
  ' Work(0) contains the number of addressee's, Work(1..n) contains who it's
  ' to (based on their record number).
  '
  Work(0) = 1
  IF RTRIM$(Message.MsgTo) = Short$(717) _
     THEN Work(1) = 0 _
     ELSE Work(1) = BiSearch(5,0,Message.Msgto)
  nn$ = Null$
  CALL GetMsgHdrStuff(7,p0,nn$)
  IF p0 = -1 THEN EXIT SUB
  TT = 33
  CALL SendTT
  '
  ' Change any of the above settings.
  '
  pp = 0
  DO
    IF p0 = -1 THEN EXIT SUB
    CALL TGet(Short$(127) + C13$)
    IF NoCarrier THEN p0 = -1 : _
                      EXIT SUB
    SELECT CASE TGot
      CASE 73
           '
           ' Select a new message area.
           '
           CALL WipeMsgHdrWindow(1)
           K2 = 1
           FOR K1 = 0 TO BasesSize
             IF MsgBases(K1).PostSL <= Levels(UserSL).SecLevel _
                AND CVL(MID$(UserMsgInfo$,K1 * 4 + 1,4)) >= 0 _
                THEN SWork$(K2) = MsgBases(K1).Title : _
                     K2 = K2 + 1
           NEXT
           SWork$(K2) = Null$
           TT = 631
           CALL MenuSystemTT
           SELECT CASE TGot
             CASE IS > 0
                  FOR K1 = 0 TO BasesSize
                    IF SWork$(TGot) = RTRIM$(MsgBases(K1).Title) _
                       THEN Message.MsgBase = K1 : _
                            EXIT FOR
                  NEXT
                  Message.MsgNum = MsgBases(Message.MsgBase).NextNumber
                  IF BitTest(MsgBases(Message.MsgBase).SubType,1) _
                     THEN Message.MsgFrom = Short$(718) _
                     ELSE Message.MsgFrom = User.UserName
                  IF BitTest(MsgBases(Message.MsgBase).SubType,6) _
                     THEN Message.MsgTo = Short$(717)
                  IF RTRIM$(Message.MsgTo) <> Short$(717) _
                     AND LEN(RTRIM$(Message.MsgTo)) > 0 _
                     AND NOT BitTest(MsgBases(Message.MsgBase).SubType,3) _
                     THEN IF BiSearch(2,0,Message.MsgTo) < 1 _
                             THEN Message.MsgTo = Null$
           END SELECT
           IF BitTest(MsgBases(Message.MsgBase).SubType,3) _
              THEN Work(0) = 1 : _
                   Work(1) = -1 : _
                   CALL BitClear(K9,3)
           CALL ReDrawMsgScreen(K9,p0,k3$,nn$)
           IF LEN(RTRIM$(Message.MsgTo)) = 0 _
              THEN CALL GetMsgHdrStuff(5,p0,K3$) : _
                   IF p0 = -1 THEN EXIT SUB
           CALL GetMsgHdrStuff(7,p0,nn$)
           TT = 33
           CALL SendTT
      CASE 84 : IF p$ = Null$ AND NOT BitTest(Message.Attr,3) _
                   AND NOT BitTest(MsgBases(Message.MsgBase).SubType,6) _
                   THEN CALL GetMsgHdrStuff(5,p0,K3$)
      CASE 83 : IF p0$ = Null$ AND NOT BitTest(Message.Attr,3) _
                   THEN CALL GetMsgHdrStuff(6,p0,K3$)
      CASE 76 : CALL BitToggle(User.Toggles,2)
                TT = 862 + BitTest(User.Toggles,2)
                CALL SendTT
      CASE 81
           '
           ' Toggle quoting on/off.
           '
           IF BitTest(Message.Attr,3) _
              THEN SELECT CASE BitTest(K9,1) : _
                     CASE -1 : TT = 36 : _
                               CALL MsgErrorBoxOutTT : _
                     CASE ELSE : CALL BitToggle(K9,2) : _
                                 TT = 864 + BitTest(K9,2) : _
                                 CALL SendTT : _
                   END SELECT
      CASE 85
           '
           ' Toggle uploading on/off.
           '
           IF BitTest(K9,2) THEN TT = 36 : _
                                 CALL MsgErrorBoxOutTT _
                            ELSE CALL BitToggle(K9,1) : _
                                 TT = 866 + BitTest(K9,1) : _
                                 CALL SendTT
      CASE 65 : CALL GetBBSAddr(nn$,K9,p0,k3$)
      CASE 70
           '
           ' Handle file attaches.
           '
           SELECT CASE BitTest(K9,3)
             CASE -1 : TT = 38
                       CALL MsgErrorBoxOutTT
             CASE ELSE
                  CALL WipeMsgHdrWindow(3)
                  SELECT CASE BitTest(Message.Attr,12)
                    CASE -1
                         CALL BitClear(Message.Attr,12)
                         TT = 759
                         CALL SendTT
                         TT$ = Null$
                         CALL MsgErrorBoxOutTT
                    CASE ELSE
                         CALL BitSet(Message.Attr,12)
                         K& = DriveSpc&(Paths$(5))
                         TT$ = BlockText2(52) + Commas$(K&) + BlockText2(101)
                         CALL MsgErrorBoxOutTT
                         IF K& < Settings.MinULSpace _
                            THEN TT = 113 : _
                                 CALL MsgErrorBoxOutTT : _
                            ELSE CALL BitSet(Message.Attr,12) : _
                                 TT = 758 : _
                                 CALL SendTT : _
                                 CALL DispBlockText(62,C13$)
                  END SELECT
           END SELECT
      CASE 67
           '
           ' Handle CC's.
           '
           SELECT CASE BitTest(MsgBases(Message.MsgBase).SubType,3)
             CASE -1 : TT = 131
                       CALL MsgErrorBoxOutTT
             CASE ELSE
                  SELECT CASE BitTest(Message.Attr,12)
                    CASE -1 : TT = 38
                              CALL MsgErrorBoxOutTT
                    CASE ELSE
                         K8 = Work(0)
                         TT$ = Short$(148)
                         FOR z = 14 TO 23
                           SWork$(z) = SPACE$(31)
                           TT$ = TT$ + AnsiLocStr$(z,24) + SPACE$(31)
                         NEXT
                         CALL SendTT
                         SWork$(24) = SPACE$(31)
                         TT = 637
                         CALL SendTT
                         z = 15
                         K2 = FileOpen(FileNames$(1))
                         FOR K1 = 1 TO Work(0)
                           CALL FileGetRec(K2,Work(K1),384,AnyUser)
                           z$ = AnyUser.UserName
                           CALL WordsCase(z$)
                           SWork$(z) = Short$(203) + Form$(3001,z$)
                           TT$ = SWork$(z)
                           CALL SendTT
                           CALL ScrollCCScreen(z)
                         NEXT
                         CALL FileClose(K2)
                         SWork$(z) = GetLine$(638)
                         TT$ = SWork$(z)
                         CALL SendTT
                         CALL ScrollCCScreen(z)
                         DO
                           CALL CursorOn
                           CALL TGet(Short$(306) + C13$)
                           K2 = TGot
                           IF TGot = 43 OR TGot = 45 _
                              THEN K4$ = Short$(148) + TGot$ : _
                                   TT$ = K4$ : _
                                   LESpecial = 4 : _
                                   CALL GetUserNameTT(K2$,k1) : _
                                   LESpecial = 0
                           CALL CursorOff
                           IF K1 < 1 OR K2 < 43 THEN EXIT DO
                           SWork$(z) = K4$ + Form$(3005,K2$)
                           CALL ScrollCCScreen(z)
                           SELECT CASE K2
                             CASE 43
                                  Work(0) = Work(0) + 1
                                  Work(Work(0)) = K1
                             CASE 45
                                  FOR a = 2 TO Work(0)
                                    IF Work(a) = K1 _
                                       THEN Work(a) = Work(Work(0)) : _
                                            Work(0) = Work(0) - 1 : _
                                            EXIT FOR
                                  NEXT
                           END SELECT
                         LOOP UNTIL NoCarrier
                         IF Work(0) > 1 THEN CALL BitSet(K9,3) _
                                        ELSE CALL BitClear(K9,3)
                         IF NOT (K8 > 1 AND Work(0) > 1) _
                            THEN TT = 860 + BitTest(K9,3) : _
                                 CALL SendTT
                  END SELECT
           END SELECT
      CASE ELSE : pp = 1
    END SELECT
  LOOP UNTIL pp = 1
  K$ = Null$
  IF BitTest(K9,2) THEN CALL QuoteTheMessage _
                   ELSE MessageBody$ = Null$
  SELECT CASE BitTest(K9,1)
    CASE -1
         CALL WipeMsgHdrWindow(3)
         SELECT CASE CommPort
           CASE 0
                TT = 77
                K2$ = LineEditTT$(41)
                IF FindF(K2$,FFile) <> 0 THEN K$ = K2$ _
                                         ELSE p0 = -1
           CASE ELSE
                CALL AdjustProtocol(User.Protocol)
                K2$ = TT$
                TT$ = BlockText2(85) + _
                      RTRIM$(Form$(7908,MID$(TT$,20,34))) + BlockText2(502)
                CALL SendTT
                CALL SysopLine(17)
                CALL ShellDos(4,ProtocolUp$)
                CALL Delay                        'Delays for slow comm programs
                CALL Delay                        'with external protocols.
                CALL PurgeComIO(CommPort)
                CALL FileAppendToLog(MID$(K2$,54,40))
         END SELECT
         CALL ImportMessage(K$)
         K$ = C0$
  END SELECT

  p$ = K$
  p0$ = K3$ + nn$

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to EnterMsgHeader, handles the
        ' display and gathering of various fields.
        '
        ' K    what to do
        '
        ' K3$  DEST: reply string.
        '
        ' p0   returns -1 if message was aborted.
        '
        ' Date last checked for perfection: Nov 19 1992
        '
SUB GetMsgHdrStuff (K,p0,K3$)

  SELECT CASE K
    CASE 0
         '
         ' Message area info.
         '
         TT$ = GetLine$(265 + BitTest(MsgBases(Message.MsgBase).SubType,1)) + _
               GetLine$(258 + BitTest(MsgBases(Message.MsgBase).SubType,2))
         IF BitTest(MsgBases(Message.MsgBase).SubType,3) _
            AND NOT BitTest(MsgBases(Message.MsgBase).SubType,9) _
            THEN TT$ = TT$ + GetLine$(390) _
            ELSE TT$ = TT$ + GetLine$(391)
         TT$ = RTRIM$(Form$(8008,TT$))
         TT$ = Short$(266) + LTRIM$(STR$(LEN(TT$) - LEN(LTRIM$(TT$)))) + _
               Short$(214) + LTRIM$(TT$)
         CALL SendTT
         TT$ = BlockText2(599) + Form$(7001,MsgBases(Message.MsgBase).Title)
         CALL SendTT
    CASE 5
         '
         ' Get/update TO: line.
         '
         K0 = LEN(RTRIM$(Message.MsgTo))
         IF K0 > 0 THEN CALL DispMsgHdrStuff(11,p0,K3$)
         TT = 10287
         CALL SendTT
         CALL CursorOn
         IF NOT BitTest(MsgBases(Message.MsgBase).SubType,3) _
            THEN LESpecial = 3 : _
                 CALL GetUserNameTT(K2$,k3) : _
                 LESpecial = 0 _
            ELSE LESpecial = 2 : _
                 K2$ = UCASE$(LineEditTT$(30)) : _
                 k3 = 1
         CALL CursorOff
         K1 = LEN(K2$)
         IF (k3 = 0 AND K2$ <> Short$(717)) _
            OR (K2$ = Short$(717) AND BitTest(MsgBases(Message.MsgBase).SubType,2)) _
            THEN p0 = -1
         IF K1 = 0 AND K0 > 0 THEN CALL DispMsgHdrStuff(1,p0,K3$)
         IF K1 > 0 THEN Message.MsgTo = K2$ : _
                        IF K0 > K1 THEN TT$ = SPACE$(K0 - K1) : _
                                        CALL SendTT
         IF LEN(RTRIM$(Message.MsgTo)) = 0 THEN p0 = -1
    CASE 6
         '
         ' Get/update SUBJECT: line.
         '
         K0 = LEN(RTRIM$(Message.MsgSubject))
         IF K0 > 0 THEN CALL DispMsgHdrStuff(13,p0,K3$)
         TT = 10302
         CALL SendTT
         CALL CursorOn
         K2$ = LineEditTT$(70)
         CALL CursorOff
         K1 = LEN(K2$)
         IF K1 = 0 AND K0 > 0 THEN CALL DispMsgHdrStuff(3,p0,K3$)
         IF K1 > 0 THEN CALL StrXLate(K2$,HiStrip$) : _
                        Message.MsgSubject = Form1$(3,K2$)
         IF LEN(RTRIM$(Message.MsgSubject)) = 0 THEN p0 = -1
    CASE 7
         '
         ' If NetMail then get an address.  Not done for reply's, EchoMail, or
         ' normal mail.
         '
         CALL GetBBSAddr(nn$,K9,p0,k3$)
         Message.SourceAddr = Settings.Addr
         '
         ' If a private message without an address in a Private NetMail area,
         ' then move it.  (destaddr could be 0 or settings.addr, so we use nn$)
         '
         IF BitTest(MsgBases(Message.MsgBase).SubType,2) _
            AND BitTest(MsgBases(Message.MsgBase).SubType,3) AND LEN(nn$) = 0 _
            THEN Work(1) = BiSearch(5,0,Message.MsgTo) : _
                 IF Work(1) > 0 _
                    THEN Message.MsgBase = 0 : _
                         CALL ReDrawMsgScreen(K9,p0,k3$,nn$) : _
                         TT = 33 : _
                         CALL SendTT _
                    ELSE TT = 739 : _
                         CALL MsgErrorBoxOutTT : _
                         p0 = -1
         K3$ = nn$
  END SELECT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to EnterMsgHeader, handles the
        ' display of various fields.
        '
        ' K    what to do
        '
        ' K3$  DEST: reply string.
        '
        ' p0   returns -1 if message was aborted.
        '
        ' Date last checked for perfection: Nov 19 1992
        '
SUB DispMsgHdrStuff (K,p0,K3$)

  SELECT CASE K
    CASE 1, 11
         '
         ' Display the TO: field.
         '
         TT$ = Message.MsgTo
         CALL WordsCase(TT$)
         IF RTRIM$(TT$) = Short$(720) THEN TT$ = Form$(3001,BlockText2(111))
         TT$ = BlockText2(397 + (K = 1)) + TT$
         CALL SendTT
    CASE 2, 12
         '
         ' Display the AT: field.
         '
         K4 = 0
         IF NOT BitTest(MsgBases(Message.MsgBase).SubType,3) _
            OR BitTest(MsgBases(Message.MsgBase).SubType,9) _
            OR LEN(k3$) = 0 _
            THEN TT$ = Null$ _
            ELSE IF Message.DestAddr = Settings.Addr OR Message.DestAddr = 0 _
                    THEN TT$ = GetLine$(2) _
                    ELSE K4 = BiSearch(4,0,MKL$(Message.DestAddr)) : _
                         IF K4 > 0 THEN TT$ = Node.BBSName _
                                   ELSE TT$ = AddrToInt$(Message.DestAddr,k5,k6,k7)
         TT$ = BlockText2(450 + (K = 2)) + Form$(3505,TT$)
         CALL SendTT
         IF K4 > 0 AND K = 2 _
            THEN CALL WipeMsgHdrWindow(2) : _
                 TT$ = NCR$(Node.BBSName) + Short$(316) + _
                       AddrToInt$(Node.Addr,K4,K5,K6) + Short$(330) + _
                       IntToPhone$(Node.BBSPhone) : _
                 CALL SendTT
    CASE 3, 13
         '
         ' Display the SUBJECT: field.
         '
         TT$ = Null$
         IF BitTest(Message.Attr,3) _
            THEN TT$ = GetLine$(116) : _
                 K0 = StrSrch(1,MessageBody$,C1$ + Short$(929)) + 9 : _
                 IF K0 > 9 _
                    THEN K1 = StrSrch(K0,MessageBody$,C13$) : _
                         K3$ = C1$ + Short$(940) + _
                               MID$(MessageBody$,K0 - 1,K1 - K0 + 1) + C13$
         TT$ = BlockText2(469 + (K = 3)) + _
               Form$(7001,RTRIM$(UnSq$(Message.MsgSubject)) + TT$)
         CALL SendTT
  END SELECT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine redisplays the whole entering messages screen.
        '
        ' K9   various toggles
        '
        ' K3$  DEST: reply string.
        '
        ' p0   returns -1 if message was aborted.
        '
        ' Date last checked for perfection: Nov 19 1992
        '
SUB ReDrawMsgScreen (K9,p0,k3$,nn$)

  TT = 598
  CALL SendTT
  CALL GetMsgHdrStuff(0,p0,K3$)    'Show area info.
  CALL DispMsgHdrStuff(1,p0,K3$)   'Show TO: line.
  CALL DispMsgHdrStuff(2,p0,nn$)   'Show AT: line.
  CALL DispMsgHdrStuff(3,p0,K3$)   'Show SUBJECT: line.
  TT$ = BlockText2(866 + BitTest(K9,1)) + _
        BlockText2(759 + BitTest(Message.Attr,12)) + _
        BlockText2(862 + BitTest(User.Toggles,2)) + _
        BlockText2(864 + BitTest(K9,2)) + _
        BlockText2(860 + BitTest(K9,3))
  CALL SendTT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine displays a message in an area.
        '
        ' Date last checked for perfection: Nov 19 1992
        '
SUB MsgErrorBoxOutTT

  IF TT > 0 THEN TT$ = GetLine$(TT) : _
                 TT = 0
  TT$ = Short$(344) + TT$
  CALL SendTT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine displays/scrolls the CC's box.
        '
        ' Date last checked for perfection: Nov 19 1992
        '
SUB ScrollCCScreen (z)
  z = z + 1
  SELECT CASE z
    CASE 24
         TT$ = Null$
         FOR z = 15 TO 24
           SWork$(z - 1) = SWork$(z)
         NEXT
         FOR z = 14 TO 23
           TT$ = TT$ + AnsiLocStr$(z,24) + SWork$(z)
         NEXT
         TT$ = TT$ + AnsiLocStr$(23,24) + SPACE$(31) + AnsiLocStr$(23,24)
         CALL SendTT
         z = 23
  END SELECT
  TT$ = AnsiLocStr$(z,24)
  CALL SendTT
END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine clears the entering messages big window.
        '
        ' Date last checked for perfection: Nov 21 1992
        '
SUB WipeMsgHdrWindow (p)

  TT$ = Short$(347)
  FOR K = 1 TO 9
    TT$ = Short$(348) + TT$
  NEXT
  SELECT CASE p
    CASE 1 : TT$ = Short$(361) + TT$
    CASE 2 : TT$ = Short$(362) + TT$ + BlockText2(134)
    CASE 3 : TT$ = Short$(362) + TT$
  END SELECT
  CALL SendTT

END SUB
        '
        '* * * *





        '* * * * * *
        ' This routine will save the current message (in MessageBody$)
        ' to a message file.
        '
        ' p  0 to create messages of MESSAGE.001 to MESSAGE.999.
        '    1 to create messages of MESSAGE.P01 to MESSAGE.P99--using
        '      the first available slot.
        '    returns with the file number the message was stored in.
        '
        ' Message files are of the form: MESSAGE.xxx, where xxx is
        ' pretty much anything--but I've always envisioned it as .001
        ' to .999, except for a few special-use ones.  They are
        ' inserted into a message with the phrase '%%%xxx' (anywhere
        ' in the message, no quotes).  xxx must always be 3 characters
        ' long.
        '
        ' It gives the new message the next higher message number, not
        ' the first available message number.  If there is a .999
        ' message, then it starts back at .001 again (overwriting a
        ' .001 message if you have one).  I've pretty much assumed
        ' this is a rarely used routine--that is, that, on average,
        ' the sysop will only create 1 or 2 new messages per month (at
        ' the rate of one new message per week, this is good for 20
        ' years).
        '
        ' Date last checked for perfection: Sep 15 1992
        '
SUB SaveMessageFile (p)

  SELECT CASE p
    CASE 0
         IF FindF(FileNames$(39) + Short$(997),FFile) <> 0 _
            THEN DO : CALL IntMax(p,Val2&(FFile.FName)) : _
                 LOOP UNTIL FindF(Null$,FFile) = 0
         p = p + 1
         K$ = Form4$(3,p)
    CASE 1
         FOR p = 1 TO 99
           K$ = Short$(750) + Form4$(2,p)
           IF FindF(FileNames$(39) + K$,FFile) = 0 THEN EXIT FOR
         NEXT
  END SELECT
  K1 = FileOpen(FileNames$(39) + K$)
  CALL FilePutSEnd(K1,MessageBody$)
  CALL FileClose(K1)
  TT$ = BlockText2(177) + K$ + Short$(304)
  CALL SendTT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine handles getting and attaching files to
        ' messages.
        '
        ' TGot is relied upon for what to do:
        '      712  -- BiModem auto-detected.
        '      713  -- Zmodem auto-detected.
        '      Anything else: default protocol
        '
        ' Properly handles attaching files at the console.
        '
        ' Date last checked for perfection: Nov 19 1992
        '
SUB DoFileAttach

  K& = DriveSpc&(Paths$(5))
  SELECT CASE TGot
    CASE 712
         IF Levels(UserSL).SecLevel < Settings.BiSL _
            OR K& < Settings.MinULSpace _
            THEN EXIT SUB
         CALL AdjustProtocol(Short$(211))
    CASE 713
         IF K& < Settings.MinULSpace THEN EXIT SUB
         CALL AdjustProtocol(Short$(627))
    CASE ELSE
         TT$ = Short$(107) + RTRIM$(Form$(7908,GetLine$(485) + _
               Commas$(K&) + GetLine$(489)))
         CALL SendTT
         IF K& < Settings.MinULSpace THEN TT = 488 : _
                                          CALL SendTT : _
                                          CALL Paused : _
                                          EXIT SUB
         SELECT CASE CommPort
           CASE 0
                TT = 260
                CALL SendTT
                K$ = MakePathName$(Message.MsgNum,Message.MsgBase + 1)
                DO
                  TT = 268
                  K1$ = LineEditTT$(56)
                  IF LEN(K1$) = 0 THEN EXIT DO
                  IF FindF(K1$,FFile) = 0 _
                     THEN TT = 506 _
                     ELSE TT = 273 : _
                          CALL  SendTT : _
                          CALL DirCreate(K$) : _
                          CALL CopyFile(0,K1$,K$ + FFile.FName) : _
                          TT = 603
                  CALL SendTT
                LOOP UNTIL LEN(K1$) = 0
           CASE ELSE
                CALL AdjustProtocol(User.Protocol)
                K1$ = TT$
                TT$ = Short$(739) + _
                      RTRIM$(Form$(7908,MID$(TT$,20,34))) + _
                      BlockText2(502)
                CALL SendTT
                TT$ = K1$
         END SELECT
  END SELECT
  IF CommPort > 0 THEN K1$ = TIME$ : _
                       CALL ShellDos(6,ProtocolUp$) : _
                       CALL FileAppendToLog(MID$(TT$,54,40)) : _
                       K1 = ElapsedTime(K1$,K3) : _
                       CALL AI(6,Null$,K1,0,0,0,0,0&,0&)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine handles the getting of a node address.
        '
        ' For NetMail, but not EchoMail, return a Dest line.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB GetBBSAddr (nn$,K9,p0,k3$)

  IF BitTest(MsgBases(Message.MsgBase).SubType,9) _
     OR NOT BitTest(MsgBases(Message.MsgBase).SubType,3) _
     THEN nn$ = null$ : _
          Message.DestAddr = Settings.Addr : _
          EXIT SUB
  IF LEN(nn$) > 0 THEN CALL DispMsgHdrStuff(12,p0,nn$) _
                  ELSE Message.DestAddr = Settings.Addr
  DO
    TT = 284
    CALL MsgErrorBoxOutTT
    CALL CursorOn
    TT$ = Null$
    K$ = UCASE$(RTRIM$(LTRIM$(LineEditTT$(35))))
    CALL CursorOff
    IF AscVal(K$) = 63 THEN CALL Wipe(1) : _
                            CALL DispBlockText(49,C13$)
    SELECT CASE LEN(K$)
      CASE IS > 1
           K = StrSrch1(K$,64)                 'Any @Domain?
           IF K = 0 THEN K = LEN(K$)           'Nope, examine whole string.
           K1 = -1
           FOR K0 = 1 TO K
             IF StrSrch(1,Short$(942),MID$(K$,K0,1)) = 0 THEN K1 = 0 : _
                                                              EXIT FOR
           NEXT
           K0 = 0
           SELECT CASE K1
             CASE 0
                  '
                  ' A non-digit found, must be a search string.
                  '
                  TT = 290
                  CALL MsgErrorBoxOutTT
                  K6 = FileOpen(FileNames$(70))
                  K0& = FileLof&(K6,1)
                  K = 0
                  K& = -26                            '-26 + 34 = 8 = 9 - 1
                  K0$ = SPACE$(25)
                  Work(0) = 0
                  FOR K2 = 1 TO K0& \ 34
                    K& = K& + 34
                    CALL FileGetSLoc(K6,K&,K0$)
                    IF StrSrch(1,UCASE$(K0$),K$) > 0 _
                       THEN K = K + 1 : _
                            Work(K) = K2 : _
                            SWork$(K) = K0$ : _
                            IF K = Settings.MaxFilesInDir THEN EXIT FOR
                    CALL ShowTheGauge(K0&,K&)
                  NEXT
                  CALL FileClose(K6)
                  TT$ = Null$
                  CALL MsgErrorBoxOutTT
                  SELECT CASE K
                    CASE 0 : TT = 286
                             CALL MsgErrorBoxOutTT
                    CASE 1 : K = Work(1)
                    CASE IS > 1
                         CALL WipeMsgHdrWindow(1)
                         SWork$(K + 1) = Null$
                         TT = 458
                         CALL MenuSystemTT
                         K = Work(TGot)
                         CALL ReDrawMsgScreen(K9,p0,k3$,nn$)
                         TT = 33
                         CALL SendTT
                  END SELECT
             CASE -1
                  '
                  ' If the string contains only numbers, then see if has any
                  ' dashes.  If it does, then it's a phone number, otherwise
                  ' it's a node address.
                  '
                  IF StrSrch1(LEFT$(K$,K),45) > 0 _
                     THEN IF LEN(K$) = 12 OR LEN(K$) = 8 THEN K0 = -1 _
                                                         ELSE K0 = 1
                  SELECT CASE K0
                    CASE -1
                         IF LEN(K$) = 8 _
                            THEN K$ = LEFT$(IntToPhone$(Settings.Phone),4) + K$
                         TT = 290
                         CALL MsgErrorBoxOutTT
                         K6 = FileOpen(FileNames$(70))
                         IF LEN(K$) <> 12 THEN K = 0
                         K& = Val2&(MID$(K$,2,1) + MID$(K$,1,1) + _
                              MID$(K$,3,1) + MID$(K$,5,3) + RIGHT$(K$,4))
                         K2& = FileLof&(K6,1)
                         K3 = K2& \ 34
                         K0& = -30                    '-30 + 34 = 4
                         FOR K = 1 TO K3
                           K0& = K0& + 34
                           CALL FileGetLoc(K6,K0&,4,K1&)
                           IF K& = K1& THEN EXIT FOR
                           CALL ShowTheGauge(K2&,K0&)
                         NEXT
                         CALL FileClose(K6)
                         TT$ = Null$
                         CALL MsgErrorBoxOutTT
                         IF K > K3 THEN K = 0 : _
                                        TT = 313 : _
                                        CALL MsgErrorBoxOutTT
                    CASE 0
                         K = BiSearch(4,0,MKL$(StrToAddr&(K$)))
                  END SELECT
           END SELECT
           '
           ' At this point, K = 0 if no match was found, K > 0 if a match
           ' was found (K contains the nodelist rec num).
           '
           SELECT CASE K
             CASE 0
                  '
                  ' Address wasn't found in the nodelist.  However, if
                  ' the search string was an address, then we still will
                  ' use it.  [future: add support for phone numbers that
                  ' are not found.]
                  '
                  ' If a number was entered (K1) and it is not a phone
                  ' number (NOT K0) then it's an address to use.
                  '
                  IF K1 AND NOT K0 _
                     THEN K0 = 0 : _
                          Message.DestAddr = StrToAddr&(K$) : _
                          nn$ = C1$ + Short$(848) + _
                                AddrToInt$(Message.DestAddr,K1,K2,K3) + C13$ _
                     ELSE K0 = 1 : _
                          nn$ = Null$
                  TT = 460 + K0
                  CALL MsgErrorBoxOutTT
             CASE ELSE
                  K0 = FileOpen(FileNames$(70))
                  CALL FileGetRec(K0,K,34,Node)
                  CALL FileClose(K0)
                  Message.DestAddr = Node.Addr
                  nn$ = C1$ + Short$(848) + _
                        AddrToInt$(Message.DestAddr,K1,K2,K3) + C13$
           END SELECT
           CALL DispMsgHdrStuff(2,p0,nn$)
      CASE ELSE : IF LEN(nn$) > 0 THEN CALL DispMsgHdrStuff(2,p0,nn$)
                  EXIT DO
    END SELECT
  LOOP UNTIL AscVal(K$) <> 63 OR NoCarrier
  Work(0) = 1
  Work(1) = -1

END SUB
        '
        '* * * *

