' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
'Various tiny routines called from multiple overlays:
'  FormLine
'  ContactPhoneNumber
'(These routines really should be overlays themselves, but haven't yet figured
'what to do.  So they waste space.)  While it would be more efficient to put
'these in each overlay, it would be more troublesome to upgrade both routines
'than just this one.




        '* * * * * *
        'Various formatting lines.
        '
        ' p  1 for message scanning when/from/subject lines.
        '    2 for message scanning to/from/subject lines.
        '
        ' 1 and 2 require Message.
        ' 1 doesn't use any stop & exit keys.
        ' 2 does checking for [Enter] and '-', and has pause control.
        '
        ' Look into expanding this for other routines.  Keep in mind,
        ' however, that because this isn't an overlay, the advantages
        ' of combining the text into here must outweigh the routines
        ' being in the probably overlaid file(s).  Probably only
        ' useful for those 'lines' that multiple routines produce, but
        ' which are the same.--Example: P&S and ListDir.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB FormLine (p)

  SELECT CASE p
    CASE 1
         K$ = Short$(93) + Form$(601,STR$(Message.MsgNum)) + Short$(66) + _
              IntToDate3$(Message.MsgDateSent) + _
              Form$(966,RightTime$(IntToTime$(Message.MsgTimeSent))) + _
              Short$(78) + Form$(2305,Message.MsgFrom)
         K0 = 30
    CASE 2
         K$ = Short$(447 + (Message.MsgNum > CVL(MID$(UserMsgInfo$,BaseIndex * 4 + 1,4)))) + _
              Form$(601,STR$(Message.MsgNum))
         IF User.UserName = Message.MsgFrom THEN K$ = K$ + Short$(87) _
                                            ELSE K$ = K$ + Short$(66)
         K$ = K$ + Form$(2369,Message.MsgFrom)
         IF User.UserName = Message.MsgTo THEN K$ = K$ + Short$(87) _
                                          ELSE K$ = K$ + Short$(78)
         TT$ = Form$(2305,Message.MsgTo)
         IF RTRIM$(TT$) = Short$(402) THEN TT$ = BlockText2(111)
         K$ = K$ + TT$
         K0 = 25
  END SELECT
  TT$ = K$ + Short$(565) + LEFT$(UnSq$(RTRIM$(Message.MsgSubject)),K0) + C1310$
  CALL SendTT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine dials a phone number.
        '
        ' p$  phone number to dial.
        '     > 12 chars have nothing added in front (intl calls)
        '     > 8 chars have '1-' added in front (LD calls)
        '     rest are assumed local calls
        '     p$ is changed
        '
        ' Date last checked for perfection: Sep 22 1992
        '
SUB ContactPhoneNumber (p$)

  IF LEN(p$) = 0 THEN EXIT SUB
  IF LEN(p$) < 13 THEN p$ = Short$(164 + (LEN(p$) < 9)) + p$
  CommPort = Settings.CommPort
  CALL Delay
  CALL Delay
  CALL Delay
  CALL CommOut(UCASE$(Short$(821) + p$ + C1310$))
  CALL DelayTiny(1)
  FOR K3 = 1 TO 2
    K$ = Null$
    K1$ = TIME$
    DO
      K1 = -2
      K = CommIn(K1)
      IF K1 = -1 THEN EXIT DO
      IF K >= 0 THEN TT$ = AscChr$(K) : _
                     K$ = K$ + TT$ : _
                     CALL AnsiTT
      IF K3 = 1 AND K = 13 THEN FOR K2 = 1034 TO 1039 : _
                                  K0 = StrSrch(1,K$,Short$(K2)) : _
                                NEXT : _
                                K$ = Null$ : _
                                IF K0 > 0 THEN EXIT DO
      IF K3 = 2 AND K = 13 THEN IF StrSrch(1,K$,Short$(899)) > 0 THEN EXIT DO
      IF (K3 = 1 AND NOT NoCarrier) OR (K3 = 2 AND NoCarrier) THEN EXIT DO
    LOOP UNTIL ElapsedTime(K1$,K4) = Settings.LogoTimeout
    IF NoCarrier OR K1 = -1 THEN CALL HangUp : _
                                 EXIT FOR
  NEXT

END SUB
        '
        '* * * *

