' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' These routines handle the Ramble system:
'   Ramblings
'   NewRambleRead
'   POLine
'




        '* * * * * *
        ' This routine handles the creation, addition, listing, and
        ' deletion, of file messages--files containing messages.
        '
        ' Date last checked for perfection: Sep 12 1992
        '
SUB Ramblings

  K3 = FileOpen(FileNames$(43))
  DO
    K1 = -1
    DO
      TT = 10107
      CALL SendTT
      SWork$(1) = GetLine$(42)
      SWork$(2) = GetLine$(43)
      SWork$(3) = GetLine$(78)
      IF Levels(UserSL).SecLevel < Settings.RambleAddSL _
         OR FileLof&(K3,77) + 3 = Settings.MaxFilesInDir _
         THEN K0 = 3 _
         ELSE SWork$(4) = GetLine$(272) : _
              K0 = 4
      FOR K = 1 TO FileLof&(K3,77)
        CALL FileGetRec(K3,K,77,Ramble)
        SELECT CASE Ramble.AccessSL
          CASE IS > Levels(UserSL).SecLevel
               K$ = GetLine$(274) + STR$(Ramble.AccessSL)
          CASE ELSE
               IF Ramble.Count > 1 THEN K9 = 79 _
                                   ELSE K9 = 81
               IF K1 < 0 THEN K$ = Ramble.Title _
                         ELSE K$ = LTRIM$(STR$(Ramble.Count)) + GetLine$(K9) + _
                                   IntToDate3$(Ramble.LastDate)
               IF Ramble.HiFilePtr > User.HiFilePtr THEN K$ = Short$(96) + K$
        END SELECT
        SWork$(K + K0) = K$
      NEXT
      SWork$(K + K0) = Null$
      TT = 275
      CALL MenuSystemTT
      IF K0 = 3 AND TGot > 3 THEN TGot = TGot + 1
      IF TGot = 3 THEN K1 = - K1
    LOOP UNTIL TGot <> 3
    SELECT CASE TGot
      CASE 0 : CALL FileClose(K3)
               EXIT SUB
      CASE 1 : CALL DispBlockText(35,Null$)
               CALL Paused
      CASE 2
           FOR K = 1 TO FileLof&(K3,77)
             CALL FileGetRec(K3,K,77,Ramble)
             IF Ramble.HiFilePtr > User.HiFilePtr _
                AND Ramble.AccessSL <= Levels(UserSL).SecLevel _
                THEN CALL NewRambleRead(K,K3)
           NEXT
      CASE 4
           TT = 276
           Ramble.Title = LineEditTT$(34)
           SELECT CASE LEN(RTRIM$(Ramble.Title))
             CASE IS > 0
                  Ramble.RambleOp = User.UserName
                  CALL DispCRLF
                  CALL DispCRLF
                  FOR K = 1 TO 996
                    K$ = RIGHT$(STR$(1000 + K),3)
                    IF FindF(FileNames$(53) + K$,FFile) = 0 THEN EXIT FOR
                  NEXT
                  IF K = 997 THEN K = 1
                  Ramble.Number = K$
                  TT = 388
                  CALL SendTT
                  MessageBody$ = Null$
                  CALL GetMessageText(0)
                  SELECT CASE LEN(MessageBody$)
                    CASE 0 TO 4 : TT = 70
                    CASE ELSE
                         K2 = FileOpen(FileNames$(53) + K$)
                         Settings.HiFilePtr = Settings.HiFilePtr + 1
                         Ramble.HiFilePtr = Settings.HiFilePtr
                         K$ = Short$(412) + IntToDate3$(LogonDate) + _
                              STR$(Settings.HiFilePtr) + C1310$ + _
                              GetLine$(389) + NCR$(User.UserName) + _
                              Short$(419) + C1310$ + Short$(404) + C1310$ + _
                              Short$(404) + C1310$
                         CALL FilePutSEnd(K2,K$)
                         K = 1
                         K0 = 0
                         DO : CALL POLine(K,78,Short$(404),K0,K2)
                         LOOP UNTIL K < 0
                         K$ = Short$(404) + C1310$ + Short$(412) + _
                               IntToDate3$(LogonDate) + _
                               STR$(Settings.HiFilePtr) + C1310$
                         CALL FilePutSEnd(K2,K$)
                         TT = 401
                         CALL GetNumPlusTT(Null$)
                         Ramble.AccessSL = Val2&(TGot$)
                         CALL DispCRLF
                         IF Ramble.AccessSL > Levels(LevelsSize).SecLevel _
                            THEN Ramble.AccessSL = 0
                         CALL FileClose(K2)
                         Ramble.LastDate = LogonDate
                         Ramble.Count = 1
                         CALL FilePutRec(K3,FileLof&(K3,77) + 1,77,Ramble)
                         TT = 4
                  END SELECT
                  CALL SendTT
           END SELECT
      CASE ELSE
           CALL DispCRLF
           K1 = TGot - 4
           CALL FileGetRec(K3,K1,77,Ramble)
           SELECT CASE Levels(UserSL).SecLevel
             CASE IS < Ramble.AccessSL : TGot$ = Null$
             CASE ELSE
                  K$ = Short$(421)
                  IF UserSL = LevelsSize OR Ramble.RambleOp = User.UserName _
                     THEN TT$ = Short$(422) : _
                          K$ = K$ + Short$(423) _
                     ELSE TT$ = Null$
                  IF Ramble.HiFilePtr > User.HiFilePtr AND User.HiFilePtr <> 0 _
                     THEN TT$ = BlockText2(354) + TT$ : _
                          K$ = K$ + Short$(424)
                  TT$ = Short$(369) + K$ + Short$(376) + TT$ + BlockText2(156)
                  CALL SendTT
                  IF TGot < 1 THEN CALL TGet(K$ + C13$)
           END SELECT
           SELECT CASE TGot
             CASE 78
                  TT = 10449
                  CALL SendTT
                  CALL NewRambleRead(K1,K3)
             CASE 82
                  TT = 10460
                  CALL SendTT
                  K2 = FileOpen(FileNames$(53) + Ramble.Number)
                  K& = 0
                  DO
                    K$ = FileGetLine$(K2,K&)
                    IF AscVal(K$) = 49 _
                       THEN TT$ = Short$(461) + MID$(K$,2) + C1310$ : _
                            CALL SendTT
                  LOOP UNTIL K& = -1 OR TGot > 0
                  CALL FileClose(K2)
                  CALL Paused
             CASE 75
                  TT = 10462
                  CALL SendTT
                  K4 = FileOpen(FileNames$(53) + Ramble.Number)
                  K2 = FileOpen(FileNames$(41))
                  K& = 0
                  CALL FilePutSEnd(K2,Short$(465) + RTRIM$(Ramble.Title) + C1310$)
                  DO
                    K$ = FileGetLine$(K4,K&)
                    CALL FilePutSEnd(K2,K$ + C1310$)
                  LOOP UNTIL K& = -1
                  CALL FilePutSEnd(K2,STRING$(79,124) + C1310$)
                  CALL FileClose(K2)
                  CALL FileClose(K4)
                  CALL KillFile(FileNames$(53) + Ramble.Number)
                  K4 = FileOpen(FileNames$(10))
                  FOR K = 1 TO FileLof&(K3,77)
                    IF K <> K1 _
                       THEN CALL FileGetRec(K3,K,77,Ramble) : _
                            CALL FilePutRec(K4,FileLof&(K4,77) + 1,77,Ramble)
                  NEXT
                  CALL FileClose(K3)
                  CALL FileClose(K4)
                  CALL Copyfile(1,FileNames$(10),FileNames$(43))
                  K3 = FileOpen(FileNames$(43))
                  TT = 4
                  CALL SendTT
             CASE 65
                  TT = 405
                  CALL SendTT
                  MessageBody$ = Null$
                  CALL GetMessageText(0)
                  SELECT CASE LEN(MessageBody$)
                    CASE 0 TO 4 : TT = 70
                    CASE ELSE
                         K2 = FileOpen(FileNames$(53) + Ramble.Number)
                         K = 1
                         K0 = 0
                         DO : CALL POLine(K,78,Short$(404),K0,K2)
                         LOOP UNTIL K < 0
                         Settings.HiFilePtr = Settings.HiFilePtr + 1
                         K$ = Short$(404) + C1310$ + Short$(412) + _
                              IntToDate3$(LogonDate) + STR$(Settings.HiFilePtr) + C1310$
                         CALL FilePutSEnd(K2,K$)
                         Ramble.HiFilePtr = Settings.HiFilePtr
                         CALL FileClose(K2)
                         Ramble.LastDate = LogonDate
                         Ramble.Count = Ramble.Count + 1
                         CALL FilePutRec(K3,K1,77,Ramble)
                         TT = 4
                  END SELECT
                  CALL SendTT
           END SELECT
    END SELECT
  LOOP UNTIL NoCarrier
  CALL FileClose(K3)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to Ramblings, reads all new entries
        ' in a Ramble file.
        '
        ' p   ramble number to read.
        '
        ' p0  ramble file handle.
        '
        ' Date last checked for perfection: Sep 12 1992
        '
SUB NewRambleRead (p,p0)

  CALL FileGetRec(p0,p,77,Ramble)
  TT$ = BlockText2(66) + RTRIM$(Ramble.Title) + Short$(466)
  CALL SendTT
  K0 = FileOpen(FileNames$(53) + Ramble.Number)
  K& = 0
  IF User.HiFilePtr <> 0 _
     THEN K& = FileLof&(K0,1) : _
          DO : _
            DO : K$ = FileGetLineR$(K0,K&) : _
            LOOP UNTIL AscVal(K$) = 50 OR K& = -1 : _
          LOOP UNTIL User.HiFilePtr > Val2&(K$) OR K& = -1 : _
          IF User.HiFilePtr <= Val2&(K$) THEN K& = 0
  K$ = FileGetLine$(K0,K&)
  DO
    IF AscVal(K$) <> 50 THEN TT$ = Short$(461) + MID$(K$,2) + C1310$ : _
                             CALL SendTT
    K$ = FileGetLine$(K0,K&)
  LOOP UNTIL K& = -1 OR TGot > 0
  CALL FileClose(K0)
  CALL Paused

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine displays a line of text from MessageBody$.
        ' When it gets to the last line, it also displays the
        ' author.
        '
        ' p   line number to show.  Returns -1 if just did last
        '     line, otherwise it's incremented.
        '
        ' p0  line size.
        '
        ' p1  maintains the maximum line width.
        '
        ' p$  what leads the output line.
        '
        ' p2  file to tack it on to.
        '
        ' Date last checked for perfection: Sep 12 1992
        '
SUB POLine (p,p0,p$,p1,p2)

  CALL FindMsgLine(p,p0,5,K0$,K5,K3)
  CALL IntMax(p1,StripLen(RTRIM$(K0$)))
  IF K5 > 0 THEN CALL FilePutSEnd(p2,p$ + K0$ + C1310$) : _
                 p = p + 1 : _
                 EXIT SUB
  p = -1
  K1$ = Short$(836) + NCR$(User.UserName)
  K4 = p1 - StripLen(K1$)
  K5 = K4 - StripLen(K0$)
  IF K5 > 0 THEN K0$ = K0$ + SPACE$(K5) + K1$ _
            ELSE CALL FilePutSEnd(p2,p$ + K0$ + C1310$) : _
                 IF K4 > 0 THEN K0$ = SPACE$(K4) + K1$ _
                           ELSE K0$ = K1$
  CALL FilePutSEnd(p2,p$ + K0$ + C1310$)

END SUB
        '
        '* * * *

