' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
'Routines related to reading of messages only:
'  AlterTheMessagesData
'  EditSentMessage
'  ForwardNoteAdd
'  MoveDirectory
'  ViewFileAttach
'  DLFileAttach





        '* * * * * *
        ' This routine, internal to ReadMessages, will edit the header
        ' record of a message.
        '
        ' p  the MsgPtr array location of the message being worked on.
        '
        ' Date last checked for perfection: Sep 7 1992
        '
SUB AlterTheMessagesData (p)

  TT = 440
  CALL SendTT
  CALL FileGetLoc(Handle(3),MsgPtr(p).MsgLoc - 1,128,Message)
  K2 = FileOpen(FileNames$(7) + Form4$(3,1))
  K0& = BlockText&(56) - 1
  K2& = Message.MsgNum
  FOR K0 = 1 TO 15
    SELECT CASE K0
      CASE 1 : K$ = Message.MsgFrom 
      CASE 2 : K$ = Message.MsgTo
      CASE 3 : K$ = UnSq$(Message.MsgSubject)
      CASE 4 : K$ = STR$(Message.MsgNum)
      CASE 5 : K$ = IntToAttr$(Message.Attr)
      CASE 6 : K$ = IntToDate3$(Message.MsgDateSent)
      CASE 7 : K$ = IntToTime$(Message.MsgTimeSent)
      CASE 8 : K$ = IntToDate3$(Message.MsgDateRcvd)
      CASE 9 : K$ = IntToTime$(Message.MsgTimeRcvd)
      CASE 10 : K$ = STR$(AscVal(Message.NumberReplies))
      CASE 11 : K$ = STR$(Message.TimesRead)
      CASE 12 : K$ = IntToDate3$(Message.LastDateRead)
      CASE 13 : K$ = IntToAttr$(Message.NetAttr) 
      CASE 14 : K$ = AddrToInt$(Message.SourceAddr,a1,a2,a3)
      CASE 15 : K$ = AddrToInt$(Message.DestAddr,a1,a2,a3)
    END SELECT
    K1& = K0&
    TT$ = MID$(FileGetLine$(K2,K0&),3) + Short$(830)
    SELECT CASE K0
      CASE 3     : TT$ = Short$(829) + TT$ + LTRIM$(RTRIM$(K$)) + Short$(900)
      CASE 5, 13 : TT$ = Short$(825) + TT$ + K$ + Short$(833)
      CASE ELSE  : TT$ = Short$(825) + TT$ + LTRIM$(RTRIM$(K$)) + Short$(833)
    END SELECT
    IF K0 = 1 OR K0 = 2 THEN CALL GetUserNameTT(K$,K1) _
                        ELSE K$ = LineEditTT$(51) : _
                             K& = Val2&(K$) : _
                             K1 = LEN(K$)
    IF NoCarrier THEN EXIT FOR
    CALL DispCRLF
    SELECT CASE K1
      CASE IS > 0
           SELECT CASE K0
             CASE 1 : Message.MsgFrom = K$
             CASE 2 : Message.MsgTo = K$
             CASE 3 : Message.MsgSubject = Sq$(K$)
             CASE 4 : Message.MsgNum = K&
             CASE 5 : IF AscVal(K$) = 63 THEN CALL DispBlockText(59,Null$) : _
                                              K0& = K1& : _
                                              K0 = K0 - 1 _
                                         ELSE Message.Attr = AttrToInt(K$)
             CASE 6 : Message.MsgDateSent = DateToInt(K$)
             CASE 7 : Message.MsgTimeSent = TimeToInt(K$)
             CASE 8 : Message.MsgDateRcvd = DateToInt(K$)
             CASE 9 : Message.MsgTimeRcvd = TimeToInt(K$)
             CASE 10 : IF K& < 256 THEN Message.NumberReplies = AscChr$(K&)
             CASE 11 : Message.TimesRead = K&
             CASE 12 : Message.LastDateRead = DateToInt(K$)
             CASE 13 : IF AscVal(K$) = 63 THEN CALL DispBlockText(60,Null$) : _
                                               K0& = K1& : _
                                               K0 = K0 - 1 _
                                          ELSE Message.NetAttr = AttrToInt(K$)
             CASE 14 : Message.SourceAddr = StrToAddr&(K$)
             CASE 15 : Message.DestAddr = StrToAddr&(K$)
           END SELECT
    END SELECT
  NEXT
  IF NOT NoCarrier _
     THEN CALL FilePutLoc(Handle(3),MsgPtr(p).MsgLoc - 1,128,Message)
  CALL FileClose(K2)
  IF Message.MsgNum <> K2& AND BitTest(Message.Attr,12) AND NOT NoCarrier _
     THEN CALL MoveDirectory(K2&,Message.MsgBase,Message.MsgNum) : _
          CALL DirDelete(MakePathName$(K2&,Message.MsgBase + 1))

END SUB
        '
        '* * * *




        '* * * * * *
        ' This subroutine, internal to ReadMessages, handles the
        ' altering, deletion, and re-creation of an already sent
        ' message.
        '
        ' p   the MsgPtr(). array location of the message.
        '
        ' p0  directional flag.
        '
        ' When searching and replacing text, hitting [Enter] alone for
        ' the the replacement string means you wish to just delete the
        ' original string.
        '
        ' The routine searches and replaces the first occurance.  If
        ' there are multiple occurances, the user may redo the same
        ' sequence--find the same occurance to search again.  This is
        ' because the originally occurance is really no longer in
        ' the text--as after each one of those letters is a CHR$(8).
        '
        ' Date last checked for perfection: Sep 7 1992
        '
SUB EditSentMessage (p,p0)

  K0$ = Null$
  DO
    SELECT CASE K0$
      CASE Null$ : K0 = 0
      CASE ELSE
           K1 = StrSrch(1,MessageBody$,K0$)
           SELECT CASE K1
             CASE 0 : TT$ = Short$(500) + K0$ + BlockText2(571)
             CASE ELSE
                  K$ = K0$
                  FOR K2 = 1 TO LEN(K$)
                    K$ = LEFT$(K$,K2 * 2 - 1) + C8$ + MID$(K$,K2 * 2)
                  NEXT
                  TT = 572
                  K0$ = LineEditTT$(45)
                  K0 = -1
                  MessageBody$ = LEFT$(MessageBody$,K1 - 1) + K$ + K0$ + _
                                 MID$(MessageBody$,K1 + K2 - 1)
                  TT = 417
           END SELECT
           CALL SendTT
    END SELECT
    TT = 567
    K0$ = LineEditTT$(40)
  LOOP UNTIL LEN(K0$) = 0
  SELECT CASE K0
    CASE 0 : TT = 570
    CASE ELSE
         IF BitTest(Message.Attr,2) THEN TT = 568 : _
                                         CALL SendTT : _
                                         MessageBody$ = Sq$(MessageBody$)
         IF BitTest(Message.Attr,12) _
            THEN CALL MoveDirectory(Message.MsgNum,Message.MsgBase,MsgBases(Message.MsgBase).NextNumber)
         CALL RemoveAMessage(p,p0)
         CALL AddAMessage(1)
         TT = 569
  END SELECT
  CALL SendTT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This subroutine, internal to ReadMessages, handles the
        ' creation and adding of Forward notes.  Also the deletion
        ' of the original message.
        '
        ' p   the MsgPtr(). array location of the message.
        '
        ' p0  returns -1 if new message sent, else 0.
        '
        ' p1  directional flag.
        '
        ' Date last checked for perfection: Sep 7 1992
        '
SUB ForwardNoteAdd (p,p0,p1)

  p0 = 0
  TT = 573
  CALL SendTT
  CALL TGet(Short$(546) + C13$)
  IF TGot = -1 THEN TT = 580 : _
                    CALL SendTT : _
                    EXIT SUB
  K71 = Message.MsgBase
  K1 = TGot
  SELECT CASE TGot
    CASE 85
         TT = 575
         CALL GetUserNameTT(K0$,K2)
         CALL DispCRLF
         IF K2 < 1 THEN TT = 577 : _
                        CALL SendTT : _
                        EXIT SUB
    CASE 77
         TT = 10550
         CALL SendTT
         FOR K2 = 1 TO BasesSize + 1
           SWork$(K2) = MsgBases(K2 - 1).Title
         NEXT
         SWork$(K2) = Null$
         TT = 578
         CALL MenuSystemTT
         IF TGot = 0 THEN EXIT SUB
         Message.MsgBase = TGot - 1
         K2 = TGot - 1
  END SELECT
  p0 = -1
  IF BitTest(Message.Attr,12) _
     THEN CALL MoveDirectory(Message.MsgNum,K71,MsgBases(Message.MsgBase).NextNumber)
  CALL RemoveAMessage(p,p1)
  TT = 595
  SELECT CASE GetYNTT
    CASE -1
         TT = 355
         CALL SendTT
         K$ = MessageBody$
         MessageBody$ = Null$
         CALL GetMessageText(0)
         K = LEN(MessageBody$)
         SELECT CASE K
           CASE IS < 3
                TT = 367
                CALL SendTT
                MessageBody$ = K$
           CASE ELSE
                MessageBody$ = LEFT$(MessageBody$,K - 1)
                MessageBody$ = Short$(425) + Form$(20,User.UserName) + _
                               GetLine$(369) + C13$ + MessageBody$ + _
                               Short$(425) + C13$
                TT = 596
                IF GetYNTT THEN MessageBody$ = K$ + MessageBody$ + C13$ _
                           ELSE MessageBody$ = MessageBody$ + C32$ + C13$ + K$
         END SELECT
  END SELECT
  SELECT CASE K1
    CASE 85
         CALL DispCRLF
         Message.MsgTo = K0$
         MessageBody$ = GetLine$(576) + NCR$(User.UserName) + _
                        Short$(653) + C13$ + C32$ + C13$ + MessageBody$
         CALL AddAMessage(0)
    CASE 77
         K1 = LEN(RTRIM$(User.username))
         K3 = LEN(LTRIM$(RTRIM$(MsgBases(K71).Title)))
         CALL IntMax(K3,K1)
         K3 = K3 * 100 + 65
         MessageBody$ = GetLine$(576) + Form$(K3,MsgBases(K71).Title) + _
                        Short$(663) + C13$ + Short$(837) + _
                        Form$(K3,NCR$(User.UserName)) + Short$(797) + C13$ + _
                        C32$ + C13$ + MessageBody$
         Message.MsgBase = K2
         CALL AddAMessage(1)
  END SELECT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This subroutine, internal to ReadMessages, handles the
        ' moving of the contents of a messages attached files when
        ' the message changes number or area.
        '
        ' p&   original message's number.
        '
        ' p    original message's area.
        '
        ' p0&  new message's number
        '
        ' Message.MsgBase = new message's base.
        '
        ' Date last checked for perfection: Sep 7 1992
        '
SUB MoveDirectory (p&,p,p0&)

  K$ = MakePathName$(p&,p + 1)
  K0$ = MakePathName$(p0&,Message.MsgBase + 1)
  CALL DirCreate(K0$)
  K0 = FindF(K$ + Short$(645),FFile)
  WHILE K0 <> 0
    CALL CopyFile(1,K$ + FFile.FName,K0$ + FFile.FName)
    K0 = FindF(K$ + Short$(645),FFile)
  WEND

END SUB
        '
        '* * * *




        '* * * * * *
        ' This subroutine, internal to ReadMessages, will just send
        ' out the contents of a file attach.
        '
        ' Date last checked for perfection: Nov 10 1992
        '
SUB ViewFileAttach (k99)

  K0$ = MakePathName$(Message.MsgNum,Message.MsgBase + 1)
  TT = 815
  SELECT CASE k99
    CASE 1
         K9 = FindF(K0$ + Short$(645),FFile) 
         K$ =  FFile.FName
         CALL SendTT
         TT$ = K$
         CALL SendTT
    CASE ELSE
         K$ = LTRIM$(RTRIM$(LineEditTT$(13)))
         IF LEN(K$) = 0 THEN CALL DispCRLF : _
                             EXIT SUB
         K$ = Form$(1201,UCASE$(K$))
         K98 = 0
         K9 = FindF(K0$ + Short$(645),FFile) 
         WHILE K9 <> 0 AND K98 = 0
           IF FFile.FName = K$ THEN K98 = 1 : _
                               ELSE K9 = FindF(Null$,FFile)
         WEND
         IF K98 = 0 THEN TT = 506 : _
                         CALL SendTT : _
                         EXIT SUB
  END SELECT
  TT = 22
  CALL SendTT
  K = FileOpen(K0$ + K$)
  K1& = FileLof&(K,1)
  K0& = 0
  WHILE TGot < 1 AND K0& < K1&
    TT$ = Short$(539) + FileGetBlock$(K,K0&,K1&)
    CALL SendTT
  WEND
  CALL FileClose(K)
  CALL Paused

END SUB
        '
        '* * * *





        '* * * * * *
        ' This subroutine, internal to ReadMessages, will send
        ' out a single file attach.
        '
        ' Date last checked for perfection: Nov 24 1992
        '
SUB DLFileAttach (k99)

  K0$ = MakePathName$(Message.MsgNum,Message.MsgBase + 1)
  TT = 346
  SELECT CASE k99
    CASE 1
         CALL SendTT
         K9 = FindF(K0$ + Short$(645),FFile) 
         TT$ = FFile.FName
         CALL SendTT
    CASE ELSE
         K$ = LTRIM$(RTRIM$(LineEditTT$(13)))
         IF LEN(K$) = 0 THEN CALL DispCRLF : _
                             EXIT SUB
         K$ = Form$(1201,UCASE$(K$))
         K98 = 0
         K9 = FindF(K0$ + Short$(645),FFile) 
         WHILE K9 <> 0 AND K98 = 0
           IF FFile.FName = K$ THEN K98 = 1 : _
                               ELSE K9 = FindF(Null$,FFile)
         WEND
         IF K98 = 0 THEN TT = 506 : _
                         CALL SendTT : _
                         EXIT SUB
  END SELECT
  SELECT CASE CanDL&
    CASE IS >= FFile.FSize
         K0$ = K0$ + FFile.FName + C1310$
         CALL KillFile(FileNames$(49))    'killfile changes ffile.
         K22 = FileOpen(FileNames$(49))
         CALL FilePutSEnd(K22,K0$)
         CALL FileClose(K22)
         CALL AdjustProtocol(User.Protocol)
         K0$ = TT$
         TT$ = Short$(751) + RTRIM$(Form$(7908,MID$(TT$,20,34))) + BlockText2(335)
         CALL ShellDownload(3)
  END SELECT
    
END SUB
        '
        '* * * *

