' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will remove a file name from the directories,
        ' FILELIST, REVIEWS, and from Files.IDX.
        '
        ' p$  contains the filename to delete if this routine is not
        '     run in a loop.  If it is run in a loop, K$ will be
        '     NULL--and will return NULL when the sysop just hits return
        '     (otherwise it'll return the filename processed.)  A '.'
        '     means clear the screen first, but otherwise it's run as
        '     if just a NULL was received.
        '
        ' Will remove all references in Files.IDX, REVIEWS, and
        ' FILELIST, but will only delete the first occurance of an
        ' actual disk file--this provides for being able to delete a
        ' duplicate uploaded to the UPLOADS directory--without also
        ' deleting the original in another directory (the FILELIST and
        ' Files.IDX data for the original would be restored whenever
        ' BuildArrays is next run, then).
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB RemoveFile (p$)

  IF p$ = Short$(379) THEN TT = 10283 : _
                           CALL SendTT : _
                           p$ = Null$
  SELECT CASE LEN(p$)
    CASE 0
         K1 = -1
         TT = 148
         CALL SendTT
         K2 = -1
'         DO
           CALL GetFileName(p$,K2)
           IF LEN(p$) = 0 OR NoCarrier THEN TT = 10283 : _
                                            CALL SendTT : _
                                            EXIT SUB
'           IF K > 0 THEN CALL TGet(C13$ + C8$) : _
'                         IF TGot = 8 THEN CALL Wipe(LEN(p$)) : _
'                                          p$ = Null$
'         LOOP UNTIL p$ <> Null$
         TT = 10146
         CALL SendTT
    CASE ELSE : K1 = 0
  END SELECT
  '
  ' Remove the file from the first directory in which it's found.
  '
  FOR K = 1 TO DirsSize
    IF FindF(RTRIM$(FileBases(K).Path) + p$,FFile) <> 0 _
       THEN CALL KillFile(RTRIM$(FileBases(K).Path) + FFile.FName) : _
            IF K1 _
               THEN TT$ = BlockText2(149) + RTRIM$(FileBases(K).Path) + _
                          Short$(343) + C1310$ : _
                    CALL SendTT : _
                    EXIT FOR _
               ELSE EXIT FOR
  NEXT
  '
  ' Remove the file name from Files.IDX.
  '
  K = BiSearch(3,0,Form$(1201,p$))
  SELECT CASE K
    CASE IS > 0
         K3 = FileOpen(FileNames$(4))
         CALL FileGetRec(K3,FileIDX.FRec,119,FileList)
         IF NOT BitTest(FileList.Attr,7) _
            THEN CALL SharedWriteEOF(24,0,FileList.FName + _
                                          Form$(1066,STR$(FileList.FSize)) + _
                                          RTRIM$(FileList.FDesc))
         TT$ = GetLine$(150) + FileList.FName + C32$ + RTRIM$(FileList.FDesc)
         CALL LogTT
         CALL BitSet(FileList.Attr,1)
         CALL FilePutRec(K3,FileIDX.FRec,119,FileList)
         CALL FileClose(K3)
         FileIDX.FName = GetLine$(184)
         CALL FilePutRec(Handle(22),K,22,FileIDX)
         CALL FileSort(Handle(22),22)
         CALL FilePutLoc(Handle(22),FileLof&(Handle(22),1) - 22,0,FileIDX)
         IF K1 AND NOT BitTest(FileList.Attr,7) THEN TT = 151 : _
                                                     CALL SendTT
  END SELECT
  TT = 0
  CALL RemoveReview(p$,K1)
  IF TT > 0 THEN CALL SendTT
  IF K1 THEN TT = 10283 : _
             CALL SendTT

END SUB


        '* * * * * *
        ' Remove the file name from all the Reviews files.
        '
        ' p$  file name to remove.
        '
        ' p1  toggle for whether to display what happened.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB RemoveReview (p$,p1)

  FOR K3 = 1 TO DirsSize
    K1$ = FileNames$(15) + Form4$(3,K3)
    SELECT CASE FindF(K1$,FFile)
      CASE IS <> 0
           K4 = FileOpen(K1$)
           K2 = FileOpen(FileNames$(10))
           K& = 0
           K = -1
           K0 = 0
           DO
             K0$ = FileGetLine$(K4,K&)
             IF K0 AND RTRIM$(LEFT$(K0$,13)) <> Short$(625) THEN K0 = 0
             IF RTRIM$(MID$(K0$,2,12)) = p$ OR K0 _
                THEN K = 0 : _
                     K0 = -1 _
                ELSE IF LEN(K0$) > 0 THEN CALL FilePutSEnd(K2,K0$ + C1310$)
           LOOP UNTIL K& = -1
           CALL FileClose(K2)
           CALL FileClose(K4)
           IF K THEN CALL KillFile(FileNames$(10)) _
                ELSE CALL CopyFile(1,FileNames$(10),K1$) : _
                     IF p1 THEN TT = 152
           K4 = FindF(K1$,FFile)
           IF FFile.FSize < 25 THEN CALL KillFile(K1$)
    END SELECT
  NEXT

END SUB
        '
        '* * * *

