' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
'Various small overlaid sysop routines:
'  Chat1
'  DirAnyWhere
'  KillAFile
'  MakeNews
'  PortDebugger
'  ResetVote
'  SysopTransfer




        '* * * * * *
        ' This routine handles simple chat sessions.
        '
        ' Date last checked for perfection: Nov 7 1992
        '
SUB Chat1

  CALL CursorOn
  K$ = Null$
  K2$ = SPACE$(Settings.MaxWidthOfMsg)
  K9 = 0
  K99 = 1
  K98 = GetRndNum(15)
  DO
    '
    'This handles colorizing at line changes.
    '
    IF K9 = -1 THEN TT$ = Short$(340) + Short$(65) : _
                    K8 = -1 _
               ELSE TT$ = Short$(340) + Short$(79) : _
                    K8 = 0
    K0 = LEN(K$)
    IF K99 = -1 THEN FOR zz = 1 TO K0 : _
                       TT$ = TT$ + KwazyColor$(K98,40) + MID$(K$,zz,1) : _
                     NEXT _
                ELSE TT$ = TT$ + K$
    CALL SendTT
    MID$(K2$,1,K0) = K$
    K$ = Null$
    K1 = 0
    DO
      SELECT CASE K1
        CASE IS > 0
             K1 = K1 - 1
             K2 = 32
        CASE ELSE
             '
             ' This handles color changes within lines.
             '
             K2 = CommIn(K9)
             IF K8 <> K9 AND K2 >= 0 THEN K8 = K9 : _
                                          TT = 10083 + K9 : _
                                          CALL SendTT
      END SELECT
      '
      ' Except for 8, 9, 13, and 27, everything below 32 is ignored.
      '
      SELECT CASE K2
        CASE 8, 127
             IF K0 > 0 THEN K0 = K0 - 1 : _
                            CALL Wipe(1)
        CASE 9 : K1 = 4 - K0 + ((K0 + 1) \ 5) * 5     '5 - ((K0 + 1) MOD 5)
        CASE 32766 : CALL CursorOff      'esc c
                     EXIT SUB
        CASE 32765 : K99 = - K99      'esc 1
                     TT = 10083 + K8
                     CALL SendTT
        CASE 32764 : 'call chat2      'esc 2
        CASE 27, IS > 31
             TT$ = AscChr$(K2)
             K0 = K0 + 1
             MID$(K2$,K0,1) = TT$
             IF K99 = -1 THEN TT$ = KwazyColor$(K98,40) + TT$
             CALL CommOut(TT$)
             CALL AnsiTT
             IF K0 > 2 THEN IF MID$(K2$,K0,1) = MID$(K2$,K0 - 2,1) _
                               THEN CALL ForeignChar(K2$,K0)
             IF K0 = Settings.MaxWidthOfMsg THEN K2 = 257
      END SELECT
    LOOP UNTIL K2 = 13 OR K2 = 257 OR NoCarrier
    SELECT CASE K2
      CASE 257 : K3 = StrSrchR(K2$,32)
                 IF K3 = 0 THEN K3 = K0
                 CALL Wipe(K0 - K3)
                 K0 = K3
                 K$ = MID$(K2$,K3 + 1)
    END SELECT
    CALL DispCRLF
    IF BitTest(Toggles(1),5) OR BitTest(User.Attr,5) _
       THEN IF DriveSpc&(FileNames$(52)) > Settings.MinSpace _
               THEN CALL FilePutSEnd(Handle(2),LEFT$(K2$,K0) + C1310$)
  LOOP UNTIL NoCarrier
  CALL CursorOff

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine lists the contents of any directory.
        '
        ' Date last checked for perfection: Sep 15 1992
        '
SUB DirAnyWhere

  TT = 8
  K$ = LineEditTT$(56)
  IF LEN(K$) = 0 THEN EXIT SUB
  IF AscVal(RIGHT$(K$,1)) <> 92 THEN K$ = K$ + Short$(426)
  SELECT CASE FindF(K$ + Short$(645),FFile)
    CASE IS <> 0
         TT = 238
         CALL SendTT
         DO
           TT$ = Short$(130) + ExpandFileName$(FFile.FName) + Short$(78) + _
                 Form2$(11,FFile.FSize) + Short$(647) + FFile.FDate
           IF FindF(Null$,FFile) <> 0 _
              THEN TT$ = TT$ + Short$(230) + ExpandFileName$(FFile.FName) + _
                         Short$(78) + Form2$(11,FFile.FSize) + Short$(647) + _
                         FFile.FDate + Short$(169)
           CALL SendTT
         LOOP UNTIL FindF(Null$,FFile) = 0 OR TGot > 0
    CASE ELSE
         TT = 9
         CALL SendTT
  END SELECT
  CALL DispCRLF
  CALL Paused

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will delete a file anywhere.
        '
        ' Date last checked for perfection: Sep 15 1992
        '
SUB KillAFile

  TT = 7
  K$ = LineEditTT$(42)
  IF FindF(K$,FFile) <> 0 THEN CALL KillFile(K$) : _
                               TT = 194 _
                          ELSE TT = 195
  CALL SendTT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will add text to the news file.
        '
        ' If you put in a news item, then re-run this routine and tack
        ' on another news item.  The additional news item appears on
        ' the very next line after the first item.  So, when adding
        ' additional items, put a space on the first line (line 1) of
        ' the new item to add a separator line in the news file.
        '
        ' It's just like messages.  Use SendTT color codes to add
        ' color (' }x').
        '
        ' Date last checked for perfection: Sep 3 1992
        '
SUB MakeNews

  TT = 199
  CALL SendTT
  MessageBody$ = Null$
  CALL GetMessageText(0)
  IF FindF(FileNames$(23),FFile) = 0 AND LEN(MessageBody$) = 0 THEN EXIT SUB
  K0$ = Null$
  K = 1
  DO
    CALL FindMsgLine(K,Settings.NewsWidth,5,K$,K0,K1)
    K0$ = K0$ + SPACE$((81 - Settings.NewsWidth) \ 2 - 1) + K$ + C1310$
    K = K + 1
  LOOP UNTIL K0 = -1
  CALL SharedWriteEOF(23,-1,K0$)
  TT = 4
  CALL SendTT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine is a direct I/O link between the software,
        ' fossil, and modem.
        '
        ' Date last checked for perfection: Sep 15 1992
        '
SUB PortDebugger

  CommPort = 0
  TT = 16
  K$ = LineEditTT$(1)
  IF LEN(K$) = 0 THEN CommPort = Settings.CommPort : _
                      EXIT SUB
  CALL DispCRLF
  CALL DispCRLF
  CommPort = Val2&(K$)
  K = 0
  WHILE K <> 6400
    K = FosIntAX(CommPort,&H2000)
    IF K > 0 AND K < 256 THEN CALL Ansi(AscChr$(K))
    K = KBin
    IF K > 0 AND K < 256 THEN CALL BlockOut(CommPort,AscChr$(K))
  WEND
  CommPort = Settings.CommPort

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will clear the vote answer field for a vote
        ' from all the users in the USERS file.
        '
        ' Date last checked for perfection: Sep 15 1992
        '
SUB ResetVote

  CALL DispBlockText(5,Null$)
  TT$ = Null$
  CALL GetNumPlusTT(Null$)
  K = Val2&(TGot$)
  IF K = 0 OR K > 100 THEN EXIT SUB
  TT = 10146
  CALL SendTT
  K3 = FileOpen(FileNames$(1))
  K& = FileLof&(K3,1)
  K0& = -290
  K$ = SPACE$(100)
  FOR K0 = 1 TO K& \ 384
    K0& = K0& + 384
    CALL FileGetSLoc(K3,K0&,K$)
    MID$(K$,K,1) = C0$
    CALL FilePutSLoc(K3,K0&,K$)
    CALL ShowTheGauge(K&,K0&)
  NEXT
  CALL FileClose(K3)
  MID$(User.Votes,K,1) = C0$

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine does an upload or download to/from any
        ' directory.
        '
        ' Date last checked for perfection: Sep 15 1992
        '
SUB SysopTransfer

  TT = 183
  CALL SendTT
  CALL AdjustProtocol(User.Protocol)
  K1$ = MID$(TT$,54,40)
  SELECT CASE Menu.ShouldDo
    CASE Short$(827)
         TT = 10
         K0$ = LineEditTT$(52)
         IF LEN(K0$) = 0 THEN EXIT SUB
         IF AscVal(RIGHT$(K0$,1)) = 92 THEN K0$ = LEFT$(K0$,LEN(K0$) - 1)
         TT = 17
         K$ = ProtocolUp$
         CALL DirUse(K0$ + C0$)
    CASE Short$(828)
         TT = 18
         K0$ = LineEditTT$(42)
         IF LEN(K0$) = 0 THEN EXIT SUB
         TT = 19
         CALL KillFile(FileNames$(49))
         CALL SharedWriteEOF(49,0,K0$)
         K$ = ProtocolDn$
  END SELECT
  CALL SendTT
  CALL ShellDos(0,K$)
  CALL KillFile(K1$)

END SUB
        '
        '* * * *


