' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will alter a user's High File Pointer to that
        ' of a previous day.
        '
        ' The summary log record that contains the information is of
        ' the form:  3 xx-xx-xxxx xxxxxxxxxx
        ' Which contains the line type ('3'), that date, and the
        ' HiFilePtr value at the start of that date.
        '
        ' If the user doesn't find a day they like from there, then
        ' we go through the users file looking for days.
        '
        ' The list of users will probably contain some multiple
        ' dates--as these are users with different HiFilePtr's, but
        ' last called on the same date.  But they'll be in order, so
        ' the date listed first will be slightly older than the next
        ' same date, etc.
        '
        ' Date last checked for perfection: Sep 2 1992
        '
SUB AlterFilePtr

  CALL DispBlockText(6,C13$)
  IF TGot > 0 THEN EXIT SUB
  K3 = FileOpen(FileNames$(50))
  K& = 0
  K0& = FileLof&(K3,1)
  K = 1
  K0$ = SPACE$(8192)
  K1$ = C10$ + Short$(112)
  DO
    CALL FileGetSLoc(K3,K&,K0$)
    K2 = StrSrch(1,K0$,K1$)
    IF K2 <= 0 THEN K& = K& + 8190 _
               ELSE K& = K& + K2 : _
                    K$ = FileGetLine$(K3,K&) : _
                    SWork$(K) = MID$(K$,3,10) : _
                    FWork(K).FSize = Val2&(K$) : _
                    K = K + 1 : _
                    IF K0& - K& < 8192 THEN K0$ = SPACE$(K0& - K&)
    IF K& > 0 THEN CALL ShowTheGauge(K0&,K&)
  LOOP UNTIL K& >= K0& OR K& = -1 OR K = Settings.MaxFilesInDir
  SWork$(K) = GetLine$(436)
  FOR K7 = 1 TO 2
    SELECT CASE K7
      CASE 2
           TT = 407
           CALL SendTT
           K3 = FileOpen(FileNames$(1))
           K = 0
           K0& = FileLof&(K3,1)
           K1& = -384
           FOR K0 = 1 TO K0& \ 384
             K1& = K1& + 384
             CALL FileGetLoc(K3,K1& + 207,2,K4)  'LastDateOn
             K0$ = IntToDate3$(K4)
             CALL FileGetLoc(K3,K1& + 223,4,K&)  'HiFilePtr
             FOR K4 = 1 TO K
               IF FWork(K4).FSize = K& THEN EXIT FOR
               IF FWork(K4).FSize > K& THEN SWAP SWork$(K4),K0$ : _
                                            SWAP FWork(K4).FSize,K&
             NEXT
             IF K4 > K AND K4 < Settings.MaxFilesInDir THEN K = K4
             IF FWork(K4).FSize <> K& THEN SWork$(K4) = K0$ : _
                                           FWork(K4).FSize = K&
             CALL ShowTheGauge(K0&,K1&)
           NEXT
    END SELECT
    CALL FileClose(K3)
    TT = 10406
    CALL SendTT
    CALL Wipe(39)
    SWork$(K + 1) = Null$
    TT = 283
    CALL MenuSystemTT
    IF TGot <> K AND K7 = 1 THEN EXIT FOR
  NEXT
  IF TGot > 0 THEN User.HiFilePtr = FWork(TGot).FSize : _
                   TT = 603 : _
                   CALL SendTT

END SUB
        '
        '* * * *

