' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine will create the initial NODELIST.DAT files from
        ' the occasional total nodelist.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB CreateNodeList

  IF CommPort <> 0 THEN EXIT SUB
  TT = 211
  K$ = LineEditTT$(40)
  IF LEN(K$) = 0 THEN EXIT SUB
  IF FindF(K$,FFile) = 0 THEN TT = 191 : _
                              CALL SendTT : _
                              EXIT SUB
  TT$ = GetLine$(214)
  FOR K1 = 7 TO 24 STEP 6
    FOR K2 = 1 TO 5
      TT$ = TT$ + AnsiLocStr$(K1 + K2,2) + STRING$(38,32) + Short$(1007) + _
            STRING$(38,32)
    NEXT
  NEXT
  CALL AnsiTT
  FOR K1 = 1 TO 100
    Work(K1) = 0
  NEXT
  K11 = FileOpen(K$)
  k0& = FileLof&(K11,1)
  K& = 0
  CALL KillFile(FileNames$(70))
  CALL KillFile(FileNames$(73))
  K1 = FileOpen(FileNames$(70))
  K2 = FileOpen(FileNames$(73))
  K = 0
  K0 = 0
  K3 = 0
  kz1 = 0
  kz2 = 0
  DO
    K$ = FileGetLine$(K11,K&)
    K5 = 0
    IF LEFT$(K$,4) = Short$(874) THEN K5 = 1
    IF LEFT$(K$,6) = Short$(875) OR LEFT$(K$,4) = Short$(876) THEN K5 = 2
    IF LEFT$(K$,3) = Short$(877) THEN K5 = 3 : _
                                      K9 = 2 _
                                 ELSE K9 = 0
    IF LEFT$(K$,3) = Short$(1008) OR LEFT$(K$,4) = Short$(1009) _
       OR LEFT$(K$,4) = Short$(1010) _
       THEN K5 = 5
    IF AscVal(K$) = 44 THEN K5 = 4
    IF LEN(K$) < 15 THEN K5 = 0
    SELECT CASE K5
      CASE IS > 0
           K7 = 0
           FOR K6 = 1 TO 7
             K8 = K7
             K7 = StrSrch(K8 + 1,K$,Short$(501))
             SELECT CASE K6
               CASE 1
                    '
                    ' Process the BBS's FidoNet status.
                    '
                    SWork$(6) = MID$(K$,K8 + 1,K7 - K8 - 1)
                    IF K5 = 5 THEN K5 = 0
               CASE 2
                    '
                    ' Process the node/net information.
                    '
                    K4 = Val2&(MID$(K$,K8 + 1,K7 - K8 - 1))
                    IF K5 = 1 THEN K0 = K4 : _
                                   K3 = 0 : _
                                   K4 = 0
                    IF K5 = 2 THEN K3 = K4 : _
                                   K4 = 0
               CASE 3
                    '
                    ' Process the BBS's name.
                    '
                    Node.BBSName = MID$(K$,K8 + 1,K7 - K8 - 1)
                    CALL ReplaceCharacters(Node.BBSName,95,Null$,32)
               CASE 4
                    '
                    ' Process the BBS's location.
                    '
                    SWork$(1) = MID$(K$,K8 + 1,K7 - K8 - 1)
               CASE 5
                    '
                    ' Process the sysop's name.
                    '
                    SWork$(2) = MID$(K$,K8 + 1,K7 - K8 - 1)
               CASE 6
                    '
                    ' Process the BBS phone number.
                    '
                    K0$ = MID$(K$,K8 + 1,K7 - K8 - 1)
                    SWork$(3) = K0$
                    IF LEFT$(K0$,2) = Short$(869) THEN K0$ = MID$(K0$,3)
                    Node.BBSPhone = 0
                    IF LEN(K0$) = 12 AND K0 = 1 _
                       THEN Node.BBSPhone = Val2&(MID$(K0$,2,1) + _
                                            MID$(K0$,1,1) + MID$(K0$,3,1) + _
                                            MID$(K0$,5,3) + RIGHT$(K0$,4)) _
                       ELSE K5 = 0
               CASE 7
                    '
                    ' Process the BBS's other info.
                    '
                    SWork$(4) = MID$(K$,K8 + 1,K7 - K8 - 1)
                    SWork$(5) = MID$(K$,K7 + 1)
                    K0$ = MID$(K$,K8 + 1,4)
                    IF K0$ <> Short$(280) AND K0$ <> Short$(799) _
                       AND K0$ <> Short$(870) AND K0$ <> Short$(871) _
                       THEN K5 = 0
             END SELECT
           NEXT
           IF StrSrch(1,MID$(K$,K7),Short$(872)) > 0 THEN K9 = K9 + 1
           IF K0 <> 1 THEN K5 = 0
           SELECT CASE K5
             CASE 0
                  '
                  ' Reject the address.
                  '
                  IF KZ1 = 7 THEN KZ = 13 _
                             ELSE IF KZ1 = 13 THEN KZ = 19 _
                                              ELSE KZ = 7
                  KZ1 = KZ
                  kzz = 42
             CASE ELSE
                  '
                  ' Accept the address.
                  '
                  Node.Flags = AscChr$(K9)
                  Node.Addr = (BitsShl(K0,13) + K3) * 32768& + K4
                  K = K + 1
                  TT$ = Short$(1011) + LTRIM$(STR$(K)) + Short$(1012)
                  CALL AnsiTT
                  CALL ShowTheGauge(K0&,K&)
                  CALL FilePutRec(K1,K,34,Node)
                  IF kz2 = 7 THEN kz = 13 _
                             ELSE IF kz2 = 13 THEN kz = 19 _
                                              ELSE kz = 7
                  kz2 = kz
                  kzz = 2
           END SELECT
           TT$ = Short$(1013)
           FOR K6 = 1 TO 5
             K13 = kz + k6 + kzz
             SELECT CASE K6
               CASE 1 : K0$ = Form$(3301,FidoForm$(K0,K3,K4) + C32$ + _
                              SWork$(6) + Short$(867) + SWork$(3)) + _
                              Form$(502,SWork$(4))
               CASE 2 : K0$ = Short$(1014) + SWork$(2)
                        K10 = LEN(K0$)
                        IF K10 > 48 THEN K0$ = LEFT$(K0$,48) : _
                                         K10 = 48 _
                                    ELSE K12 = Work(k13) - K10 : _
                                         IF K12 > 0 THEN K0$ = K0$ + SPACE$(K12)
                        Work(k13) = K10
               CASE 3 : K0$ = Short$(95) + Node.BBSName
                        K10 = LEN(K0$)
                        IF K10 > 45 THEN K0$ = LEFT$(K0$,45) : _
                                         K10 = 45 _
                                    ELSE K12 = Work(k13) - K10 : _
                                         IF K12 > 0 THEN K0$ = K0$ + SPACE$(K12)
                        Work(k13) = K10
               CASE 4 : K0$ = Short$(1014) + SWork$(1)
                        K10 = LEN(K0$)
                        IF K10 > 48 THEN K0$ = LEFT$(K0$,48) : _
                                         K10 = 48 _
                                    ELSE K12 = Work(k13) - K10 : _
                                         IF K12 > 0 THEN K0$ = K0$ + SPACE$(K12)
                        Work(k13) = K10
               CASE 5 : K0$ = LTRIM$(SWork$(5))
                        K10 = LEN(K0$)
                        IF K10 > 38 THEN K0$ = LEFT$(K0$,38) : _
                                         K10 = 38 _
                                    ELSE K12 = Work(k13) - K10 : _
                                         IF K12 > 0 THEN K0$ = K0$ + SPACE$(K12)
                        Work(k13) = K10
             END SELECT
             TT$ = TT$ + AnsiLocStr$(Kz + K6,kzz) + K0$   'Form$(3801,K0$)
           NEXT
           CALL ReplaceCharacters(TT$,95,Null$,32)
           CALL ReplaceCharacters(TT$,44,Null$,32)
           CALL SendTT
           IF TGot > 0 THEN EXIT DO
    END SELECT
    IF K5 = 0 THEN CALL FilePutSEnd(K2,K$)
  LOOP UNTIL K& = -1 OR LEFT$(K$,6) = Short$(873)
  CALL FileClose(K11)
  CALL FileClose(K2)
  CALL FileClose(K1)
  k = TGot
  TT = 213
  CALL SendTT
  IF k > 0 THEN TT = 533 : _
                CALL SendTT : _
                CALL Paused _
           ELSE CALL ShellDos(10,Null$)

END SUB
        '
        '* * * *

