;
; This routine will delete a directory.
;
; Usage:  CALL DirDelete (Input$)
;
; Where Input$ is a "\" terminated directory name to create.
;
; Upon exit, the final "\" will have been turned into a CHR$(0).
;
; It's assumed there is a "x:\" for the first 3 characters of Input$.
;

.Model Medium, Basic
.Code

            PUBLIC  DirDelete         ;Make this routine available to LINK.

DirDelete   proc    far               ;Beginning of routine.

            push    bp
            mov     bp,sp

            mov     bx,[bp + 06]      ;Get descriptor of the string.
            mov     cx,[bx]           ;Get string size in CX.
            mov     dx,[bx + 02]      ;String location -> DX.
            mov     bx,dx             ;Point to start of string.
            add     bx,cx             ;Move to last "\" + 1.
            dec     bx                ;Move onto last "\".
            mov     byte ptr [bx],0   ;Add the "Z" in ASCIIZ.
            mov     ah,3AH            ;DOS subfunction 3AH.
            int     21H               ;Call the fossil.

            pop     bp
            ret     2                 ;Pop-return past our input parameter.

DirDelete   endp                      ;End of routine.

End


