' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine expands various %x codes.
        '
        ' p$  is the string to process.
        '     Expandables are:
        '       %B   Baud rate
        '       %D   path to where the door files are
        '       %L   control file (file of filenames) (TEMPFILE)
        '       %N   node number
        '       %P   Comm port
        '       %S   Locked baud rate (either 19200 or 2400).
        '       %U   path to current files area (ul path usually)
        '
        ' Date last checked for perfection: Sep 20 1992
        '
SUB ExpandStr (p$)

  FOR K2 = 1 TO 11 STEP 2
    K2$ = MID$(Short$(945),K2,2)
    K3 = StrSrch(1,p$,K2$)
    WHILE K3 > 0
      K0$ = Null$
      SELECT CASE K2
        CASE 1  : K0$ = WordsGet$(Connect$,1,K1)
        CASE 3  : K0$ = RTRIM$(Door.Path)
        CASE 5  : K0$ = FileNames$(49)
        CASE 7  : K0$ = LTRIM$(STR$(Settings.Node))
        CASE 9  : K0$ = LTRIM$(STR$(CommPort))
        CASE 11 : K0$ = RTRIM$(FileBases(FileIndex).Path)
        CASE 13 : K0$ = Short$(456 + BitTest(Toggles(2),10))
      END SELECT
      p$ = LEFT$(p$,K3 - 1) + K0$ + MID$(p$,K3 + 2)
      K3 = StrSrch(K3 + LEN(K0$),p$,K2$)
    WEND
  NEXT

END SUB
        '
        '* * * *

