' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine inputs, and searches Files.IDX, for a file
        ' name.
        '
        ' p   contains the array location in Files.IDX if found.
        '      0 if not found.
        '     -1 if partially found (has one or more neighbors
        '        identical).
        '     -2 if backspace was hit with a NULL field.
        '
        ' p$  will contain the trimed filename (if found).
        '
        ' FileIDX will contain the entry if found.
        '
        ' Just use 'IF p < 1 THEN EXIT SUB' to exit when a bad name or
        ' no name is entered.  This might cause confusion should they
        ' enter part of a name then hit return, or backspace past the
        ' beginning while correcting a mistake.  But Download makes
        ' use of the methods and should help them to understand.
        '
        ' This routine will not handle any file names not contained in
        ' the Files.IDX file.
        '
        ' ':', '\', and '/' are among the characters not allowed.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB GetFileName (p$,p)

  K7 = p
  IF p < 0 THEN p = - p
  DO
    p$ = SPACE$(12)
    K0 = 0
    K0$ = Short$(234) + C13$ + C8$
    IF NOT BitTest(Toggles(1),3) THEN K0$ = K0$ + C32$
    DO
      p = -1
      CALL TGet(K0$)
      SELECT CASE TGot
        CASE 8
             IF K0 = 0 THEN p = -2 : _
                            p$ = Null$ : _
                            EXIT SUB
             K0 = K0 - 1
             CALL Wipe(1)
        CASE 32 : Tgot = -1
        CASE IS > 32
             K0 = K0 + 1
             MID$(p$,K0,1) = TGot$
             p = BiSearch(3,0,LEFT$(p$,K0))
             SELECT CASE p
               CASE IS > 0
                    p$ = FileIDX.FName + C32$
                    K4 = 1
                    K3 = K0 + 1 : K2 = 1 : K1 = 0     'Added for AI independence.
                    CALL AI(3,p$,p,K0,K1,K2,K3,0&,0&)
                    IF (K3 = 13 OR (K3 = LEN(RTRIM$(p$)) + 1 AND p > 0)) AND (K2 - K1 = 0) _
                       THEN K4 = 2                 'Added for AI independence.
                    IF K4 = 2 AND RTRIM$(User.UserName) <> Null$ _
                       AND ((BitTest(FileIDX.Attr,6) AND UserSL <> LevelsSize) _
                       OR (FileBases(FileIDX.FArea).DLSL > Levels(UserSL).SecLevel)) _
                       OR (BitTest(User.Attr,10) AND NOT BitTest(FileBases(FileIDX.FArea).Attr,6)) _
                       THEN K4 = 3 : _
                            K0 = K0 - 1
                    IF K4 <> 3 THEN TT$ = MID$(p$,K0,K3 - K0) : _
                                    CALL SendTT : _
                                    K0 = K3 - 1 : _
                                    IF K4 = 2 THEN TGot = -1 _
                                              ELSE IF K2 - K1 > 0 THEN TGot = 1
               CASE ELSE : K0 = K0 - 1
             END SELECT
      END SELECT
    LOOP UNTIL TGot = -1
    IF NoCarrier THEN K0 = 0
    p$ = LEFT$(p$,K0)
    IF NOT BitTest(Toggles(1),3) _
       THEN IF p = -1 THEN p = BiSearch(3,0,Form$(1201,p$)) : _
                           IF p = 0 THEN p = -1
    IF p <= 0 OR K0 = 0 THEN K7 = 0
    IF K7 < 0 AND p > 0 THEN CALL TGet(C13$ + C8$ + C32$) : _
                             IF TGot = 8 THEN CALL Wipe(LEN(p$)) : _
                                              p$ = Null$ _
                                         ELSE K7 = 0
  LOOP UNTIL K7 >= 0

END SUB
        '
        '* * * *

