' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' Included in this package:
'   Initializer2
'   BootStuff2
'   DirectryStart
'   BootUpStatus2
'   BuildMsgPtr
'   InitNewUser





        '* * * * * *
        ' This routine will handle more initialization stuff.
        '
        ' The Initializer routine is in two parts to reduce the size
        ' of the overlays.
        '
        ' It's called when the BBS is started up, and when the system
        ' is restarted after a shutdown (for doors).
        '
        ' Date last checked for perfection: Sep 16 1992
        '
SUB Initializer2

  '
  ' Create the user file if needed.  Build the user index if it is not there.
  '
  CALL BootUpStatus2(7)
  K = FindF(FileNames$(1),FFile)
  IF K = 0 THEN CALL InitNewUser
  K = FindF(FileNames$(56),FFile)
  IF K = 0 OR FFile.FSize < 31 THEN CALL BootStuff2(4) _
                               ELSE Handle(21) = FileOpen(FileNames$(56))
  CALL BootUpStatus2(9)
  '
  ' Build messages index.  Load up MsgPtr().
  '
  CALL BootUpStatus2(14)
  IF FindF(FileNames$(2),FFile) <> FindF(FileNames$(57),FFile) _
     THEN CALL BootStuff2(5) _
     ELSE K = FileOpen(FileNames$(57)) : _
          ActiveMessages = FileLof&(K,14) - 1 : _
          FOR K0 = 0 TO ActiveMessages : _
            CALL FileGetRec(K,K0 + 1,14,MsgPtr(K0)) : _
          NEXT : _
          CALL FileClose(K) : _
          CALL BootUpStatus2(19)
  '
  ' Build files index.  Special processing is done for deleted or found files.
  '
  CALL BootStuff2(6)
  '
  ' Get the various hot key's that each menu uses.  Not put above above because
  ' MENUTEXT.DAT will be read in faster from the ram drive.
  '
  K = FileOpen(FileNames$(35))
  CALL FileGetRec(K,FileLof&(K,38),38,Menu)
  MenusSize = Val2&(Menu.Index)
  DIM ValidChoice$(MenusSize)
  FOR K0 = 1 TO FileLof&(K,38)
    CALL FileGetRec(K,K0,38,Menu)
    IF Menu.Filler7 <> C1310$ _
       THEN TT$ = BlockText2(316) + STR$(K0) + BlockText2(334) : _
            CALL SendTT : _
            SYSTEM
    IF AscVal(Menu.HotKey) <> 126 _
       THEN K1 = Val2&(Menu.Index) : _
            ValidChoice$(K1) = ValidChoice$(K1) + Menu.HotKey
  NEXT
  CALL FileClose(K)
  '
  ' Build the buffer file if needed.
  '
  IF FindF(FileNames$(11),FFile) = 0 _
     THEN CALL BootStuff2(7) _
     ELSE IF FFile.FSize <> Settings.BufferSize * 4096 THEN CALL BootStuff2(7)
  '
  ' Build the Directry indexes if needed.
  '
  K = NonStop
  FOR K0 = 1 TO 99
    K$ = Form4$(2,K0)
    K1 = FindF(FileNames$(44) + K$,FFile)      'DIRECTRY.Dxx
    IF K1 <> 0 _
       THEN IF K1 <> FindF(FileNames$(46) + K$,FFile) _
               THEN IF K = 0 THEN CALL BootUpStatus2(20) : _
                                  K = 1 : _
                                  CALL DirectryStart(K$) _
                             ELSE CALL DirectryStart(K$)
  NEXT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to initializer, handles some of the
        ' actual work.
        '
        ' p  4 to build USERS.IDX USERS.IDX.
        '    5 to load up MsgPtr() from MESSAGES (vs. MESSAGES.IDX).
        '    6 to match on-line files with active files.
        '    7 to rebuild the buffer file.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB BootStuff2 (p)

  SELECT CASE p
    CASE 4
         K2 = FileOpen(FileNames$(1))
         K& = FileLof&(K2,1)
         Handle(21) = FileOpen(FileNames$(56))
         K0& = -295
         K4 = 0
         FOR K = 1 TO FileLof&(K2,384)
           K0& = K0& + 384
           CALL FileGetLoc(K2,K0&,2,K3)
           SELECT CASE BitTest(K3,1)
             CASE 0
                  CALL FileGetRec(K2,K,384,AnyUser)
                  K1 = AscVal(AnyUser.UserName)
                  IF NonStop = 0 THEN CALL ShowTheGauge(K&,K0&)
                  IF K1 < 32 OR K1 > 90 _
                     THEN AnyUser.Attr = AnyUser.Attr + 1 : _
                          CALL FilePutRec(K2,K,384,AnyUser) _
                     ELSE UserIDX.UserName = AnyUser.UserName : _
                          UserIDX.RecNum = K : _
                          K4 = K4 + 1 : _
                          CALL FilePutRec(Handle(21),K4,32,UserIDX)
           END SELECT
         NEXT
         CALL FileClose(K2)
         CALL FileSort(Handle(21),32)
    CASE 5
         CALL BuildMsgPtr
         CALL BootUpStatus2(18)
    CASE 6
         CALL BootUpStatus2(21)
         K = FindF(FileNames$(59),FFile)
         IF FFile.FSize < 21 THEN K = 0
         Handle(22) = FileOpen(FileNames$(59))
         SELECT CASE K
           CASE 0
                K1 = 0
                K = FileOpen(FileNames$(4))
                K& = -4
                FOR K0 = 1 TO FileLof&(K,119)
                  K& = K& + 119
                  CALL FileGetLoc(K,K&,2,K3)
                  IF NOT BitTest(K3,1) _
                     THEN CALL FileGetRec(K,K0,119,FileList) : _
                          FileIDX.FName = FileList.FName : _
                          FileIDX.FSize = FileList.FSize : _
                          FileIDX.FRec = K0 : _
                          FileIDX.Attr = K3 : _
                          FileIDX.FArea = FileList.FArea : _
                          K1 = K1 + 1 : _
                          CALL FilePutRec(Handle(22),K1,22,FileIDX)
                NEXT
                CALL FileClose(K)
                CALL FileSort(Handle(22),22)
         END SELECT
         '
         ' Build a temp file of what's on-line.
         '
         K = FileOpen(FileNames$(10))
         FOR K0 = 1 TO DirsSize
           IF FindF(RTRIM$(FileBases(K0).Path) + Short$(645),FFile) <> 0 _
              THEN DO : CALL FilePutSEnd(K,FFile.FName) : _
                   LOOP UNTIL FindF(Null$,FFile) = 0
         NEXT
         CALL FileSort(K,12)
         '
         ' Compare our FILES.IDX with our list of what's on-line.
         '
         K1 = 0
         K2 = FileOpen(FileNames$(4))
         K3 = FileLof&(Handle(22),22) + 1
         K& = FileLof&(K,1)
         K$ = FileIDX.FName
         DO
           SELECT CASE FileIDX.FName
             CASE IS > K$
                  '
                  ' Files that have disappeared off the drive(s).  Officially
                  ' remove them.
                  '
                  CALL FileGetRec(K2,FileIDX.FRec,119,FileList)
                  CALL RemoveReview(RTRIM$(FileIDX.FName),0)
                  TT$ = GetLine$(267) + FileIDX.FName + C32$ + _
                        RTRIM$(FileList.FDesc)
                  CALL LogTT
                  IF NOT BitTest(FileList.Attr,7) _
                     THEN CALL SharedWriteEOF(24,0,FileList.FName + _
                                           Form$(1066,STR$(FileList.FSize)) + _
                                           RTRIM$(FileList.FDesc))
                  CALL BitSet(FileList.Attr,1)
                  CALL FilePutRec(K2,FileIDX.FRec,119,FileList)
                  FileIDX.FName = Short$(902)
                  CALL FilePutRec(Handle(22),K3,22,FileIDX)
                  K1 = -1
             CASE IS < K$
                  '
                  ' Files that have suddenly appeared on the drive(s).
                  ' Officially add them (but make them <incomplete> for now.
                  '
                  K4 = 0
                  K0& = -119
                  K0$ = K$
                  FOR K5 = FileLof&(K2,119) TO 1 STEP -1
                    K0& = K0& + 119
                    CALL FileGetSLoc(K2,K0&,K0$)
                    SELECT CASE K0$
                      CASE K$
                           CALL FileGetRec(K2,K5,119,FileList)
                           '
                           ' If a file exists on the disk, but is marked as
                           ' deleted, then undelete it.
                           '
                           IF BitTest(FileList.Attr,1) _
                              THEN TT$ = GetLine$(266) + FileList.FName + _
                                         C32$ + RTRIM$(FileList.FDesc) : _
                                   CALL LogTT : _
                                   FileList.Attr = FileList.Attr - 1 : _
                                   CALL FilePutRec(K2,K5,119,FileList)
                           FileIDX.FName = FileList.FName
                           FileIDX.FSize = FileList.FSize
                           FileIDX.FRec = K5
                           FileIDX.Attr = FileList.Attr
                           FileIDX.FArea = FileList.FArea
                           CALL FilePutRec(Handle(22),FileLof&(Handle(22),22) + 1,22,FileIDX)
                           K4 = 1
                           EXIT FOR
                    END SELECT
                  NEXT
                  SELECT CASE K4
                    CASE 0
                         User.UserName = Settings.Sysop
                         LogonDate = DateToInt(DATE$)
                         FOR FileIndex = 1 TO DirsSize
                           IF FindF(RTRIM$(FileBases(FileIndex).Path) + K$,FFile) <> 0 _
                              THEN CALL CreateFileStuff(3,64,0,K2) : _
                                   CALL FilePutRec(K2,FileLof&(K2,119) + 1,119,FileList) : _
                                   EXIT FOR
                       NEXT
                  END SELECT
                  K3 = K3 + 1                       'Need to reload FileIDX
                  K1 = 0
             CASE ELSE : K1 = 0
           END SELECT
           IF K1 <= 0 _
              THEN K3 = K3 - 1 : _
                   IF K3 > 0 THEN CALL FileGetRec(Handle(22),K3,22,FileIDX) _
                             ELSE FileIDX.FName = Short$(815)
           IF K1 >= 0 THEN K& = K& - 12 : _
                           IF K& >= 0 THEN CALL FileGetSLoc(K,K&,K$) _
                                      ELSE K$ = Short$(815)
         LOOP UNTIL K3 < 1 AND K& < 0
         CALL FileClose(K)
         CALL FileClose(K2)
         CALL KillFile(FileNames$(10))
         CALL FileSort(Handle(22),22)
         CALL FileGetRec(Handle(22),FileLof&(Handle(22),22),22,FileIDX)
         WHILE FileIDX.FName = Short$(902)
           CALL FilePutLoc(Handle(22),FileLof&(Handle(22),1) - 22,0,FileIDX)
           CALL FileGetRec(Handle(22),FileLof&(Handle(22),22),22,FileIDX)
         WEND
         CALL BootUpStatus2(22)
    CASE 7
         CALL KillFile(FileNames$(11))
         K0 = FileOpen(FileNames$(11))
         FOR K = 1 TO Settings.BufferSize
           CALL FilePutSEnd(K0,SPACE$(4096))
         NEXT
         CALL FileClose(K0)
  END SELECT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to Initialize, builds the index
        ' (DIRECTRY.Ixx) files for whatever DIRECTRY files exist.
        '
        ' p$  contains the 'xx' for the file names to use.
        '
        ' Even though it may actually add extra space, I usually end
        ' all the DIRECTRY.Dxx files with a '%%%' as well.
        '
        ' DIRECTRY.Dxx for the text, DIRECTRY.Txx for the menu
        ' selection titles.
        '
        ' For LENGTH files, the only real way to determine the lengths
        ' is by trial and error.
        '
        ' The DIRECTRY.Dxx file structures are below.
        '
        ' The DIRECTRY.Txx structure:
        '   First line: SendTT line of text that makes up the heading.
        '   2nd line: Text of what question to ask.
        '   n lines: n lines of titles for each group of text in
        '            DIRECTRY.Dxx file.
        '
        ' For a lot of entries: using a max title width of 20 will get
        ' you 3 entries per line.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB DirectryStart (p$)

  K3 = FileOpen(FileNames$(44) + p$)            'DIRECTRY.Dxx
  CALL KillFile(FileNames$(46) + p$)            'DIRECTRY.Ixx
  K1 = FileOpen(FileNames$(46) + p$)
  K& = 0
  K0$ = FileGetLine$(K3,K&)                     'Get the data type.
  k$ = FileGetLine$(K3,K&)                      'Past the header type.
  K0 = 0
  DO
    K0& = K&
    k$ = FileGetLine$(K3,K&)                    'Get the next line.
    K0 = K0 + 1
    SELECT CASE LEFT$(K0$,4)
      CASE Short$(407)
           '
           ' LINE files consist of:  LINE
           '                         HEADER/NOHEADER
           '                         %%%
           '                         text line 1
           '                         text line 2
           '                         text line 3
           '                         . . .
           '                         text line n
           '
           CALL FilePutRec(K1,K0,4,K&)         'Store start of line.
      CASE Short$(408)
           '
           ' BLOCK files consist of:  BLOCK
           '                          HEADER/NOHEADER
           '                          %%%
           '                          text line 1
           '                          . . .
           '                          text line n
           '                          %%%
           '                          text line 1
           '                          etc.
           '
           IF k$ = Short$(503) THEN CALL FilePutRec(K1,K0,4,K&) _
                               ELSE K0 = K0 - 1      'Store start of block.
      CASE Short$(410)
           '
           ' LENGTH files consist of:  LENGTH
           '                           HEADER/NOHEADER
           '                           %%%
           '                           size
           '                           text of size bytes
           '                           %%%
           '                           size
           '                           etc.
           '
           IF K& > 0 THEN k$ = FileGetLine$(K3,K&)   'Get length of the text.
           CALL FilePutRec(K1,K0 * 2 - 1,4,K&)  'Store the start.
           K0& = Val2&(k$)
           IF K0& = 0 THEN K0& = 4096           'Off-block, so skip fast
                                                'past the rest.
           CALL FilePutRec(K1,K0 * 2,4,K0&)     'Store the length.
           IF K& > 0 THEN K& = K& + K0&         'Jump over the text.
      CASE ELSE
           TT$ = GetLine$(534) + FileNames$(44) + p$ + GetLine$(535)
           CALL LogTT
           EXIT DO
    END SELECT
  LOOP UNTIL K& = -1
  CALL SameDate(K3,K1)
  CALL FileClose(K1)
  CALL FileClose(K3)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine, internal to Initializer, displays the 'what's
        ' happening during initialization' messages.
        '
        ' p   which message to display.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB BootUpStatus2 (p)

  IF NonStop <> 0 THEN EXIT SUB
  SELECT CASE p
    CASE 7 : TT$ = Short$(888) + LTRIM$(STR$(1 * 5 + 3)) + GetLine$(251) + _
                   STR$(FRE(0)) + STR$(FRE(-2)) + STR$(FRE(-1)) + C1310$ + _
                   GetLine$(254)
    CASE 9
         K2 = FileOpen(FileNames$(1))
         K3 = FileLof&(K2,384)
         CALL FileClose(K2)
         K2 = FileLof&(Handle(21),32)
         TT$ = STR$(K3 - K2) + GetLine$(255) + STR$(K2) + GetLine$(256)
    CASE 14 : TT = 261
    CASE 18 : TT$ = STR$(TT&) + GetLine$(262) + _
                    STR$(ActiveMessages + 1) + GetLine$(263)
    CASE 19 : TT$ = GetLine$(261) + STR$(ActiveMessages + 1) + GetLine$(263)
    CASE 20 : TT = 236
    CASE 21 : TT = 269
    CASE 22 : K2 = FileOpen(FileNames$(4))
              K3 = FileLof&(K2,119)
              CALL FileClose(K2)
              K2 = FileLof&(Handle(22),22)
              TT$ = STR$(K3 - K2) + GetLine$(270) + STR$(K2) + GetLine$(271)
  END SELECT
  CALL AnsiTT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine rebuilds our MsgPtr index after undeleting
        ' messages, or when starting up (if .IDX is incorrect).
        '
        ' Returns the number of deleted messages in TT&.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB BuildMsgPtr

  TT& = 0
  ActiveMessages = -1
  K0& = FileLof&(Handle(3),1)
  K& = 1
  CALL FileGetRec(Handle(3),1,128,Message)
  WHILE K& < K0&
    IF BitTest(Message.Attr,1) _
       THEN TT& = TT& + 1 _
       ELSE ActiveMessages = ActiveMessages + 1 : _
            MsgPtr(ActiveMessages).MsgLoc = K& : _
            MsgPtr(ActiveMessages).MsgNum = Message.MsgNum : _
            MsgPtr(ActiveMessages).MsgBase = Message.MsgBase : _
            MsgPtr(ActiveMessages).MsgTo = StrCkSum(Message.MsgTo) : _
            MsgPtr(ActiveMessages).MsgFrom = StrCkSum(Message.MsgFrom)
    K& = K& + Message.NumOfBytes + 128
    CALL ShowTheGauge(K0&,K&)
    CALL FileGetLoc(Handle(3),K& - 1,128,Message)
  WEND

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine re-initializes all the fields of the new user's
        ' base record.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB InitNewUser

  K = FileOpen(FileNames$(1))
  AnyUser.UserName    = Short$(626)
  AnyUser.Password    = Null$
  AnyUser.CityState   = Null$
  AnyUser.HomePhone   = 0
  AnyUser.BBSPhone    = 0
  AnyUser.BirthDate   = 0
  AnyUser.SecLevel    = 5
  AnyUser.FirstCall   = 0
  AnyUser.Attr        = 0
  AnyUser.Toggles     = 2 + 16 + 32 + 64 + 2048 + 4096 + 8192
  AnyUser.Protocol    = Short$(627)
  AnyUser.Votes       = STRING$(100,0)
  AnyUser.SubsStart   = 0
  AnyUser.SubsEnd     = 0
  AnyUser.SubsType    = Short$(628)
  AnyUser.Monies      = 0
  AnyUser.TotalMonies = 0
  AnyUser.LastDateOn  = DateToInt(DATE$)
  AnyUser.PswdChange  = C0$
  AnyUser.AlterDate   = 0
  AnyUser.JDRVerDL    = 0
  AnyUser.BullsRead   = STRING$(8,0)
  AnyUser.Connect     = C0$
  AnyUser.HiFilePtr   = 0
  AnyUser.HighestPtr  = 0
  AnyUser.PagedSysop  = 0
  AnyUser.Logons      = 0
  AnyUser.Attempts    = C0$
  AnyUser.MinCredits  = 0
  AnyUser.MinMegs     = 0
  AnyUser.MsgsPosted  = 0
  AnyUser.EMsgsPosted = 0
  AnyUser.FMsgsPosted = 0
  AnyUser.NetMailSent = 0
  AnyUser.NetMailRcvd = 0
  AnyUser.Elapsed     = 0
  AnyUser.Dnlds       = 0
  AnyUser.DLBytes     = 0
  AnyUser.MinsDLing   = 0
  AnyUser.BadDLs      = 0
  AnyUser.Uplds       = 0
  AnyUser.ULBytes     = 0
  AnyUser.MinsULing   = 0
  AnyUser.BadULs      = 0
  AnyUser.Doors       = 0
  AnyUser.Group       = 0
  AnyUser.SysopNote   = Null$
  AnyUser.UserNote    = Null$
  CALL FilePutRec(K,1,384,AnyUser)
  CALL FileClose(K)
  K$ = STRING$(LEN(UserMsgInfo$),0)
  FOR K = 1 TO BasesSize
    IF BitTest(MsgBases(K).SubType,4) THEN MID$(K$,K * 4 + 1,4) = MKL$(-1)
  NEXT
  K = FileOpen(FileNames$(3))
  CALL FilePutSLoc(K,0&,K$)
  CALL FileClose(K)
  K = FileOpen(FileNames$(5))
  CALL FilePutSLoc(K,0&,STRING$(99,0))
  CALL FileClose(K)

END SUB
        '
        '* * * *



