' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.


        '* * * * * *
        ' This routine lists the contents of a single download
        ' directory.
        '
        ' p  16 bits:
        '      1 on, if should show additional info line (uploader,
        '        etc.)
        '      2 on, if using P&S system.
        '      3 on, if should list from Z to A.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB ListDir (p)

  IF FileIndex = 32767 THEN EXIT SUB
  DO
    K4 = 0
    '
    ' Display heading information.
    '
    TT$ = BlockText2(12) + RTRIM$(FileBases(FileIndex).Title) + Short$(115)
    CALL SendTT
    IF TGot > 0 THEN EXIT SUB
    IF NOT FAccessAllowed(FileIndex) THEN TT = 324 : _
                                          CALL SendTT : _
                                          CALL Paused : _
                                          EXIT SUB
    IF FindF(RTRIM$(FileBases(FileIndex).Path) + Short$(760),FWork(1)) = 0 _
       THEN CALL Paused : _
            EXIT SUB
    '
    ' Locate all the files in the directory.
    '
    K3 = 1
    DO : K3 = K3 + 1
    LOOP UNTIL FindF(Null$,FWork(K3)) = 0
    FWork(0).FName = C0$
    CALL FWorkSort(K3 - 1)
    '
    ' Output the names with their descriptions.
    '
    K6 = FileOpen(FileNames$(4))
    IF BitTest(p,3) THEN K2 = K3 - 1 _
                    ELSE K2 = 1
    DO
      K0 = BiSearch(3,0,FWork(K2).FName)
      '
      ' No FileList entry found?  Fix this 'loose' file by giving it an entry.
      '
      IF K0 < 1 THEN FFile = FWork(K2) : _
                     CALL CreateFileStuff(3,64,0,K6) : _
                     FileList.UserName = FileBases(FileIndex).FileOp : _
                     CALL FilePutRec(K6,FileLof&(K6,119) + 1,119,FileList) : _
                     TT$ = FWork(K2).FName + GetLine$(63) : _
                     CALL LogTT : _
                     K0 = BiSearch(3,0,FWork(K2).FName)
      CALL FileGetRec(Handle(22),K0,22,FileIDX)
      CALL FileGetRec(K6,FileIDX.FRec,119,FileList)
      '
      ' File area's don't match?  Fix this by giving it it's current file area.
      '
      IF FileList.FArea <> FileIndex _
         THEN FileList.FArea = FileIndex : _
              FileIDX.FArea = FileIndex : _
              CALL FilePutRec(K6,FileIDX.FRec,119,FileList) : _
              CALL FilePutRec(Handle(22),K0,22,FileIDX) : _
              TT$ = GetLine$(341) + FileList.FName : _
              CALL LogTT
      IF BitTest(p,1) THEN CALL DispDescLine(- K2,Short$(767)) _
                      ELSE CALL DispDescLine(K2,Short$(767))
      IF BitTest(p,3) THEN K2 = K2 - 1 _
                      ELSE K2 = K2 + 1
    LOOP UNTIL K2 = K3 OR K2 = 0 OR TGot > 0
    SELECT CASE TGot
      CASE 33  ' '!'
           IF BitTest(Toggles(1),13) OR User.UserName = FileBases(FileIndex).FileOp _
              THEN CALL BitToggle(p,1) : _
                   K4 = -1
      CASE 45  ' '-'
           CALL BitToggle(p,3)
           K4 = -1
      CASE 46  ' '.'
           CALL BitToggle(p,2)
    END SELECT
    CALL FileClose(K6)
  LOOP UNTIL K2 = K3 OR K2 = 0 OR K4 = 0
  IF TGot > 0 THEN EXIT SUB
  IF (K2 = K3 OR K2 = 0) AND BitTest(FileBases(FileIndex).Attr,3) _
     AND BitTest(User.Toggles,7) _
     THEN TT = 339 + (FileIndex = 1) : _
          CALL SendTT : _
          IF TGot > 0 THEN EXIT SUB
  CALL DispCRLF
  CALL Paused
  CALL DisplayReviews(-1)

END SUB
        '
        '* * * *

