' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' This collection contains the following related routines:
'   MsgBaseLocker
'   UnLockedList





        '* * * * * *
        ' This routine will stop or allow access to a message base for
        ' a single user or all users.
        '
        ' p   0 to unlock message base(s).
        '    -1 to lock message bases(s).
        '    anything else causes trouble.
        '
        ' Date last checked for perfection: Aug 31 1992
        '
SUB MsgBaseLocker (p)

  K = Val2&(Menu.ShouldDo) - 1
  IF User.UserName <> MsgBases(K).MsgOp THEN EXIT SUB
  TT = 51 + p
  K1 = GetYNTT
  CALL DispCRLF
  SELECT CASE K1
    CASE 0
         TT = 817 + p
         CALL GetUserNameTT(K$,K2)
         CALL DispCRLF
         IF K2 < 1 THEN EXIT SUB
  END SELECT
  SELECT CASE K
    CASE 0
         FOR K = 1 TO BasesSize
           SWork$(K) = MsgBases(K).Title
         NEXT
         SWork$(K) = Null$
         TT = 819 + p
         CALL MenuSystemTT
         IF TGot = 0 THEN EXIT SUB
         IF MsgBases(TGot).MsgOp <> User.UserName THEN TT = 703 : _
                                                       CALL SendTT : _
                                                       EXIT SUB
         K = TGot
  END SELECT
  K4 = FileOpen(FileNames$(3))
  K0$ = MKL$(p)
  K0 = LEN(UserMsgInfo$)
  IF K1 <> 0 THEN K2 = FileLof&(K4,K0) : _
                  K1 = 1 _
             ELSE K1 = K2
  IF K2 = BiSearch(3,0,User.UserName) THEN MID$(UserMsgInfo$,K * 4 + 1,4) = K0$
  FOR K3 = K1 TO K2 
    CALL FilePutSLoc(K4,1& * (K3 - 1) * K0 + K * 4,K0$)
  NEXT
  CALL FileClose(K4)
  TT = 4
  CALL SendTT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine displays all the users that have access to a
        ' locked message base.
        '
        ' Date last checked for perfection: Aug 31 1992
        '
SUB UnLockedList

  K = Val2&(Menu.ShouldDo) - 1
  TT = 642
  CALL SendTT
  K2 = FileOpen(FileNames$(1))
  K3 = FileOpen(FileNames$(3))
  K0 = LEN(UserMsgInfo$)
  FOR K1 = 1 TO FileLof&(Handle(21),32)
    CALL FileGetRec(Handle(21),K1,32,UserIDX)
    CALL FileGetLoc(K3,1& * (UserIDX.RecNum - 1) * K0 + K * 4,4,K&)
    IF K& <> -1 THEN CALL FileGetRec(K2,UserIDX.RecNum,384,AnyUser) : _
                     TT$ = Short$(590) + NCR$(AnyUser.UserName) + C1310$ : _
                     CALL SendTT : _
                     IF TGot > 0 THEN EXIT FOR
  NEXT
  CALL FileClose(K2)
  CALL FileClose(K3)
  CALL Paused

END SUB
        '
        '* * * *

