' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This is the Goodbye/logout subroutine.  End of session
        ' handling.
        '
        ' Date last checked for perfection: Sep 14 1992
        '
SUB LogOut

  CALL HangUp
  SysopNote$ = Null$                               'Clear CHAT note.
  SELECT CASE RTRIM$(User.UserName)
    CASE IS <> Null$
         '
         ' Update the log file.
         '
         IF LEN(RTRIM$(User.CityState)) > 0 _
            THEN TT$ = Short$(136) + NCR$(User.CityState) _
            ELSE TT$ = Null$
         TT$ = IntToDate3$(LogonDate) + C32$ + NCR$(User.UserName) + _
               TT$ + Short$(137) + RightTime$(LogonTime$) + _
               GetLine$(383) + RightTime$(Null$) + Short$(892) + _
               Connect$ + Short$(580)
         CALL LogTT
         '
         ' Update user record.
         '
         User.Connect = AscChr$(StrSrch(1,Short$(893),LEFT$(Connect$,2) + Short$(379)) \ 2 + 49)
         User.HiFilePtr = Settings.HiFilePtr
         User.LastDateOn = LogonDate
         User.Attempts = C0$
         K = FileOpen(FileNames$(1))
         kz = BiSearch(5,0,User.UserName)
         CALL FilePutRec(K,kz,384,User)
         CALL FileClose(K)
         K = FileOpen(FileNames$(3))
         CALL FilePutSLoc(K,1& * (kz - 1) * LEN(UserMsgInfo$),UserMsgInfo$)
         CALL FileClose(K)
         '
         ' Close the Chat Trap or Trap All files if need be.
         '
         IF BitTest(User.Attr,6) OR BitTest(Toggles(2),8) _
            THEN TT$ = C1310$ + Short$(894) + NCR$(User.UserName) + _
                       GetLine$(384) + TIME$ + Short$(895) + C1310$ : _
                 IF DriveSpc&(FileNames$(51)) > Settings.MinSpace _
                    THEN CALL FilePutSEnd(Handle(1),TT$)
         IF BitTest(User.Attr,6) AND NOT BitTest(Toggles(2),8) _
            THEN CALL FileClose(Handle(1))
         '
         ' Update statistical summary log.
         '
         CALL UpdateSumLog(1)
         '
         ' Update Files.IDX/remove EXTRACT.ZIP.
         '
         K0 = FileOpen(FileNames$(4))
         FOR K = 1 TO FileLof&(Handle(22),22)
           CALL FileGetRec(Handle(22),K,22,FileIDX)
           IF BitTest(FileIDX.Attr,8) _
              THEN CALL FileGetRec(K0,FileIDX.FRec,119,FileList) : _
                   CALL KillFile(RTRIM$(FileBases(FileList.FArea).Path) + FileList.FName) : _
                   CALL BitSet(FileList.Attr,1) : _
                   CALL FilePutRec(K0,FileIDX.FRec,119,FileList) : _
                   FileIDX.FName = GetLine$(184) : _
                   CALL FilePutRec(Handle(22),K,22,FileIDX) : _
                   CALL FileSort(Handle(22),22) : _
                   CALL FilePutLoc(Handle(22),FileLof&(Handle(22),1) - 22,0,FileIDX)
         NEXT
         CALL FileClose(K0)
         '
         ' Update hourly graph data.
         '
         K1 = FileOpen(FileNames$(13))
         CALL FileGetLoc(K1,2310&,2,K3)       'Get last date updated.
         '
         ' If we've started a new day (caller was first call after midnight)
         ' then shift the hourly info over 24 hours, and clean the slate, else
         ' get the hourly info for the last 24 hours.
         '
         IF K3 <> LogonDate THEN K$ = SPACE$(168) : _
                                 CALL FileGetSLoc(K1,2320&,K$) : _
                                 CALL FilePutSLoc(K1,2344&,K$) : _
                                 K$ = STRING$(24,0) _
                            ELSE K$ = SPACE$(24) : _
                                 CALL FileGetSLoc(K1,2320&,K$)
         K0 = ElapsedTime(LogonTime$,K)       'Calculate call length.
         K = Val2&(LEFT$(LogonTime$,2)) + 1   'Get starting hour.
         K0 = K0 + AscVal(MID$(K$,K,1))       'Want to add to whats there.
         WHILE K0 > 60                        'Go below 1 hour.
           MID$(K$,K,1) = AscChr$(60)         'Store an hour.
           K0 = K0 - 60                       'Reduce by 60 minutes.
           K = K + 1                          'Next storage hour.
           IF K = 25 THEN CALL FilePutSLoc(K1,2320&,K$) : _
                          K$ = SPACE$(168) : _
                          CALL FileGetSLoc(K1,2320&,K$) : _
                          CALL FilePutSLoc(K1,2344&,K$) : _
                          K = 1 : _
                          K$ = STRING$(24,0)  'Next day processing.
         WEND
         MID$(K$,K,1) = AscChr$(K0)           'Residual time.
         CALL FilePutSLoc(K1,2320&,K$)         'Put back the last 24 hours.
         '
         ' Update RESULTS with the current date.  If the first call after
         ' midnight, update the summary log.
         '
         K2 = DateToInt(DATE$)
         IF K3 <> K2 _
            THEN CALL FilePutLoc(K1,2310&,2,K2) : _
                 K2 = FileOpen(FileNames$(50)) : _
                 CALL FilePutSEnd(K2,Short$(412) + IntToDate3$(LogonDate) + _
                       Form$(1034,STR$(Settings.HiFilePtr)) + C1310$) : _
                 CALL FileClose(K2)
         CALL FileClose(K1)
    CASE ELSE
         TT$ = GetLine$(550) + RightTime$(Null$) + Short$(139) + TIME$ + _
               Short$(896) + GetLine$(551) + Connect$ + Short$(153)
         CALL LogTT
  END SELECT
  User.UserName = Null$

END SUB
        '
        '* * * *

