' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine initializes a new FileList record and/or
        ' initializes and merges a new Files.IDX entry.
        '
        ' p   1 to just do a FileList entry
        '     2 to just do a Files.IDX entry
        '     3 to do both a FileList entry and a Files.IDX entry
        '
        ' p0  attr field to use (FileList only).
        '
        ' p1  LDCount value to use (FileList only).
        '
        ' p2  file handle to use (Files.IDX only).
        '
        ' The filename and size are gotten from FFile.
        '
        ' Description handling, and writing this record, are handled
        ' by the calling routine.
        '
        ' Date last checked for perfection: Sep 22 1992
        '
SUB CreateFileStuff (p,p0,p1,p2)

  SELECT CASE p
    CASE 1, 3
         Settings.HiFilePtr = Settings.HiFilePtr + 1
         FileList.FArea = FileIndex
         FileList.HiFilePtr = Settings.HiFilePtr
         FileList.LDCount = p1
         FileList.FName = FFile.FName
         FileList.FDesc = Null$
         FileList.FSize = FFile.FSize
         FileList.UserName = User.UserName
         FileList.FileType = 0
         FileList.Password = 0
         FileList.Downloaded = 0
         FileList.LastDLed = 0
         FileList.DateULed = LogonDate
         FileList.Attr = p0
         FileList.Group = 0
  END SELECT
  SELECT CASE p
    CASE 2, 3
         FileIDX.FName = FFile.FName
         FileIDX.FSize = FFile.FSize
         FileIDX.FRec = FileLof&(p2,119) + 1
         FileIDX.Attr = p0
         FileIDX.FArea = FileIndex
         CALL FilePutRec(Handle(22),FileLof&(Handle(22),22) + 1,22,FileIDX)
         CALL FileSort(Handle(22),22)
  END SELECT

END SUB
        '
        '* * * *




