' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine displays the contents of the file areas in a
        ' paged method.
        '
        ' p  What to do:  0 ask user which to do
        '                 1 to do all files
        '                 2 to do only new files
        '    If p = 0 then p will get changed.
        '
        ' Date last checked for perfection: Nov 6 1992
        '
SUB PagedFileSystem (p)

  SELECT CASE p
    CASE 0
         TT = 764
         CALL SendTT
         IF TGot < 1 THEN CALL TGet(Short$(1029) + C13$)
         IF TGot < 65 THEN EXIT SUB
         p = 2 + (TGot = 65)
         TT = 764 + p
         CALL SendTT
  END SELECT
  IF p = 2 THEN TT = 767 : _
                CALL SendTT
  FileIndex = 32767
  CALL NextArea(1)
  IF FileIndex = 32767 THEN EXIT SUB         'No accessible file areas.
  K = FileOpen(FileNames$(4))
  K0 = 1
  K1 = 1
  K13 = 1
  K2$ = Short$(1030) + C1$ + Short$(153)
  K$ = Null$
  DO
    '
    ' Don't assume anything, since K0 may have been changed.
    '
    FileIndex = 32767
    FOR K2 = 1 TO K0
      K3 = FileIndex
      CALL NextArea(1)
      IF FileIndex <= K3 AND K3 <> 32767 THEN EXIT FOR
    NEXT
    IF FileIndex <= K3 AND K3 <> 32767 THEN EXIT DO
    K2 = 0
    IF p = 2 AND FileBases(FileIndex).HiFilePtr <= User.HiFilePtr _
       THEN K2 = 2 _
       ELSE IF FindF(RTRIM$(FileBases(FileIndex).Path) + Short$(760),FWork(1)) = 0 _
               THEN K2 = p
    SELECT CASE K2
      CASE 2 : TT$ = BlockText2(768) + RTRIM$(FileBases(FileIndex).Title) + _
                     Short$(868) + LTRIM$(STR$(K0)) + C1310$
               CALL SendTT
      CASE 0
           TT$ = Short$(868) + LTRIM$(STR$(K0))
           TT$ = Short$(930) + _
                 Form1$(79 - StripLen(TT$),RTRIM$(FileBases(FileIndex).Title)) + _
                 TT$ + Short$(1006) + STRING$(79,205) + C1310$
           CALL SendTT
           SELECT CASE TGot
             CASE IS < 1
                  CALL LoadDirContents(K3)
                  '
                  ' Output the names with their descriptions.  Await options.
                  '
                  K5 = 0
                  K6 = 0
                  K7 = 0
                  DO
                    K5 = K5 + 1
                    TGot = 0
                    '
                    ' Locate all the files in the directory.  An alternative
                    ' method is to scan the entire FILES.IDX file looking for
                    ' matching .FArea's.
                    '
                    ' BiSearch est: NLogN wher N is number of files in dir.
                    ' FILES.IDX est: total number of entries.
                    ' BiSearch offers the advantage of sorted entries.
                    ' Files.idx offers the advantage of disk buffered speed.
                    '
                    ' 3 dirs with 100 files each (300 total):
                    ' Bisearch = 600 reads of files.idx per dir.
                    ' Files.idx = 300 reads of files.idx per dir.
                    ' 10 dirs with 100 files each (1000 total):
                    ' Bisearch = 600 reads of files.idx per dir.
                    ' Files.idx = 1000 reads of files.idx per dir.
                    ' 20 dirs with 100 files each (2000 total):
                    ' Bisearch = 600 reads of files.idx per dir.
                    ' Files.idx = 2000 reads of files.idx per dir.
                    '
                    ' So, Bisearch method is better as number of files increase.
                    ' Therefore that is the method used.
                    '
                    SELECT CASE BiSearch(3,0,FWork(K5).FName)
                      CASE IS > 0
                           CALL FileGetRec(K,FileIDX.FRec,119,FileList)
                           IF (p = 1) _
                              OR (p = 2 AND FileList.HiFilePtr > User.HiFilePtr) _
                              THEN CALL DispDescLine(K5 * K1,K2$) : _
                                   K6 = K6 + 1 : _
                                   IF K1 < 0 THEN K6 = K6 + 2
                           IF TGot = 13 THEN TGot = 78
                    END SELECT
                    K8 = 0
                    IF (K6 = 18 AND K13 > 0) OR K5 = K3 OR TGot > 0 THEN K8 = 1
                    SELECT CASE K8
                      CASE 1
                           K6 = 0
                           K9 = 0
                           DO
                             IF TGot < 1 THEN TT = 769 : _
                                              CALL GetNumPlusTT(Short$(1031) + C1$)
                             K10 = TGot
                             IF K10 = 1 THEN K0$ = TGot$
                             K8 = StrSrch1(Short$(1032),K10)
                             IF K8 > 0 THEN TT = 773 + K8 : _
                                            CALL SendTT
                             SELECT CASE K10
                               CASE 63
                               CASE 1
                                    TGot$ = K0$
                                    K12 = FileIndex
                                    IF Levels(UserSL).SecLevel >= Settings.BiSL _
                                       OR AscVal(TGot$) = 90 _
                                       THEN CALL Upload(1)
                                    IF FileIndex <> K12 THEN K0 = 1 : _
                                                             K2 = -1
                               CASE 65, 66 : CALL DLBatchStuff(K10,K$)
                               CASE 68
                                    K8 = -1
                                    CALL DLStuff(0,K$,K&)
                                    IF LEN(K$) > 0 _
                                       THEN TT = 773 : _
                                            IF NOT GetYNTT _
                                               THEN CALL DispCRLF _
                                               ELSE CALL DLBatchSTuff(4,K$) : _
                                                    K8 = 0 : _
                                                    IF TGot = 1000 _
                                                       THEN CALL ShellDownload(0)
                                    IF K8 THEN CALL DLStuff(1,K$,K&) : _
                                               IF TGot = 1000 _
                                                  THEN CALL ShellDownload(0)
                               CASE 69
                                    K1 = - K1
                                    TT = 771 + (K1 > 0)
                                    CALL SendTT
                               CASE 78 : K2 = 1
                               CASE 80 : K0 = K0 - 1
                                         K2 = -1
                               CASE 81 : FileIndex = 32767
                                         K2 = -2
                               CASE 82 : K5 = K7
                                         K9 = 1
                               CASE 83 : CALL DisplayReviews(0)
                               CASE 85 : K10 = FileIndex
                                         CALL Upload(1)
                                         IF FileIndex <> K10 THEN K0 = 1 : _
                                                                  K2 = -1
                               CASE 87
                                    K8 = -1
                                    CALL GetFileName(K0$,K8)
                                    IF K8 > 0 THEN CALL Archiver(K0$)
                               CASE 67 : K13 = - K13
                                         IF K13 < 0 THEN K9 = 1
                               CASE ELSE
                                    K8 = Val2&(TGot$)
                                    IF K8 > 0 THEN K0 = K8 : _
                                                   K2 = -1 _
                                              ELSE K9 = 1 : _
                                                   IF K5 = K3 _
                                                      THEN K2 = 1 _
                                                      ELSE CALL DispCRLF
                                    K7 = K5
                             END SELECT
                             CALL DispCRLF
                           LOOP UNTIL K9 = 1 OR K2 <> 0
                    END SELECT
                  LOOP UNTIL NoCarrier OR K5 = K3 OR K2 <> 0
             CASE ELSE : K2 = 1
           END SELECT
    END SELECT
    IF K2 > 0 THEN K0 = K0 + 1
  LOOP UNTIL NoCarrier OR K2 = -2
  CALL FileClose(K)
  IF K2 <> -2 THEN TT = 593 : _
                   CALL SendTT
  IF LEN(K$) > 0 THEN CALL DLBatchStuff(5,K$) : _
                      IF TGot = 1000 THEN CALL ShellDownload(0)
  IF BitTest(Toggles(2),7) THEN CALL DispRequests
 
END SUB
        '
        '* * * *

