' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.





        '* * * * * *
        ' This routine displays a screen summarizing how the user
        ' compares with the averages of the users in the other SL
        ' ranges.
        '
        ' p  1 if we're looking at someone else's stats.
        '    anything else if we're looking at the user's stats.
        '
        ' The average of the SL range to which the user belongs has
        ' the user's own stats subtracted from the totals before
        ' displaying.
        '
        ' The totals are distorted slightly: as the totals represent
        ' the last time 'update stats' was run, and the user's record
        ' represents current values--this is only really noticable
        ' when the SL range has only one user (such as the sysop
        ' range).
        '
        ' Date last checked for perfection: Sep 3 1992
        '
SUB ProfileSLs (p)

  TT$ = BlockText2(439) + Short$(106 + (p = 1)) + BlockText2(467)
  CALL SendTT
  IF TGot > 0 THEN EXIT SUB
  K2 = FileOpen(FileNames$(13))
  K4& = 2510 + Settings.StatsSize * 34 * 12
  FOR K0 = 1 TO LevelsSize
    K4& = K4& + 16
    CALL FileGetLoc(K2,K4& + 8,4,K0&)                         'Total posts/SL.
    CALL FileGetLoc(K2,K4& + 12,4,K&)                         'Total users/SL.
    IF MappedSL(AnyUser.SecLevel) = K0 THEN K1 = -1 _
                                       ELSE K1 = 0
    IF K1 THEN K& = K& - 1 : _
               K0& = K0& - AnyUser.MsgsPosted - AnyUser.FMsgsPosted - AnyUser.EMsgsPosted
    TT$ = Form2$(9,K&)
    IF K& = 0 THEN K& = 1
    TT$ = Form2$(10,K0& \ K&) + TT$
    CALL FileGetLoc(K2,K4& + 108,4,K0&)                       'Total UL bytes/SL.
    CALL FileGetLoc(K2,K4& + 112,4,K1&)                       'Total uploads/SL.
    CALL FileGetLoc(K2,K4& + 116,4,K2&)                       'Total logons/SL.
    IF K1 THEN K2& = K2& - AnyUser.Logons : _
               K1& = K1& - AnyUser.Uplds : _
               K0& = K0& - AnyUser.ULBytes
    TT$ = Form2$(15,K0& \ K&) + Form2$(7,K1& \ K&) + Form2$(10,K2& \ K&) + TT$
    CALL FileGetLoc(K2,K4&,4,K0&)                             'Total DL bytes/SL.
    CALL FileGetLoc(K2,K4& + 4,4,K1&)                         'Total downloads/SL.
    IF K1 THEN K1& = K1& - AnyUser.Dnlds : _
               K0& = K0& - AnyUser.DLBytes
    TT$ = Short$(108) + Form$(502,STR$(Levels(K0).SecLevel)) + _
          Form2$(15,K0& \ K&) + Form2$(7,K1& \ K&) + TT$ + C1310$
    SELECT CASE K1
      CASE -1
           K0& = AnyUser.Dnlds
           K1& = AnyUser.Uplds
           K2& = AnyUser.Logons
           K3& = AnyUser.MsgsPosted + AnyUser.FMsgsPosted + AnyUser.EMsgsPosted
           TT$ = TT$ + Short$(97) + Form$(502,STR$(AnyUser.SecLevel)) + _
                 Form2$(15,AnyUser.DLBytes) + Form2$(7,K0&) + _
                 Form2$(15,AnyUser.ULBytes) + Form2$(7,K1&) + _
                 Form2$(10,K2&) + Form2$(10,K3&) + Short$(110 + (p = 1))
    END SELECT
    CALL SendTT
    IF TGot > 0 THEN EXIT FOR
  NEXT
  CALL FileClose(K2)
  CALL Paused

END SUB
        '
        '* * * *

