' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine searches MsgPtr() for a variety of information
        ' and returns it.
        '
        ' p   returns with the array location of the first message in
        '     that base.
        '
        ' p0  returns with the array location of the last message in
        '     that base.
        '
        ' p1  returns with the array location of the first message in
        '     that base that is new to the user.
        '
        ' p2  returns with the array location of the first message in
        '     that base which the user either sent or received.
        '
        ' p3  returns with the total number of messages in that base
        '     which are new to the user.
        '
        ' p4  returns with the array location of the first new message
        '     TO: the user.
        '
        ' BaseIndex is relied upon for which message base info to
        ' return.
        '
        ' This routine can be slow under the right circumstances: such
        ' as reseting the sysop's last-message-read to 1, with 100+
        ' messages to the sysop in the Private Area.  But usually it's
        ' really fast, and will be made faster with assembly in the
        ' future.
        '
        ' Date last checked for perfection: Sep 19 1992
        '
SUB ReturnMsgInfo (p,p0,p1,p2,p3,p4)

  p = -1 : p0 = -1 : p1 = -1 : p2 = -1 : p3 = 0 : p4 = -1
  K& = CVL(MID$(UserMsgInfo$,BaseIndex * 4 + 1,4))
  K6 = StrCkSum(User.UserName)
  FOR K5 = 0 TO ActiveMessages
    SELECT CASE MsgPtr(K5).MsgBase
      CASE BaseIndex
           IF p = -1 THEN p = K5
           p0 = K5
           IF p1 <> -1 THEN p3 = p3 + 1 _
                       ELSE IF MsgPtr(K5).MsgNum > K& THEN p1 = K5 : _
                                                           p3 = 1
           IF p1 <> -1 AND p4 = -1 AND K6 = MsgPtr(K5).MsgTo _
              THEN K$ = SPACE$(30) : _
                   CALL FileGetSLoc(Handle(3),MsgPtr(K5).MsgLoc + 35,K$) : _
                   IF User.UserName = K$ THEN p4 = K5
           IF p2 = -1 AND (K6 = MsgPtr(K5).MsgTo OR K6 = MsgPtr(K5).MsgFrom) _
              THEN K$ = SPACE$(60) : _
                   CALL FileGetSLoc(Handle(3),MsgPtr(K5).MsgLoc + 5,K$) : _
                   IF User.UserName = LEFT$(K$,30) _
                      OR User.UserName = RIGHT$(K$,30) THEN p2 = K5
    END SELECT
  NEXT

END SUB
        '
        '* * * *

