' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.




        '* * * * * *
        ' This routine updates the data used for the statistics
        ' screens and fixes the voting numbers in RESULTS (for when
        ' you remove a user who voted, repairs the voting numbers in
        ' RESULTS).
        '
        ' Vote weights are applied to the options, not to the number
        ' of users who voted for that option.
        '
        ' Date last checked for perfection: Sep 10 1992
        '
SUB StatsCalc

  FOR K = 0 TO Settings.MaxFilesInDir
    FWork(K).FSize = 0
    Work(K) = 0
  NEXT
  K$ = Null$
  K6 = FileOpen(FileNames$(1))
  K7 = FileOpen(FileNames$(13))
  K0& = 2514
  '
  ' 12 stats screens, 1 total stats screen, and 1 for voting update.
  '
  FOR K = 0 TO 13
    TT = 183
    CALL SendTT
    CALL ShowTheGauge(14,K + 1)
    FOR K0 = 2 TO FileLof&(K6,384)
      CALL FileGetRec(K6,K0,384,AnyUser)
      SELECT CASE BitTest(AnyUser.Attr,1)
        CASE 0
             SELECT CASE K                        
               CASE 0 TO 11
                    SELECT CASE K
                      CASE 0, 6  : K& = AnyUser.DLBytes
                      CASE 1, 7  : K& = AnyUser.Dnlds
                      CASE 2, 8  : K& = AnyUser.ULBytes
                      CASE 3, 9  : K& = AnyUser.Uplds
                      CASE 4, 10 : K& = AnyUser.Logons
                      CASE 5, 11 : K& = AnyUser.MsgsPosted + AnyUser.FMsgsPosted + _
                                        AnyUser.EMsgsPosted
                    END SELECT
                    K2 = K0
                    FOR K1 = 0 TO Settings.StatsSize - 1
                      SELECT CASE K
                        CASE 0 TO 5
                             IF K& > FWork(K1).FSize _
                                THEN SWAP K&, FWork(K1).FSize : _
                                     SWAP K2, Work(K1)
                        CASE 6 TO 11
                             IF K& < FWork(K1).FSize AND K& <> 0 _
                                AND AnyUser.Logons >= Settings.WorstLogons _
                                AND AnyUser.SecLevel >= Settings.WorstSL _
                                THEN SWAP K&, FWork(K1).FSize : _
                                     SWAP K2, Work(K1)
                      END SELECT
                    NEXT
               CASE 12
                    '
                    'FWork(0).FSize = total DL bytes
                    'FWork(1).FSize = total DL files
                    'FWork(2).FSize = total messages posted
                    'FWork(3...2 + LevelsSize * 4) = bytes, files, msgs, number
                    '                                for each SL
                    'FWork(3 + LevelsSize * 4) = total UL bytes
                    'FWork(4 + LevelsSize * 4) = total UL files
                    'FWork(5 + LevelsSize * 4) = total logons
                    'FWork(6 + LevelsSize * 4...5 + LevelsSize * 8) = bytes, files,
                    '                                                 msgs, number
                    '                                                 for each SL
                    '
                    K2 = MappedSL(AnyUser.SecLevel)
                    FOR K1 = 0 TO 13
                      SELECT CASE K1
                        CASE 0    : K& = 0       'old total DL bytes field.
                        CASE 1, 4 : K& = AnyUser.Dnlds
                        CASE 2, 5 : K& = AnyUser.MsgsPosted + _
                                         AnyUser.EMsgsPosted + AnyUser.FMsgsPosted
                        CASE 3    : K& = AnyUser.DLBytes
                        CASE 6, 13 : K& = 1
                        CASE 7, 10 : K& = AnyUser.ULBytes
                        CASE 8, 11 : K& = AnyUser.Uplds
                        CASE 9, 12 : K& = AnyUser.Logons
                      END SELECT
                      SELECT CASE K1
                        CASE 0 TO 2   : K3 = K1
                        CASE 3 TO 6   : K3 = K2 * 4 + K1 - 4
                        CASE 7 TO 9   : K3 = LevelsSize * 4 + K1 - 4
                        CASE 10 TO 13 : K3 = LevelsSize * 4 + K2 * 4 + K1 - 8
                        CASE ELSE
                      END SELECT
                      FWork(K3).FSize = FWork(K3).FSize + K&
                    NEXT
                    K0$ = LTRIM$(STR$(AnyUser.DLBytes))
                    IF LEN(K0$) > LEN(K$) THEN SWAP K0$, K$
                    K3 = LEN(K$)
                    K0$ = Form$(K3 * 100 + 2,K0$)           'Make same width.
                    K2 = 0                                  'Carry = 0.
                    FOR K1 = K3 TO 1 STEP -1
                      K3 = Val2&(MID$(K$,K1,1)) + Val2&(MID$(K0$,K1,1)) + K2
                      K2 = K3 \ 10                          'Whats left = carry.
                      MID$(K$,K1,1) = RIGHT$(STR$(K3),1)
                    NEXT
               CASE 13
                    SELECT CASE AnyUser.SecLevel
                      CASE IS >= Settings.CanVoteSL
                           K5 = Levels(MappedSL(AnyUser.SecLevel)).VoteWeight
                           FOR K1 = 1 TO 100
                             K2 = AscVal(MID$(AnyUser.Votes,K1,1))
                             IF K2 > 0 THEN K1& = K1 * 18 - 17 + K2 * 2 - 1 : _
                                            CALL FileGetLoc(K7,K1&,2,K3) : _
                                            CALL FilePutLoc(K7,K1&,2,K3 + K5) : _
                                            K1& = K1 * 18 - 18 : _
                                            CALL FileGetLoc(K7,K1&,2,K3) : _
                                            CALL FilePutLoc(K7,K1&,2,K3 + 1)
                           NEXT
                    END SELECT
             END SELECT
      END SELECT
    NEXT
    SELECT CASE K
      CASE 0 TO 11
           '
           ' Store our rankings screens.
           '
           K0$ = SPACE$(30)
           FOR K0 = 0 TO Settings.StatsSize - 1
             IF Work(K0) = 0 THEN Work(K0) = 1
             CALL FileGetSLoc(K6,(Work(K0) - 1) * 384&,K0$)
             CALL FilePutSLoc(K7,K0&,K0$)
             CALL FilePutLoc(K7,K0& + 30,4,FWork(K0).FSize)
             K0& = K0& + 34
             Work(K0) = 0
             IF K < 5 OR K = 11 THEN FWork(K0).FSize = 0 _
                                ELSE FWork(K0).FSize = 2100000000&
           NEXT
      CASE 12
           '
           ' Store our totals data.
           '
           FOR K0 = 0 TO 5 + LevelsSize * 8
             CALL FilePutLoc(K7,K0&,4,FWork(K0).FSize)
             K0& = K0& + 4
           NEXT
           '
           ' Store our total downloads.
           '
           K$ = Form$(1501,K$)
           CALL FilePutSLoc(K7,2285&,K$)
           '
           ' Zero out our current voting results.  (100 voting questions
           ' times 20 bytes per question).
           '
           K$ = STRING$(2000,0)
           CALL FilePutSLoc(K7,0&,K$)
    END SELECT
  NEXT
  CALL FileClose(K6)
  CALL FileClose(K7)

END SUB
        '
        '* * * *

