; Copyright (c) 1991-1992, John David Rohner.  All rights reserved.

;
; This routine returns with the time of an HH:MM:SS string in integer form.
;
; Usage:  Result% = TimeToInt(Input$)
; Declare:  DECLARE FUNCTION TimeToInt% (Input$)
;
; Where Result% is the time in integer form, and Input$ is the time to use
; in the form "HH:MM:SS".
;
; All 8 characters must be included for the time, anything less than 8, and
; you'll get random results.
;

.Model Medium, Basic
.Code

            PUBLIC  TimeToInt         ;Make this routine available to LINK.

TimeToInt   proc    far               ;Beginning of routine.

            push    bp
            mov     bp,sp
            cld

            mov     si,[bp + 06]      ;Descriptor of Input$.
            lodsw                     ;Get the length,
            xchg    di,ax             ; into DI.
            lodsw                     ;Get the address,
            xchg    si,ax             ; and put it in SI.
            mov     cx,0A06H
            mov     bx,3000H

            lodsb
            sub     al,bh
            mul     ch
            mov     dl,al
            lodsb
            sub     al,bh
            add     dl,al
            shl     dx,cl

            inc     si

            lodsb
            sub     al,bh
            mul     ch
            or      dl,al
            lodsb
            sub     al,bh
            add     dl,al
            dec     cx
            shl     dx,cl

            inc     si

            lodsb
            sub     al,bh
            mul     ch
            mov     bl,al
            lodsb
            sub     al,bh
            add     al,bl
            shr     ax,1
            or      ax,dx

      Done: pop     bp
            ret     2                 ;Pop-return past our input parameter.

TimeToInt   endp                      ;End of routine.

End

