' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
' This file contains:
'   Upload2
'   SearchFile



        '* * * * * *
        ' This routine, internal to Upload, handles most of the work.
        '
        ' p   1 for upload with current protocol.  (TGot$ = ZMODEM or
        '       BIMODEM for an auto-detect upload.)
        '     2 for BiModem
        '     3 for Targeted Upload
        '     returns with -1 if no upload was done.
        '
        ' p$  returns with the ShellDos command to use.
        '
        ' p0 p0$ p11$ p1$ p2$  return with the ProcessLog parameters to
        '                    use.
        '
        ' Date last checked for perfection: Sep 18 1992
        '
SUB Upload2 (p,p$,p0,p0$,p11$,p1$,p2$)

  k = p
  p = -1
  IF FileIndex = 32767 THEN EXIT SUB
  '
  ' If the area does not allow uploads, or they do not enough SL, or it's PR
  ' play time, then shift to area 001, and recheck again.
  '
  IF NOT BitTest(FileBases(FileIndex).Attr,4) THEN FileIndex = 1   'No Upld
  IF User.SecLevel < FileBases(FileIndex).ULSL THEN FileIndex = 1  'No SL
  IF BitTest(User.Attr,10) AND NOT BitTest(FileBases(FileIndex).Attr,5) _
     THEN FileIndex = 1                                            'No PRUL
  IF NOT BitTest(FileBases(FileIndex).Attr,4) THEN EXIT SUB        'No Upld
  IF User.SecLevel < FileBases(FileIndex).ULSL THEN EXIT SUB       'No SL
  IF BitTest(User.Attr,10) AND NOT BitTest(FileBases(FileIndex).Attr,5) _
     THEN EXIT SUB                                                 'No PRUL
  CALL DateDMY(LogonDate,K1,K2,K3)
  IF (K1 <> (K1 \ 2) * 2) AND ConnectCPS < Settings.BiDayBaud \ 10 AND k = 1 _
     THEN TT = 484 : _
          CALL SendTT : _
          EXIT SUB
  K$ = Null$
  K& = DriveSpc&(FileBases(1).Path)
  SELECT CASE TGot$
    CASE Short$(225), Short$(187)
         IF K& < Settings.MinULSpace THEN EXIT SUB
    CASE ELSE
         TT = 10107
         CALL SendTT
         TT$ = GetLine$(485) + Commas$(K&) + GetLine$(486)
         IF K& < Settings.BeSureSpace THEN TT$ = TT$ + GetLine$(487)
         TT$ = RTRIM$(Form$(7908,TT$)) + Short$(115)
         K1$ = TT$
         CALL SendTT
         IF K& < Settings.MinULSpace THEN TT = 488 : _
                                          CALL SendTT : _
                                          CALL Paused : _
                                          EXIT SUB
         IF K& < Settings.TargetSpace AND k = 3 _
            THEN TT$ = BlockText2(490) + Commas$(Settings.TargetSpace) + _
                       BlockText2(491) : _
                 CALL SendTT : _
                 CALL Paused : _
                 EXIT SUB
         '
         ' Handle the different user input's for the various upload methods.
         '
         SELECT CASE k
           CASE 1, 2
                IF NOT BitTest(Toggles(1),14) THEN k = 3
                SELECT CASE k
                  CASE 1
                       TT = 492
                       CALL SendTT
                       K1 = 0
                       DO
                         K0 = 1
                         Call SearchFile(K0)
                         IF K0 = 1 OR NoCarrier THEN EXIT SUB
                         IF K0 = -1 THEN K1 = 1
                         TT = 10107
                         CALL SendTT
                         '
                         ' Since SearchFile may take a while to respond
                         ' to a CR/LF, the user may press a lot of them,
                         ' so clear the buffer.
                         '
                         IF K0 = 0 THEN CALL PurgeComIO(CommPort)
                         IF K0 = 0 AND K1 = 0 THEN TT = 494 : _
                                                   CALL SendTT
                         TT = 495
                       LOOP UNTIL NOT GetYNTT
                       IF K0 = 0 AND K1 = 0 THEN EXIT SUB
                       TT = 10107
                       CALL SendTT
                       TT$ = K1$
                  CASE 2 : TT = 496
                END SELECT
                IF k = 3 THEN k = 1
                CALL SendTT
                TT = 498
                CALL SendTT
                CALL TGet(Short$(158) + C13$)
                SELECT CASE TGot
                  CASE 89
                       CALL Wipe(6)
                       TT = 499
                       CALL SendTT
                       FileList.FArea = FileIndex
                       FileList.FDesc = Null$
                       CALL GetDesc(1,Short$(121),Short$(122))
                       K$ = LTRIM$(RTRIM$(FileList.FDesc))
                  CASE ELSE : CALL Wipe(51)
                END SELECT
                IF k = 1 THEN CALL AdjustProtocol(User.Protocol) : _
                              TT$ = Short$(739) + _
                                    RTRIM$(Form$(7908,MID$(TT$,20,34))) : _
                              CALL SendTT
           CASE 3
                CALL DispBlockText(4,Null$)
                DO
                  CALL GetUserNameTT(K$,K1)
                  IF LEN(K$) = 0 THEN EXIT SUB
                  IF K$ = RTRIM$(Settings.Sysop) OR K$ = Short$(652) _
                     THEN TT = 505 : _
                          CALL SendTT : _
                          EXIT SUB
                  IF K1 = 0 THEN TT = 506 : _
                                 CALL SendTT
               LOOP UNTIL K1 > 0
               KKK$ = K$
               CALL DispCRLF
               CALL DispCRLF
         END SELECT
         TT = 503 + (k = 1)
         CALL SendTT
  END SELECT
  '
  ' This section of the routine executes the protocol--no more user entering,
  ' but possibly lots for the system to still do.
  '
  IF BitTest(Toggles6,1) THEN TT$ = C7$ : _
                              CALL AnsiTT
  SELECT CASE k
    CASE 1
         CALL SysopLine(17)
         IF TGot$ <> Short$(255) THEN K0$ = User.Protocol _
                                 ELSE K0$= Short$(627)
         CALL AdjustProtocol(K0$)
         CALL KillFile(MID$(TT$,54,40))
         p$ = ProtocolUp$
         p0 = 1
         p0$ = K$
         p11$ = Null$
         p1$ = TIME$
         p2$ = K0$
    CASE 2
         K0$ = TIME$
         CALL AI(4,Null$,0,0,0,0,0,0,0)                'Exchange for bytes.
         TT$ = Short$(67) + RTRIM$(User.UserName) + STR$(CanDL&) + Short$(318) + _
              STR$(User.Elapsed) + Short$(320) + STR$(User.MinMegs) + _
              Short$(322) + STR$(User.MinCredits) + Short$(323) + _
              STR$(Levels(UserSL).SecLevel) + Short$(324)
         CALL AnsiTT
         '
         ' If the amount of time the user can spend downloading is negative,
         ' then don't let them do it.  This is the final line after they've
         ' persisted in downloading greatly past their limits (both daily time
         ' and ratio).  If they're getting this, they'll need to send up about
         ' 2 megs.  The whole trickery will work faster as daily MinsPerDay is
         ' reduced due to more HST users.
         '
         K1 = DLTime
         IF K1 < 0 THEN TT = 508 : _
                        CALL SendTT : _
                        EXIT SUB
         K2 = User.MinCredits
         CALL AI(5,Null$,0,0,0,0,0,0,0)              'Exchange for time.
         K1 = K1 + User.MinCredits - K2
         CALL AdjustProtocol(Short$(211))
         CALL KillFile(MID$(TT$,54,40))
         IF User.MinCredits < 0 THEN TT$ = STR$(K1) + Short$(325) : _
                                     K2$ = Short$(327) + LTRIM$(STR$(K1)) _
                                ELSE TT$ = GetLine$(522) : _
                                     K2$ = Null$
         CALL AnsiTT
         p$ = ProtocolDn$ + K2$
         p0 = -1
         p0$ = k$
         p11$ = Null$
         p1$ = K0$
         p2$ = Short$(211)
    CASE 3
         TT$ = Short$(67) + User.UserName + Short$(479) + K$
         CALL AnsiTT
         K$ = TIME$
         CALL AdjustProtocol(Short$(211))
         CALL KillFile(MID$(TT$,54,40))
         p$ = ProtocolUp$
         p0 = -1
         p0$ = Null$
         p11$ = KKK$
         p1$ = K$
         p2$ = Short$(211)
  END SELECT
  p = k

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will search the various list files for a word.
        '
        ' p  0 to just do offline lists search.
        '    1 to do offline and on-line lists search.
        '    2 to just do on-line lists search.
        '
        ' p  returns  0 if the search was aborted midway
        '             1 if no search pattern entered
        '            -1 if the search was completed
        '
        ' Date last checked for perfection: Sep 14 1992
        '
SUB SearchFile (p)

  K9 = p
  p = 1
  TT = 153
  K2$ = LineEditTT$(10)
  K = StrSrch1(K2$,46)
  CALL StrXLate(K2$,AlphaTable$)
  K2$ = Form$(16,K2$)
  K3 = LEN(K2$)
  IF K3 < 3 THEN EXIT SUB
  FOR K1 = 1 TO K3
    IF StrSrch1(Short$(172),AscVal(MID$(K2$,K1,1))) > 0 THEN EXIT FOR
  NEXT
  IF K1 > K3 THEN TT = 154 : _
                  CALL SendTT _
             ELSE IF K > 0 THEN TT = 155 : _
                                CALL SendTT
  FOR K = 350 TO 359
    IF K2$ = Short$(K) THEN EXIT FOR
  NEXT
  IF K <= 359 THEN TT = 64 : _
                   CALL SendTT : _
                   EXIT SUB
  p = 0
  TT = 94
  CALL SendTT
  IF TGot > 0 THEN EXIT SUB
  K5 = 0
  SELECT CASE K9
    CASE 0, 1
         K7 = FileOpen(FileNames$(19))
         FOR K = 1 TO FileLof&(K7,138)
           K1$ = SPACE$(138)
           CALL FileGetSLoc(K7,(K - 1) * 138&,K1$)
           SELECT CASE CVI(LEFT$(K1$,2))
             CASE IS < Levels(UserSL).SecLevel
                  TT$ = BlockText2(160) + K2$ + Short$(176) + _
                        RTRIM$(RIGHT$(K1$,72)) + Short$(114)
                  CALL SendTT
                  IF TGot > 0 THEN EXIT FOR
                  K8 = FileOpen(RTRIM$(MID$(K1$,3,64)))
                  K& = 0
                  K0& = FileLof&(K8,1)
                  K$ = SPACE$(4096)
                  WHILE K& < K0& AND TGot < 1
                    IF K& + 4096 > K0& THEN K$ = SPACE$(K0& - K&)
                    CALL FileGetSLoc(K8,K&,K$)
                    K1 = StrSrchR(K$,10)
                    IF K1 = 0 THEN K1 = K0& - K&
                    K0$ = LEFT$(K$,K1)
                    K& = K& + K1
                    CALL StrXLate(K0$,AlphaTable$)
                    K1 = StrSrch(1,K0$,K2$)
                    '
                    'The above needs maximum optimization, below can be slower,
                    'since the search is less likely to be true, and when it
                    'is, there's the 128 byte output buffer.
                    '
                    WHILE K1 > 0 AND TGot < 1
                      K5 = 1         'Could be out of loop--but would be less efficient.
                      K4 = StrSrch(K1 + 1,K$,C13$)
                      SELECT CASE K4
                        CASE IS > 160 : K2 = K4 - 161 + StrSrchR(MID$(K$,K4 - 160,160),10)
                        CASE ELSE : K2 = StrSrchR(LEFT$(K$,K1),10)
                      END SELECT
                      K2 = K2 + 1
                      IF K4 - K2 < 40 _
                         THEN TT$ = MID$(K$,K2,K4 - K2) _
                              ELSE TT$ = MID$(K$,K2 + 38,K4 - K2 - 38) : _
                                   IF AscVal(TT$) <> 32 _
                                      THEN K6 = Crunch(TT$) : _
                                           TT$ = LEFT$(MID$(K$,K2,K4 - K2),38) + _
                                                 LEFT$(TT$,K6) _
                                      ELSE TT$ = LEFT$(MID$(K$,K2,K4 - K2),38) + TT$
                      '
                      'A single unbroken string of 80 characters (no spaces)
                      'will probably not show up (show up only as spaces).
                      'This is too rare for me to bother processing.  But if
                      'you need it (say your lists have long dashed lines to
                      'break it up, or somesuch) then put in a 'IF K1 = 0 THEN
                      'K1 = 80' (and the same for 160) before altering TT$
                      'below (after the StrSrchR's).
                      '
                      IF LEN(TT$) > 80 _
                         THEN K1 = StrSrchR(LEFT$(TT$,80),32) : _
                              TT$ = LEFT$(TT$,K1) + SPACE$(118 - K1) + MID$(TT$,K1 + 1)
                      IF LEN(TT$) > 160 _
                         THEN K1 = StrSrchR(LEFT$(TT$,160),32) : _
                              TT$ = LEFT$(TT$,K1) + SPACE$(198 - K1) + MID$(TT$,K1 + 1)
                      IF LEN(TT$) > 239 THEN TT$ = LEFT$(TT$,239)
                      K1$ = TT$
                      CALL StrXLate(K1$,AlphaTable$)
                      K1 = StrSrch(1,K1$,K2$)
                      WHILE K1 > 0
                        TT$ = LEFT$(TT$,K1 - 1) + Short$(72) + MID$(TT$,K1,K3) + _
                              Short$(97) + MID$(TT$,K1 + K3)
                        K1$ = TT$
                        CALL StrXLate(K1$,AlphaTable$)
                        K1 = StrSrch(K1 + K3 + 11,K1$,K2$)
                      WEND
                      TT$ = Short$(138) + TT$ + C1310$
                      CALL SendTT
                      K1 = StrSrch(K4 + 2,K0$,K2$)
                    WEND
                  WEND
                  CALL FileClose(K8)
                  IF TGot > 0 THEN EXIT FOR
           END SELECT
         NEXT
         CALL FileClose(K7)
         IF TGot > 0 THEN EXIT SUB
  END SELECT
  SELECT CASE K9
    CASE 1, 2
         TT$ = BlockText2(160) + K2$ + BlockText2(125)
         CALL SendTT
         IF TGot > 0 THEN EXIT SUB
         K7 = FileOpen(FileNames$(4))
         FOR K = 1 TO FileLof&(Handle(22),22)
           CALL FileGetRec(Handle(22),K,22,FileIDX)
           IF K9 = 1 OR FAccessAllowed(FileIDX.FArea) _
              THEN CALL FileGetRec(K7,FileIDX.FRec,119,FileList) : _
                   IF StrSrch(1,UCASE$(FileList.FDesc),K2$) > 0 _
                      OR StrSrch(1,UCASE$(FileList.FName),K2$) > 0 _
                      THEN TT$ = Short$(150) + ExpandFileName$(FileList.FName) + _
                                 Short$(97) + Form$(1466,Commas$(FileList.FSize)) + _
                                 C32$ + RTRIM$(FileList.FDesc) + C1310$ : _
                           CALL SendTT : _
                           K5 = 1 : _
                           IF TGot > 0 THEN EXIT FOR
         NEXT
         CALL FileClose(K7)
         IF TGot > 0 THEN EXIT SUB
  END SELECT
  p = -1
  IF K5 = 0 THEN TT = 161 : _
                 CALL SendTT
  CALL Paused

END SUB
        '
        '* * * *


