' $INCLUDE: 'BBS-VAR.BAS'
'
' Copyright (c) 1991-1992, John David Rohner.  All rights reserved.
'
'Various small, little used, overlaid user routines:
'  Chat
'  DoAFreeDownload
'  GetProtocol
'  Profile
'  Reminder
'  SelectMArea
'  SetAllLastReadsHigh




        '* * * * * *
        ' This routine handles the user requesting chat of the sysop
        ' (and then requesting again, and again, and ...)
        '
        ' Date last checked for perfection: Sep 2 1992 
        '
SUB Chat

  IF NOT BitTest(Toggles(1),4) THEN TT = 690 : _
                                    CALL SendTT : _
                                    EXIT SUB
  IF StrSrch(1,SysopNote$,Short$(167)) > 0 AND User.PagedSysop < 32767 _
     AND SumLog.PagedSysop < 32767 _
     THEN User.PagedSysop = User.PagedSysop + 1 : _
          SumLog.PagedSysop = SumLog.PagedSysop + 1 : _
          TT = 689 : _
          CALL SendTT : _
          EXIT SUB
  TT = 691
  K$ = RTRIM$(LineEditTT$(30))
  IF LEN(K$) < 2 THEN EXIT SUB
  User.PagedSysop = User.PagedSysop + 1
  SumLog.PagedSysop = SumLog.PagedSysop + 1
  K1 = 692
  K0$ = UCASE$(K$)
  CALL StrXLate(K0$,AlphaTable$)
  K1$ = UCASE$(Short$(252))
  K3 = WordsCnt(K0$)
  IF K3 < 3 THEN K1 = 604
  FOR K = 1 TO K3
    FOR K0 = 1 TO WordsCnt(K1$)
      IF WordsGet$(K0$,K,K2) = WordsGet$(K1$,K0,K2) THEN K1 = 693
    NEXT
  NEXT
  TT = K1
  CALL SendTT
  IF K1 = 692 THEN SysopNote$ = Short$(167) + K$ + Short$(179) : _
                   TT$ = STRING$(5,7) : _
                   CALL AnsiTT
  TT$ = GetLine$(44) + K$
  CALL LogTT
  IF BitTest(User.Attr,10) AND LEN(LTRIM$(RTRIM$(LEFT$(User.SysopNote,8)))) = 8 _
     THEN K$ = GetLine$(95) + K$ + C1310$ : _
          K = FileOpen(FileNames$(39) + Short$(750) + LEFT$(User.SysopNote,2)) : _
          CALL FilePutSEnd(K,K$) : _
          CALL FileClose(K)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will download the latest JDR_mmyy.  All
        ' download directories are searched when looking for the
        ' file.
        '
        ' p$  is the filename to download.
        '
        ' Date last checked for perfection: Sep 3 1992 
        '
SUB DoAFreeDownload (p$)

  FOR K = 1 to DirsSize
    K0$ = RTRIM$(FileBases(K).Path) + p$
    IF FindF(K0$,FFile) <> 0 THEN EXIT FOR
  NEXT
  IF K > DirsSize THEN EXIT SUB
  CALL KillFile(FileNames$(49))
  CALL SharedWriteEOF(49,0,p$)
  CALL AdjustProtocol(User.Protocol)
  K0$ = MID$(TT$,54,40)
  TT$ = Short$(113) + RTRIM$(Form$(7908,MID$(TT$,20,34))) + BlockText2(335)
  CALL SendTT
  CALL SysopLine(9)
  CALL ShellDos(8,ProtocolDn$)
  CALL Delay
  CALL PurgeComIO(CommPort)
  CALL FileAppendToLog(K0$)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine gets the users protocol choice from the
        ' available protocols.
        '
        ' Date last checked for perfection: Sep 3 1992
        '
SUB GetProtocol

  TT = 10107
  CALL SendTT
  K1 = FileOpen(FileNames$(69))
  K$ = SPACE$(211)
  K = 1
  K& = -211
  FOR K0 = 0 TO FileLof&(K1,211) - 1
    K& = K& + 211
    CALL FileGetSLoc(K1,K&,K$)
    IF Levels(UserSL).SecLevel >= CVI(MID$(K$,2,2)) _
       AND Levels(UserSL).SecLevel <= CVI(MID$(K$,4,2)) _
       AND AscVal(K$) <> 66 AND AscVal(K$) <> 72 _
       THEN SWork$(K) = MID$(K$,20,34) : _
            Work(K) = K0 : _
            K = K + 1
  NEXT
  SWork$(K) = Null$
  TT = 91
  CALL MenuSystemTT
  IF TGot > 0 THEN CALL FileGetSLoc(K1,Work(TGot) * 211&,User.Protocol)
  CALL FileClose(K1)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine handles displaying of information about another
        ' user.
        '
        ' p$  exit's with NULL if no user to look at.
        '
        ' Date last checked for perfection: Sep 3 1992
        '
SUB Profile (p$)

  TT = 438
  CALL GetUserNameTT(K$,K)
  IF K < 1 THEN p$ = Null$ : _
                EXIT SUB
  K0 = FileOpen(FileNames$(1))
  CALL FileGetRec(K0,K,384,AnyUser)
  CALL FileClose(K0)
  K0 = FileOpen(FileNames$(3))
  p$ = UserMsgInfo$
  CALL FileGetSLoc(K0,1& * (K - 1) * LEN(p$),p$)
  CALL FileClose(K0)
  CALL DispFile(FileNames$(66),C13$)
  CALL Paused
  CALL DispFile(FileNames$(67),C13$)
  CALL Paused

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine lets the user make/erase thier UserNote field.
        '
        ' Date last checked for perfection: Sep 3 1992
        '
SUB Reminder

  K$ = RTRIM$(User.UserNote)
  TT$ = BlockText2(546) + K$ + Short$(417)
  K0$ = LineEditTT$(52)
  K = LEN(K$) - LEN(K0$)
  IF K > 0 THEN TT$ = SPACE$(K) : _
                CALL SendTT
  User.UserNote = K0$
  TT = 412
  CALL SendTT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine allows one to select a message area from a
        ' menu of all the areas.
        '
        ' Date last checked for perfection: Nov 24 1992
        '
SUB SelectMArea

  TT = 1
  CALL SendTT
  K = BaseIndex
  BaseIndex = 32767
  CALL NextArea(2)
  IF BaseIndex = 32767 THEN EXIT SUB          'No accessible areas.
  K1 = BaseIndex
  BaseIndex = 32767
  K2 = 0
  DO
    k3 = BaseIndex
    CALL NextArea(2)
    K2 = K2 + 1
    SWork$(K2) = MsgBases(BaseIndex).Title
    Work(K2) = BaseIndex
  LOOP UNTIL BaseIndex = K1 AND K3 <> 32767
  SWork$(K2) = Null$
  TT = 798
  CALL MenuSystemTT
  IF TGot < 1 THEN BaseIndex = K _
              ELSE BaseIndex = Work(TGot)

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will set all new messages a user has unread
        ' (in, and only in, those message areas the user has toggled
        ' on and access to) to read.  Turning formerly new messages
        ' into not-new messages.
        '
        ' Date last checked for perfection: Sep 3 1992
        '
SUB SetAllLastReadsHigh

  TT = 411
  IF NOT GetYNTT THEN EXIT SUB
  K0 = -3
  FOR K = 0 TO BasesSize
    K0 = K0 + 4
    K& = MsgBases(K).NextNumber - 1
    IF CVL(MID$(UserMsgInfo$,K0,4)) < 0 THEN K& = 0
    IF K& > 0 THEN MID$(UserMsgInfo$,K0,4) = MKL$(K&)
  NEXT

END SUB
        '
        '* * * *

